
_USB_CDC_Bytes_Received:

;USB_CDC_Library_NA.mpas,138 :: 		begin
;USB_CDC_Library_NA.mpas,139 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,141 :: 		Result := 0;
	CLRF        R1 
;USB_CDC_Library_NA.mpas,142 :: 		if (BDEP3OUTStat.UOWN = 0)
	BTFSC       _BDEP3OUTStat+0, 7 
	GOTO        L__USB_CDC_Bytes_Received2
;USB_CDC_Library_NA.mpas,143 :: 		then Result := BDEP3OUTCnt;
	MOVF        _BDEP3OUTCnt+0, 0 
	MOVWF       R1 
L__USB_CDC_Bytes_Received2:
;USB_CDC_Library_NA.mpas,145 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,146 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_USB_CDC_Bytes_Received:
	RETURN      0
; end of _USB_CDC_Bytes_Received

_USB_CDC_Read:

;USB_CDC_Library_NA.mpas,151 :: 		begin
;USB_CDC_Library_NA.mpas,152 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,153 :: 		Result := 0; // no bytes read
	CLRF        USB_CDC_Read_local_result+0 
;USB_CDC_Library_NA.mpas,155 :: 		if (BDEP3OUTStat.UOWN = 0) then  // PIC owns the buffer
	BTFSC       _BDEP3OUTStat+0, 7 
	GOTO        L__USB_CDC_Read6
;USB_CDC_Library_NA.mpas,157 :: 		ByteCount := BDEP3OUTCnt; // get bytecount of EP3 out buffer
	MOVF        _BDEP3OUTCnt+0, 0 
	MOVWF       USB_CDC_Read_ByteCount+0 
;USB_CDC_Library_NA.mpas,158 :: 		SrcPtr := ^byte(BDEP3OUTAdr);  // Source data pointer
	MOVF        _BDEP3OUTAdr+0, 0 
	MOVWF       USB_CDC_Read_SrcPtr+0 
	MOVF        _BDEP3OUTAdr+1, 0 
	MOVWF       USB_CDC_Read_SrcPtr+1 
;USB_CDC_Library_NA.mpas,160 :: 		if ByteCount > MaxLen then ByteCount := MaxLen;
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	SUBWF       FARG_USB_CDC_Read_MaxLen+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Read9
	MOVF        FARG_USB_CDC_Read_MaxLen+0, 0 
	MOVWF       USB_CDC_Read_ByteCount+0 
L__USB_CDC_Read9:
;USB_CDC_Library_NA.mpas,161 :: 		Result := ByteCount;
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	MOVWF       USB_CDC_Read_local_result+0 
;USB_CDC_Library_NA.mpas,163 :: 		if ByteCount > 0 then  // non empty
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Read12
;USB_CDC_Library_NA.mpas,165 :: 		memcpy(DstPtr, SrcPtr, ByteCount);
	MOVF        FARG_USB_CDC_Read_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        FARG_USB_CDC_Read_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        USB_CDC_Read_SrcPtr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        USB_CDC_Read_SrcPtr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVF        USB_CDC_Read_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_CDC_Library_NA.mpas,166 :: 		end;
L__USB_CDC_Read12:
;USB_CDC_Library_NA.mpas,169 :: 		BDEP3OUTCnt  := USB_CDC_BULK_OUT_EP_SIZE;// bytecount
	MOVLW       64
	MOVWF       _BDEP3OUTCnt+0 
;USB_CDC_Library_NA.mpas,170 :: 		BDEP3OUTStat := BDEP3OUTStat and USB_DTSMASK; // save only the data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP3OUTStat+0, 1 
;USB_CDC_Library_NA.mpas,171 :: 		BDEP3OUTStat := BDEP3OUTStat xor USB_DTSMASK; // toggle data 0/1
	BTG         _BDEP3OUTStat+0, 6 
;USB_CDC_Library_NA.mpas,172 :: 		BDEP3OUTStat := BDEP3OUTStat OR (USB_DTSEN or USB_USIE);   // set the DTSEN bit and UOWN bit (enable next reception)
	MOVLW       136
	IORWF       _BDEP3OUTStat+0, 1 
;USB_CDC_Library_NA.mpas,173 :: 		end;
L__USB_CDC_Read6:
;USB_CDC_Library_NA.mpas,175 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,176 :: 		end;
	MOVF        USB_CDC_Read_local_result+0, 0 
	MOVWF       R0 
L_end_USB_CDC_Read:
	RETURN      0
; end of _USB_CDC_Read

USB_CDC_Library_NA_SendBulkZeroLenPacket:

;USB_CDC_Library_NA.mpas,179 :: 		begin
;USB_CDC_Library_NA.mpas,181 :: 		BDEP3INCnt  := 0;                              // set bytecount
	CLRF        _BDEP3INCnt+0 
;USB_CDC_Library_NA.mpas,182 :: 		BDEP3INStat := BDEP3INStat and USB_DTSMASK;    // save only the data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP3INStat+0, 1 
;USB_CDC_Library_NA.mpas,183 :: 		BDEP3INStat := BDEP3INStat xor USB_DTSMASK;    // toggle the data 0/1 bit
	BTG         _BDEP3INStat+0, 6 
;USB_CDC_Library_NA.mpas,184 :: 		BDEP3INStat := BDEP3INStat OR (USB_DTSEN or USB_USIE);  // set the DTSEN bit and UOWN bit (enable sending)
	MOVLW       136
	IORWF       _BDEP3INStat+0, 1 
;USB_CDC_Library_NA.mpas,185 :: 		end;
L_end_SendBulkZeroLenPacket:
	RETURN      0
; end of USB_CDC_Library_NA_SendBulkZeroLenPacket

_USB_CDC_Write_Ready:

;USB_CDC_Library_NA.mpas,188 :: 		begin
;USB_CDC_Library_NA.mpas,189 :: 		PIE2.USBIE  := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,190 :: 		if (BDEP3INStat.UOWN = 0)
	BTFSC       _BDEP3INStat+0, 7 
	GOTO        L__USB_CDC_Write_Ready17
;USB_CDC_Library_NA.mpas,191 :: 		then Result := true
	MOVLW       255
	MOVWF       R1 
	GOTO        L__USB_CDC_Write_Ready18
;USB_CDC_Library_NA.mpas,192 :: 		else Result := false;
L__USB_CDC_Write_Ready17:
	CLRF        R1 
L__USB_CDC_Write_Ready18:
;USB_CDC_Library_NA.mpas,193 :: 		PIE2.USBIE  := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,194 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_USB_CDC_Write_Ready:
	RETURN      0
; end of _USB_CDC_Write_Ready

_USB_CDC_Write:

;USB_CDC_Library_NA.mpas,198 :: 		begin
;USB_CDC_Library_NA.mpas,199 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,201 :: 		if (BDEP3INStat.UOWN = 0)
	BTFSC       _BDEP3INStat+0, 7 
	GOTO        L__USB_CDC_Write21
;USB_CDC_Library_NA.mpas,202 :: 		then Result := true
	MOVLW       255
	MOVWF       USB_CDC_Write_local_result+0 
	GOTO        L__USB_CDC_Write22
;USB_CDC_Library_NA.mpas,203 :: 		else Result := false;
L__USB_CDC_Write21:
	CLRF        USB_CDC_Write_local_result+0 
L__USB_CDC_Write22:
;USB_CDC_Library_NA.mpas,205 :: 		if Result then
	MOVF        USB_CDC_Write_local_result+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__USB_CDC_Write24
;USB_CDC_Library_NA.mpas,208 :: 		DstPtr := ^byte(@BuffEP3IN);// get destination address
	MOVLW       _BuffEP3IN+0
	MOVWF       USB_CDC_Write_DstPtr+0 
	MOVLW       hi_addr(_BuffEP3IN+0)
	MOVWF       USB_CDC_Write_DstPtr+1 
;USB_CDC_Library_NA.mpas,211 :: 		if ByteCount > USB_CDC_BULK_IN_EP_SIZE
	MOVLW       0
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_CDC_Write111
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	SUBLW       64
L__USB_CDC_Write111:
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Write27
;USB_CDC_Library_NA.mpas,212 :: 		then ByteCount := USB_CDC_BULK_IN_EP_SIZE;
	MOVLW       64
	MOVWF       FARG_USB_CDC_Write_ByteCount+0 
L__USB_CDC_Write27:
;USB_CDC_Library_NA.mpas,214 :: 		if ByteCount > 0 then// fill the transmit buffer
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_CDC_Write30
;USB_CDC_Library_NA.mpas,216 :: 		memcpy(DstPtr, SrcPtr, ByteCount);
	MOVF        USB_CDC_Write_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        USB_CDC_Write_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        FARG_USB_CDC_Write_SrcPtr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        FARG_USB_CDC_Write_SrcPtr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_CDC_Library_NA.mpas,217 :: 		end;
L__USB_CDC_Write30:
;USB_CDC_Library_NA.mpas,220 :: 		BDEP3INCnt  := ByteCount;                      // set bytecount
	MOVF        FARG_USB_CDC_Write_ByteCount+0, 0 
	MOVWF       _BDEP3INCnt+0 
;USB_CDC_Library_NA.mpas,221 :: 		BDEP3INStat := BDEP3INStat and USB_DTSMASK;    // save only the data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP3INStat+0, 1 
;USB_CDC_Library_NA.mpas,222 :: 		BDEP3INStat := BDEP3INStat xor USB_DTSMASK;    // toggle the data 0/1 bit
	BTG         _BDEP3INStat+0, 6 
;USB_CDC_Library_NA.mpas,223 :: 		BDEP3INStat := BDEP3INStat OR (USB_DTSEN or USB_USIE);  // set the DTSEN bit and UOWN bit (enable sending)
	MOVLW       136
	IORWF       _BDEP3INStat+0, 1 
;USB_CDC_Library_NA.mpas,224 :: 		end;
L__USB_CDC_Write24:
;USB_CDC_Library_NA.mpas,226 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,227 :: 		end;
	MOVF        USB_CDC_Write_local_result+0, 0 
	MOVWF       R0 
L_end_USB_CDC_Write:
	RETURN      0
; end of _USB_CDC_Write

_USB_CDC_Get_Line_Coding:

;USB_CDC_Library_NA.mpas,230 :: 		begin
;USB_CDC_Library_NA.mpas,231 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,232 :: 		memcpy(^byte(@LineCoding), ^byte(@LineCodingFromHost), sizeof(TLineCoding));
	MOVF        FARG_USB_CDC_Get_Line_Coding_LineCoding+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        FARG_USB_CDC_Get_Line_Coding_LineCoding+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVLW       USB_CDC_Library_NA_LineCodingFromHost+0
	MOVWF       FARG_memcpy_p2+0 
	MOVLW       hi_addr(USB_CDC_Library_NA_LineCodingFromHost+0)
	MOVWF       FARG_memcpy_p2+1 
	MOVLW       7
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_CDC_Library_NA.mpas,233 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,234 :: 		end;
L_end_USB_CDC_Get_Line_Coding:
	RETURN      0
; end of _USB_CDC_Get_Line_Coding

_USB_CDC_Set_Line_Coding:

;USB_CDC_Library_NA.mpas,237 :: 		begin
;USB_CDC_Library_NA.mpas,238 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,239 :: 		memcpy(^byte(@LineCodingToHost), ^byte(@LineCoding), sizeof(TLineCoding));
	MOVLW       USB_CDC_Library_NA_LineCodingToHost+0
	MOVWF       FARG_memcpy_p1+0 
	MOVLW       hi_addr(USB_CDC_Library_NA_LineCodingToHost+0)
	MOVWF       FARG_memcpy_p1+1 
	MOVF        FARG_USB_CDC_Set_Line_Coding_LineCoding+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        FARG_USB_CDC_Set_Line_Coding_LineCoding+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVLW       7
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_CDC_Library_NA.mpas,240 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,241 :: 		end;
L_end_USB_CDC_Set_Line_Coding:
	RETURN      0
; end of _USB_CDC_Set_Line_Coding

_USB_CDC_Get_Control_Line_State:

;USB_CDC_Library_NA.mpas,244 :: 		begin
;USB_CDC_Library_NA.mpas,245 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,246 :: 		Result     := ControlLineState;
	MOVF        USB_CDC_Library_NA_ControlLineState+0, 0 
	MOVWF       R2 
	MOVF        USB_CDC_Library_NA_ControlLineState+1, 0 
	MOVWF       R3 
;USB_CDC_Library_NA.mpas,247 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_CDC_Library_NA.mpas,248 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
	MOVF        R3, 0 
	MOVWF       R1 
L_end_USB_CDC_Get_Control_Line_State:
	RETURN      0
; end of _USB_CDC_Get_Control_Line_State

USB_CDC_Library_NA_USBError:

;USB_CDC_Library_NA.mpas,252 :: 		begin
;USB_CDC_Library_NA.mpas,266 :: 		UEIR := 0;
	CLRF        UEIR+0 
;USB_CDC_Library_NA.mpas,267 :: 		UIR.UERRIF := 0; // clear error interrupt bit
	BCF         UIR+0, 1 
;USB_CDC_Library_NA.mpas,269 :: 		end;
L_end_USBError:
	RETURN      0
; end of USB_CDC_Library_NA_USBError

_ClassSpecificRequestCDC:

;USB_CDC_Library_NA.mpas,276 :: 		begin
;USB_CDC_Library_NA.mpas,277 :: 		Result := false;
	CLRF        ClassSpecificRequestCDC_local_result+0 
;USB_CDC_Library_NA.mpas,279 :: 		if (SetUpPacket.wIndex = USB_CDC_INTERFACE_NUMBER) then
	MOVLW       0
	XORWF       _SetUpPacket+5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC117
	MOVLW       0
	XORWF       _SetUpPacket+4, 0 
L__ClassSpecificRequestCDC117:
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC38
;USB_CDC_Library_NA.mpas,281 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassSpecificRequestCDC_local_result+0 
;USB_CDC_Library_NA.mpas,291 :: 		USB_SEND_ENCAPSULATED_COMMAND: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC43
;USB_CDC_Library_NA.mpas,296 :: 		UsbDeviceRequest := USB_SEND_ENCAPSULATED_COMMAND + $80;
	MOVLW       128
	MOVWF       _UsbDeviceRequest+0 
;USB_CDC_Library_NA.mpas,297 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,298 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC43:
;USB_CDC_Library_NA.mpas,300 :: 		USB_GET_ENCAPSULATED_RESPONSE: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC46
;USB_CDC_Library_NA.mpas,305 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,306 :: 		BuffEP0IN[0] := 'O';
	MOVLW       79
	MOVWF       _BuffEP0IN+0 
;USB_CDC_Library_NA.mpas,307 :: 		BuffEP0IN[1] := 'K';
	MOVLW       75
	MOVWF       _BuffEP0IN+1 
;USB_CDC_Library_NA.mpas,308 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       _BDEP0INCnt+0 
;USB_CDC_Library_NA.mpas,309 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       _BDEP0INStat+0 
;USB_CDC_Library_NA.mpas,310 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC46:
;USB_CDC_Library_NA.mpas,312 :: 		USB_SET_COMM_FEATURE: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC49
;USB_CDC_Library_NA.mpas,318 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,319 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_CDC_Library_NA.mpas,320 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC49:
;USB_CDC_Library_NA.mpas,322 :: 		USB_CLEAR_COMM_FEATURE: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC52
;USB_CDC_Library_NA.mpas,328 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,329 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_CDC_Library_NA.mpas,330 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC52:
;USB_CDC_Library_NA.mpas,332 :: 		USB_GET_COMM_FEATURE: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC55
;USB_CDC_Library_NA.mpas,338 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,339 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_CDC_Library_NA.mpas,340 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC55:
;USB_CDC_Library_NA.mpas,342 :: 		USB_SET_LINE_CODING: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC58
;USB_CDC_Library_NA.mpas,347 :: 		UsbDeviceRequest := USB_SET_LINE_CODING + $80;
	MOVLW       160
	MOVWF       _UsbDeviceRequest+0 
;USB_CDC_Library_NA.mpas,348 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,349 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC58:
;USB_CDC_Library_NA.mpas,351 :: 		USB_GET_LINE_CODING: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       33
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC61
;USB_CDC_Library_NA.mpas,353 :: 		BuffEP0IN[0] := lo(LineCodingToHost.Baudrate);
	MOVF        USB_CDC_Library_NA_LineCodingToHost+0, 0 
	MOVWF       _BuffEP0IN+0 
;USB_CDC_Library_NA.mpas,354 :: 		BuffEP0IN[1] := hi(LineCodingToHost.Baudrate);
	MOVF        USB_CDC_Library_NA_LineCodingToHost+1, 0 
	MOVWF       _BuffEP0IN+1 
;USB_CDC_Library_NA.mpas,355 :: 		BuffEP0IN[2] := higher(LineCodingToHost.Baudrate);
	MOVF        USB_CDC_Library_NA_LineCodingToHost+2, 0 
	MOVWF       _BuffEP0IN+2 
;USB_CDC_Library_NA.mpas,356 :: 		BuffEP0IN[3] := highest(LineCodingToHost.Baudrate);
	MOVF        USB_CDC_Library_NA_LineCodingToHost+3, 0 
	MOVWF       _BuffEP0IN+3 
;USB_CDC_Library_NA.mpas,357 :: 		BuffEP0IN[4] := LineCodingToHost.CharFormat;
	MOVF        USB_CDC_Library_NA_LineCodingToHost+4, 0 
	MOVWF       _BuffEP0IN+4 
;USB_CDC_Library_NA.mpas,358 :: 		BuffEP0IN[5] := LineCodingToHost.ParityType;
	MOVF        USB_CDC_Library_NA_LineCodingToHost+5, 0 
	MOVWF       _BuffEP0IN+5 
;USB_CDC_Library_NA.mpas,359 :: 		BuffEP0IN[6] := LineCodingToHost.DataBits;
	MOVF        USB_CDC_Library_NA_LineCodingToHost+6, 0 
	MOVWF       _BuffEP0IN+6 
;USB_CDC_Library_NA.mpas,364 :: 		EP0OutReset(USB_DAT1);                      // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,365 :: 		BDEP0INCnt   := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _BDEP0INCnt+0 
;USB_CDC_Library_NA.mpas,366 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       _BDEP0INStat+0 
;USB_CDC_Library_NA.mpas,367 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC61:
;USB_CDC_Library_NA.mpas,369 :: 		USB_SET_CONTROL_LINE_STATE: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       34
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC64
;USB_CDC_Library_NA.mpas,371 :: 		ControlLineState := SetUpPacket.wValue;
	MOVF        _SetUpPacket+2, 0 
	MOVWF       USB_CDC_Library_NA_ControlLineState+0 
	MOVF        _SetUpPacket+3, 0 
	MOVWF       USB_CDC_Library_NA_ControlLineState+1 
;USB_CDC_Library_NA.mpas,377 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,378 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_CDC_Library_NA.mpas,379 :: 		end;
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC64:
;USB_CDC_Library_NA.mpas,381 :: 		USB_SEND_BREAK: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       35
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestCDC67
;USB_CDC_Library_NA.mpas,387 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,388 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_CDC_Library_NA.mpas,390 :: 		else
	GOTO        L__ClassSpecificRequestCDC40
L__ClassSpecificRequestCDC67:
;USB_CDC_Library_NA.mpas,397 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_CDC_Library_NA.mpas,398 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_CDC_Library_NA.mpas,399 :: 		end;
L__ClassSpecificRequestCDC40:
;USB_CDC_Library_NA.mpas,403 :: 		end;
L__ClassSpecificRequestCDC38:
;USB_CDC_Library_NA.mpas,404 :: 		end;
	MOVF        ClassSpecificRequestCDC_local_result+0, 0 
	MOVWF       R0 
L_end_ClassSpecificRequestCDC:
	RETURN      0
; end of _ClassSpecificRequestCDC

_ClassSetupEndPointsCDC:

;USB_CDC_Library_NA.mpas,407 :: 		begin
;USB_CDC_Library_NA.mpas,413 :: 		LineCodingFromHost.BaudRate   := 0; // = invalid value
	CLRF        USB_CDC_Library_NA_LineCodingFromHost+0 
	CLRF        USB_CDC_Library_NA_LineCodingFromHost+1 
	CLRF        USB_CDC_Library_NA_LineCodingFromHost+2 
	CLRF        USB_CDC_Library_NA_LineCodingFromHost+3 
;USB_CDC_Library_NA.mpas,414 :: 		LineCodingFromHost.CharFormat := 0;
	CLRF        USB_CDC_Library_NA_LineCodingFromHost+4 
;USB_CDC_Library_NA.mpas,415 :: 		LineCodingFromHost.ParityType := 0;
	CLRF        USB_CDC_Library_NA_LineCodingFromHost+5 
;USB_CDC_Library_NA.mpas,416 :: 		LineCodingFromHost.Databits   := 8;
	MOVLW       8
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+6 
;USB_CDC_Library_NA.mpas,418 :: 		BDEP2INAdr   := word(@BuffEP2IN);
	MOVLW       _BuffEP2IN+0
	MOVWF       _BDEP2INAdr+0 
	MOVLW       hi_addr(_BuffEP2IN+0)
	MOVWF       _BDEP2INAdr+1 
;USB_CDC_Library_NA.mpas,419 :: 		BDEP2INStat  := (USB_UCPU or USB_DAT1);
	MOVLW       64
	MOVWF       _BDEP2INStat+0 
;USB_CDC_Library_NA.mpas,421 :: 		BDEP3OUTAdr  := word(@BuffEP3OUT);
	MOVLW       _BuffEP3OUT+0
	MOVWF       _BDEP3OUTAdr+0 
	MOVLW       hi_addr(_BuffEP3OUT+0)
	MOVWF       _BDEP3OUTAdr+1 
;USB_CDC_Library_NA.mpas,422 :: 		BDEP3OUTCnt  := (USB_CDC_BULK_OUT_EP_SIZE);
	MOVLW       64
	MOVWF       _BDEP3OUTCnt+0 
;USB_CDC_Library_NA.mpas,423 :: 		BDEP3OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN);
	MOVLW       136
	MOVWF       _BDEP3OUTStat+0 
;USB_CDC_Library_NA.mpas,425 :: 		BDEP3INAdr   := word(@BuffEP3IN);
	MOVLW       _BuffEP3IN+0
	MOVWF       _BDEP3INAdr+0 
	MOVLW       hi_addr(_BuffEP3IN+0)
	MOVWF       _BDEP3INAdr+1 
;USB_CDC_Library_NA.mpas,426 :: 		BDEP3INStat  := (USB_UCPU or USB_DAT1); // USB_DAT1 will be toggled to USB_DAT0 before the first OUT packet is sent
	MOVLW       64
	MOVWF       _BDEP3INStat+0 
;USB_CDC_Library_NA.mpas,428 :: 		UEP2         := (USB_EP_IN or USB_HSHK_EN); // enable com pipe
	MOVLW       26
	MOVWF       UEP2+0 
;USB_CDC_Library_NA.mpas,429 :: 		UEP3         := (USB_EP_OUT_IN or USB_HSHK_EN);  // enable data pipes
	MOVLW       30
	MOVWF       UEP3+0 
;USB_CDC_Library_NA.mpas,431 :: 		end;
L_end_ClassSetupEndPointsCDC:
	RETURN      0
; end of _ClassSetupEndPointsCDC

_ClassTokenInCDC:

;USB_CDC_Library_NA.mpas,434 :: 		begin
;USB_CDC_Library_NA.mpas,435 :: 		Result := false;
	CLRF        ClassTokenInCDC_local_result+0 
;USB_CDC_Library_NA.mpas,438 :: 		0: // endpoint 0 in
	MOVF        FARG_ClassTokenInCDC_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInCDC73
;USB_CDC_Library_NA.mpas,440 :: 		end;
	GOTO        L__ClassTokenInCDC70
L__ClassTokenInCDC73:
;USB_CDC_Library_NA.mpas,442 :: 		2: // endpoint 2 in
	MOVF        FARG_ClassTokenInCDC_Ep+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInCDC76
;USB_CDC_Library_NA.mpas,444 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenInCDC_local_result+0 
;USB_CDC_Library_NA.mpas,445 :: 		end;
	GOTO        L__ClassTokenInCDC70
L__ClassTokenInCDC76:
;USB_CDC_Library_NA.mpas,447 :: 		3: // endpoint 3 in
	MOVF        FARG_ClassTokenInCDC_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInCDC79
;USB_CDC_Library_NA.mpas,449 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenInCDC_local_result+0 
;USB_CDC_Library_NA.mpas,450 :: 		if BDEP3INCnt = USB_CDC_BULK_OUT_EP_SIZE
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInCDC120
	MOVLW       64
	XORWF       _BDEP3INCnt+0, 0 
L__ClassTokenInCDC120:
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInCDC81
;USB_CDC_Library_NA.mpas,451 :: 		then SendBulkZeroLenPacket;
	CALL        USB_CDC_Library_NA_SendBulkZeroLenPacket+0, 0
L__ClassTokenInCDC81:
;USB_CDC_Library_NA.mpas,452 :: 		end;
	GOTO        L__ClassTokenInCDC70
L__ClassTokenInCDC79:
L__ClassTokenInCDC70:
;USB_CDC_Library_NA.mpas,455 :: 		end;
	MOVF        ClassTokenInCDC_local_result+0, 0 
	MOVWF       R0 
L_end_ClassTokenInCDC:
	RETURN      0
; end of _ClassTokenInCDC

_ClassTokenOutCDC:

;USB_CDC_Library_NA.mpas,459 :: 		begin
;USB_CDC_Library_NA.mpas,460 :: 		Result := true;
	MOVLW       255
	MOVWF       R1 
;USB_CDC_Library_NA.mpas,461 :: 		if (Ep = 2) then exit;
	MOVF        FARG_ClassTokenOutCDC_Ep+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutCDC85
	GOTO        L_end__ClassTokenOutCDC
L__ClassTokenOutCDC85:
;USB_CDC_Library_NA.mpas,462 :: 		if (Ep = 3) then exit;
	MOVF        FARG_ClassTokenOutCDC_Ep+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutCDC88
	GOTO        L_end__ClassTokenOutCDC
L__ClassTokenOutCDC88:
;USB_CDC_Library_NA.mpas,464 :: 		Result := false;
	CLRF        R1 
;USB_CDC_Library_NA.mpas,471 :: 		if Ep = 0 then
	MOVF        FARG_ClassTokenOutCDC_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutCDC91
;USB_CDC_Library_NA.mpas,475 :: 		USB_SEND_ENCAPSULATED_COMMAND + $80: //
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutCDC96
;USB_CDC_Library_NA.mpas,477 :: 		Result := true;
	MOVLW       255
	MOVWF       R1 
;USB_CDC_Library_NA.mpas,481 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_CDC_Library_NA.mpas,482 :: 		for I := 0 to 7 do DummyEncapsulatedCommand[I] := BuffEP0OUT[I];
	CLRF        R2 
L__ClassTokenOutCDC98:
	MOVLW       USB_CDC_Library_NA_DummyEncapsulatedCommand+0
	MOVWF       FSR1L 
	MOVLW       hi_addr(USB_CDC_Library_NA_DummyEncapsulatedCommand+0)
	MOVWF       FSR1H 
	MOVF        R2, 0 
	ADDWF       FSR1L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVLW       _BuffEP0OUT+0
	MOVWF       FSR0L 
	MOVLW       hi_addr(_BuffEP0OUT+0)
	MOVWF       FSR0H 
	MOVF        R2, 0 
	ADDWF       FSR0L, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R2, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L__ClassTokenOutCDC101
	INCF        R2, 1 
	GOTO        L__ClassTokenOutCDC98
L__ClassTokenOutCDC101:
;USB_CDC_Library_NA.mpas,483 :: 		end;
	GOTO        L__ClassTokenOutCDC93
L__ClassTokenOutCDC96:
;USB_CDC_Library_NA.mpas,485 :: 		USB_SET_LINE_CODING + $80: //
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       160
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutCDC104
;USB_CDC_Library_NA.mpas,487 :: 		Result := true;
	MOVLW       255
	MOVWF       R1 
;USB_CDC_Library_NA.mpas,492 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_CDC_Library_NA.mpas,494 :: 		lo(LineCodingFromHost.Baudrate)      := BuffEP0OUT[0];
	MOVF        _BuffEP0OUT+0, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+0 
;USB_CDC_Library_NA.mpas,495 :: 		hi(LineCodingFromHost.Baudrate)      := BuffEP0OUT[1];
	MOVF        _BuffEP0OUT+1, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+1 
;USB_CDC_Library_NA.mpas,496 :: 		higher(LineCodingFromHost.Baudrate)  := BuffEP0OUT[2];
	MOVF        _BuffEP0OUT+2, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+2 
;USB_CDC_Library_NA.mpas,497 :: 		highest(LineCodingFromHost.Baudrate) := BuffEP0OUT[3];
	MOVF        _BuffEP0OUT+3, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+3 
;USB_CDC_Library_NA.mpas,499 :: 		LineCodingFromHost.CharFormat        := BuffEP0OUT[4];
	MOVF        _BuffEP0OUT+4, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+4 
;USB_CDC_Library_NA.mpas,500 :: 		LineCodingFromHost.ParityType        := BuffEP0OUT[5];
	MOVF        _BuffEP0OUT+5, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+5 
;USB_CDC_Library_NA.mpas,501 :: 		LineCodingFromHost.DataBits          := BuffEP0OUT[6];
	MOVF        _BuffEP0OUT+6, 0 
	MOVWF       USB_CDC_Library_NA_LineCodingFromHost+6 
;USB_CDC_Library_NA.mpas,502 :: 		end;
	GOTO        L__ClassTokenOutCDC93
L__ClassTokenOutCDC104:
L__ClassTokenOutCDC93:
;USB_CDC_Library_NA.mpas,504 :: 		end;
L__ClassTokenOutCDC91:
;USB_CDC_Library_NA.mpas,505 :: 		end;
L_end__ClassTokenOutCDC:
	MOVF        R1, 0 
	MOVWF       R0 
L_end_ClassTokenOutCDC:
	RETURN      0
; end of _ClassTokenOutCDC

_GetClassSpecificDescriptorCDC:

;USB_CDC_Library_NA.mpas,508 :: 		begin
;USB_CDC_Library_NA.mpas,509 :: 		Result := false;
	CLRF        R1 
;USB_CDC_Library_NA.mpas,510 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_GetClassSpecificDescriptorCDC:
	RETURN      0
; end of _GetClassSpecificDescriptorCDC
