
_ConfiguredUsb:

;USB_Library_Core_NA.mpas,277 :: 		begin
;USB_Library_Core_NA.mpas,278 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ConfiguredUsb2
;USB_Library_Core_NA.mpas,279 :: 		then Result := true
	MOVLW       255
	MOVWF       R1 
	GOTO        L__ConfiguredUsb3
;USB_Library_Core_NA.mpas,280 :: 		else Result := false;
L__ConfiguredUsb2:
	CLRF        R1 
L__ConfiguredUsb3:
;USB_Library_Core_NA.mpas,281 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_ConfiguredUsb:
	RETURN      0
; end of _ConfiguredUsb

_ActiveUsb:

;USB_Library_Core_NA.mpas,284 :: 		begin
;USB_Library_Core_NA.mpas,285 :: 		if (IsIdle = false) and (UsbDeviceEnumState = USB_CONFIG_STATE)
	MOVF        _IsIdle+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__ActiveUsb6
;USB_Library_Core_NA.mpas,286 :: 		then Result := true
	MOVLW       255
	MOVWF       R2 
	GOTO        L__ActiveUsb7
;USB_Library_Core_NA.mpas,287 :: 		else Result := false;
L__ActiveUsb6:
	CLRF        R2 
L__ActiveUsb7:
;USB_Library_Core_NA.mpas,288 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
L_end_ActiveUsb:
	RETURN      0
; end of _ActiveUsb

_InitUsb:

;USB_Library_Core_NA.mpas,291 :: 		begin
;USB_Library_Core_NA.mpas,304 :: 		UsbDeviceRequest  := $FF; // no device requests in progress
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,306 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        _UsbDeviceEnumState+0 
;USB_Library_Core_NA.mpas,307 :: 		UsbCurrentConfig  := 0; // no configuration selected
	CLRF        _UsbCurrentConfig+0 
;USB_Library_Core_NA.mpas,308 :: 		Usb_Status_Device := 1; //
	MOVLW       1
	MOVWF       _Usb_Status_Device+0 
;USB_Library_Core_NA.mpas,309 :: 		UsbInterface      := 0;
	CLRF        _UsbInterface+0 
;USB_Library_Core_NA.mpas,311 :: 		UADDR := 0;
	CLRF        UADDR+0 
;USB_Library_Core_NA.mpas,313 :: 		UCFG.7      := 0; // eye pattern disabled
	BCF         UCFG+0, 7 
;USB_Library_Core_NA.mpas,314 :: 		UCFG.UOEMON := 0; // OE monitor disabled
	BCF         UCFG+0, 6 
;USB_Library_Core_NA.mpas,315 :: 		UCFG.UPUEN  := 1; // on chip pull up enabled
	BSF         UCFG+0, 4 
;USB_Library_Core_NA.mpas,316 :: 		UCFG.UTRDIS := 0; // on chip tranceiver active
	BCF         UCFG+0, 3 
;USB_Library_Core_NA.mpas,317 :: 		UCFG.FSEN   := 1; // Full speed enable (48 MHz USB clock required)
	BSF         UCFG+0, 2 
;USB_Library_Core_NA.mpas,318 :: 		UCFG.PPB1   := 0; // ping pong buffers disabled
	BCF         UCFG+0, 1 
;USB_Library_Core_NA.mpas,319 :: 		UCFG.PPB0   := 0; //
	BCF         UCFG+0, 0 
;USB_Library_Core_NA.mpas,321 :: 		UIR   := 0; // clear all Usb interrupt flags
	CLRF        UIR+0 
;USB_Library_Core_NA.mpas,322 :: 		UIE   := 1; // the only interrupt enabled is "USB reset"
	MOVLW       1
	MOVWF       UIE+0 
;USB_Library_Core_NA.mpas,324 :: 		PIR2.USBIF := 0; // clear usb interrupt flag
	BCF         PIR2+0, 5 
;USB_Library_Core_NA.mpas,325 :: 		PIE2.USBIE := 1; // enable Usb interrupts
	BSF         PIE2+0, 5 
;USB_Library_Core_NA.mpas,327 :: 		INTCON.PEIE := 1; // peripheral interrupt enable
	BSF         INTCON+0, 6 
;USB_Library_Core_NA.mpas,328 :: 		INTCON.GIE  := 1; // global enable
	BSF         INTCON+0, 7 
;USB_Library_Core_NA.mpas,330 :: 		UCON  := 8; // attach device (USBEN = 1)
	MOVLW       8
	MOVWF       UCON+0 
;USB_Library_Core_NA.mpas,332 :: 		repeat
L__InitUsb9:
;USB_Library_Core_NA.mpas,333 :: 		until UCON.SE0 = 0;
	BTFSC       UCON+0, 5 
	GOTO        L__InitUsb9
;USB_Library_Core_NA.mpas,335 :: 		end;
L_end_InitUsb:
	RETURN      0
; end of _InitUsb

_DeInitUsb:

;USB_Library_Core_NA.mpas,338 :: 		begin
;USB_Library_Core_NA.mpas,339 :: 		UCON.USBEN  := 0; // detach
	BCF         UCON+0, 3 
;USB_Library_Core_NA.mpas,340 :: 		UCON.SUSPND := 1; // suspend mode
	BSF         UCON+0, 1 
;USB_Library_Core_NA.mpas,342 :: 		UsbDeviceEnumState := USB_POWERED_STATE;
	CLRF        _UsbDeviceEnumState+0 
;USB_Library_Core_NA.mpas,344 :: 		PIE2.USBIE := 0;  // disable the USB interrupts
	BCF         PIE2+0, 5 
;USB_Library_Core_NA.mpas,345 :: 		end;
L_end_DeInitUsb:
	RETURN      0
; end of _DeInitUsb

_SoftDetachUsb:

;USB_Library_Core_NA.mpas,348 :: 		begin
;USB_Library_Core_NA.mpas,349 :: 		UCON.USBEN := 0;
	BCF         UCON+0, 3 
;USB_Library_Core_NA.mpas,350 :: 		Delay_ms(100);
	MOVLW       7
	MOVWF       R11, 0
	MOVLW       23
	MOVWF       R12, 0
	MOVLW       106
	MOVWF       R13, 0
L__SoftDetachUsb16:
	DECFSZ      R13, 1, 1
	BRA         L__SoftDetachUsb16
	DECFSZ      R12, 1, 1
	BRA         L__SoftDetachUsb16
	DECFSZ      R11, 1, 1
	BRA         L__SoftDetachUsb16
	NOP
;USB_Library_Core_NA.mpas,351 :: 		InitUsb;
	CALL        _InitUsb+0, 0
;USB_Library_Core_NA.mpas,352 :: 		end;
L_end_SoftDetachUsb:
	RETURN      0
; end of _SoftDetachUsb

USB_Library_Core_NA_EP0InReset:

;USB_Library_Core_NA.mpas,355 :: 		begin
;USB_Library_Core_NA.mpas,356 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_Library_Core_NA.mpas,357 :: 		BDEP0INStat := (USB_UCPU or USB_DAT0 or USB_DTSEN);
	MOVLW       8
	MOVWF       1028 
;USB_Library_Core_NA.mpas,358 :: 		end;
L_end_EP0InReset:
	RETURN      0
; end of USB_Library_Core_NA_EP0InReset

_EP0OutReset:

;USB_Library_Core_NA.mpas,361 :: 		begin
;USB_Library_Core_NA.mpas,362 :: 		BDEP0OUTCnt  := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_Library_Core_NA.mpas,363 :: 		BDEP0OUTStat := (USB_USIE or USBDat or USB_DTSEN); // UOWN = 1 and DTSEN = 1; // ready to receive data
	MOVLW       128
	IORWF       FARG_EP0OutReset_USBDat+0, 0 
	MOVWF       R0 
	MOVLW       8
	IORWF       R0, 0 
	MOVWF       1024 
;USB_Library_Core_NA.mpas,364 :: 		end;
L_end_EP0OutReset:
	RETURN      0
; end of _EP0OutReset

_GiveEP0INtoSIE__:

;USB_Library_Core_NA.mpas,367 :: 		begin
;USB_Library_Core_NA.mpas,368 :: 		BDEP0INStat := BDEP0INStat xor USB_DTSMASK;             // toggle the DTS bit
	BTG         1028, 6 
;USB_Library_Core_NA.mpas,369 :: 		BDEP0INStat := BDEP0INStat and USB_DTSMASK;             // clear the PID bits except DTS
	MOVLW       64
	ANDWF       1028, 1 
;USB_Library_Core_NA.mpas,370 :: 		BDEP0INStat := BDEP0INStat or (USB_DTSEN or USB_USIE);  // go: set DTSEN
	MOVLW       136
	IORWF       1028, 1 
;USB_Library_Core_NA.mpas,371 :: 		end;
L_end_GiveEP0INtoSIE__:
	RETURN      0
; end of _GiveEP0INtoSIE__

_GiveEP0OUTtoSIE__:

;USB_Library_Core_NA.mpas,374 :: 		begin
;USB_Library_Core_NA.mpas,375 :: 		BDEP0OUTStat := BDEP0OUTStat and USB_DTSMask;            // save only the data 0/1 bit
	MOVLW       64
	ANDWF       1024, 1 
;USB_Library_Core_NA.mpas,376 :: 		BDEP0OUTStat := BDEP0OUTStat xor USB_DTSMask;            // toggle data 0/1
	BTG         1024, 6 
;USB_Library_Core_NA.mpas,377 :: 		BDEP0OUTStat := BDEP0OUTStat or (USB_DTSEN or USB_USIE); // set the DTS bit and the UOWN bit
	MOVLW       136
	IORWF       1024, 1 
;USB_Library_Core_NA.mpas,378 :: 		end;
L_end_GiveEP0OUTtoSIE__:
	RETURN      0
; end of _GiveEP0OUTtoSIE__

_StallEP0:

;USB_Library_Core_NA.mpas,381 :: 		begin
;USB_Library_Core_NA.mpas,385 :: 		UsbDeviceRequest := $FF; // disregard any pending device request
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,387 :: 		BDEP0OUTCnt      := EP0_PACKET_SIZE;
	MOVLW       64
	MOVWF       1025 
;USB_Library_Core_NA.mpas,388 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_Library_Core_NA.mpas,389 :: 		BDEP0OUTStat     := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1024 
;USB_Library_Core_NA.mpas,390 :: 		BDEP0INStat      := (USB_USIE or USB_BSTALL);
	MOVLW       132
	MOVWF       1028 
;USB_Library_Core_NA.mpas,391 :: 		end;
L_end_StallEP0:
	RETURN      0
; end of _StallEP0

USB_Library_Core_NA_EP0Stalled:

;USB_Library_Core_NA.mpas,394 :: 		begin
;USB_Library_Core_NA.mpas,395 :: 		Result := (BDEP0INStat and USB_BSTALL) > 0;
	MOVLW       4
	ANDWF       1028, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	SUBLW       0
	MOVLW       255
	BTFSC       STATUS+0, 0 
	MOVLW       0
	MOVWF       R1 
;USB_Library_Core_NA.mpas,396 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_EP0Stalled:
	RETURN      0
; end of USB_Library_Core_NA_EP0Stalled

USB_Library_Core_NA_UsbReset:

;USB_Library_Core_NA.mpas,399 :: 		begin
;USB_Library_Core_NA.mpas,405 :: 		UCON.PKTDIS := 1;    // disable packet reception
	BSF         UCON+0, 4 
;USB_Library_Core_NA.mpas,407 :: 		UEP0  := 0;  // disable UEP0
	CLRF        UEP0+0 
;USB_Library_Core_NA.mpas,408 :: 		UEP1  := 0;  // disable UEP1
	CLRF        UEP1+0 
;USB_Library_Core_NA.mpas,409 :: 		UEP2  := 0;  // disable UEP2
	CLRF        UEP2+0 
;USB_Library_Core_NA.mpas,410 :: 		UEP3  := 0;  // disable UEP3
	CLRF        UEP3+0 
;USB_Library_Core_NA.mpas,411 :: 		UEP4  := 0;  // disable UEP4
	CLRF        UEP4+0 
;USB_Library_Core_NA.mpas,412 :: 		UEP5  := 0;  // disable UEP5
	CLRF        UEP5+0 
;USB_Library_Core_NA.mpas,413 :: 		UEP6  := 0;  // disable UEP6
	CLRF        UEP6+0 
;USB_Library_Core_NA.mpas,414 :: 		UEP7  := 0;  // disable UEP7
	CLRF        UEP7+0 
;USB_Library_Core_NA.mpas,415 :: 		UEP8  := 0;  // disable UEP8
	CLRF        UEP8+0 
;USB_Library_Core_NA.mpas,416 :: 		UEP9  := 0;  // disable UEP9
	CLRF        UEP9+0 
;USB_Library_Core_NA.mpas,417 :: 		UEP10 := 0;  // disable UEP10
	CLRF        UEP10+0 
;USB_Library_Core_NA.mpas,418 :: 		UEP11 := 0;  // disable UEP11
	CLRF        UEP11+0 
;USB_Library_Core_NA.mpas,419 :: 		UEP12 := 0;  // disable UEP12
	CLRF        UEP12+0 
;USB_Library_Core_NA.mpas,420 :: 		UEP13 := 0;  // disable UEP13
	CLRF        UEP13+0 
;USB_Library_Core_NA.mpas,421 :: 		UEP14 := 0;  // disable UEP14
	CLRF        UEP14+0 
;USB_Library_Core_NA.mpas,422 :: 		UEP15 := 0;  // disable UEP15
	CLRF        UEP15+0 
;USB_Library_Core_NA.mpas,424 :: 		UsbCurrentConfig := 0;
	CLRF        _UsbCurrentConfig+0 
;USB_Library_Core_NA.mpas,425 :: 		IsIdle := false;
	CLRF        _IsIdle+0 
;USB_Library_Core_NA.mpas,427 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_Library_Core_NA.mpas,428 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_Library_Core_NA.mpas,429 :: 		UIR.TRNIF := 0;
	BCF         UIR+0, 3 
;USB_Library_Core_NA.mpas,430 :: 		UIR.TRNIF := 0;  // clear 4 times to make the status fifo empty
	BCF         UIR+0, 3 
;USB_Library_Core_NA.mpas,433 :: 		BDEP0OUTAdr  := word(@BuffEP0OUT);
	MOVLW       _BuffEP0OUT+0
	MOVWF       1026 
	MOVLW       hi_addr(_BuffEP0OUT+0)
	MOVWF       1027 
;USB_Library_Core_NA.mpas,434 :: 		EP0OutReset(USB_DAT0);  // Initial EP0OUT Status: start with DATA0 toggle bit
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,437 :: 		BDEP0INAdr  := word(@BuffEP0IN);
	MOVLW       _BuffEP0IN+0
	MOVWF       1030 
	MOVLW       hi_addr(_BuffEP0IN+0)
	MOVWF       1031 
;USB_Library_Core_NA.mpas,438 :: 		EP0InReset;
	CALL        USB_Library_Core_NA_EP0InReset+0, 0
;USB_Library_Core_NA.mpas,440 :: 		UADDR      := 0; // no usb address assigned (yet)
	CLRF        UADDR+0 
;USB_Library_Core_NA.mpas,441 :: 		UIR        := 0; // clear the usb interrupt flags
	CLRF        UIR+0 
;USB_Library_Core_NA.mpas,442 :: 		PIR2.USBIF := 0; // clear the USB general interrupt flag
	BCF         PIR2+0, 5 
;USB_Library_Core_NA.mpas,444 :: 		UsbDeviceEnumState := USB_DEFAULT_STATE;
	MOVLW       1
	MOVWF       _UsbDeviceEnumState+0 
;USB_Library_Core_NA.mpas,446 :: 		Usb_Status_Device := 0; // selfpowered, remote wakeup disabled
	CLRF        _Usb_Status_Device+0 
;USB_Library_Core_NA.mpas,449 :: 		UIE  := $39; // enable all interrupts except "ACTIVE", "SOFIE" and "UERRIE"
	MOVLW       57
	MOVWF       UIE+0 
;USB_Library_Core_NA.mpas,450 :: 		UEIE := 0;   // disable all error interrupts
	CLRF        UEIE+0 
;USB_Library_Core_NA.mpas,457 :: 		UEP0 := (USB_EP_CTRL or USB_HSHK_EN); // control endpoint, handshake enabled
	MOVLW       22
	MOVWF       UEP0+0 
;USB_Library_Core_NA.mpas,458 :: 		UCON.PKTDIS := 0;                     // enable packet reception
	BCF         UCON+0, 4 
;USB_Library_Core_NA.mpas,459 :: 		end;
L_end_UsbReset:
	RETURN      0
; end of USB_Library_Core_NA_UsbReset

USB_Library_Core_NA_USBError:

;USB_Library_Core_NA.mpas,462 :: 		begin
;USB_Library_Core_NA.mpas,463 :: 		UIR.UERRIF := 0; // clear error interrupt bit
	BCF         UIR+0, 1 
;USB_Library_Core_NA.mpas,469 :: 		end;
L_end_USBError:
	RETURN      0
; end of USB_Library_Core_NA_USBError

_MemCpy__:

;USB_Library_Core_NA.mpas,472 :: 		begin
;USB_Library_Core_NA.mpas,473 :: 		while N > 0 do
L__MemCpy__27:
	MOVLW       0
	MOVWF       R0 
	MOVF        FARG_MemCpy___n+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__MemCpy__361
	MOVF        FARG_MemCpy___n+0, 0 
	SUBLW       0
L__MemCpy__361:
	BTFSC       STATUS+0, 0 
	GOTO        L__MemCpy__28
;USB_Library_Core_NA.mpas,475 :: 		Towards^ := From^;
	MOVFF       FARG_MemCpy___From+0, FSR0L
	MOVFF       FARG_MemCpy___From+1, FSR0H
	MOVFF       FARG_MemCpy___Towards+0, FSR1L
	MOVFF       FARG_MemCpy___Towards+1, FSR1H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,476 :: 		inc(Towards);
	INFSNZ      FARG_MemCpy___Towards+0, 1 
	INCF        FARG_MemCpy___Towards+1, 1 
;USB_Library_Core_NA.mpas,477 :: 		inc(From);
	INFSNZ      FARG_MemCpy___From+0, 1 
	INCF        FARG_MemCpy___From+1, 1 
;USB_Library_Core_NA.mpas,478 :: 		dec(N);
	MOVLW       1
	SUBWF       FARG_MemCpy___n+0, 1 
	MOVLW       0
	SUBWFB      FARG_MemCpy___n+1, 1 
;USB_Library_Core_NA.mpas,479 :: 		end;
	GOTO        L__MemCpy__27
L__MemCpy__28:
;USB_Library_Core_NA.mpas,480 :: 		end;
L_end_MemCpy__:
	RETURN      0
; end of _MemCpy__

_memCpyC__:

;USB_Library_Core_NA.mpas,484 :: 		begin
;USB_Library_Core_NA.mpas,485 :: 		while N > 0 do
L__memCpyC__33:
	MOVLW       0
	MOVWF       R0 
	MOVF        FARG_memCpyC___N+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__memCpyC__363
	MOVF        FARG_memCpyC___N+0, 0 
	SUBLW       0
L__memCpyC__363:
	BTFSC       STATUS+0, 0 
	GOTO        L__memCpyC__34
;USB_Library_Core_NA.mpas,487 :: 		P1^ := P2^;
	MOVF        FARG_memCpyC___p2+0, 0 
	MOVWF       TBLPTRL 
	MOVF        FARG_memCpyC___p2+1, 0 
	MOVWF       TBLPTRH 
	MOVF        FARG_memCpyC___p2+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       FARG_memCpyC___p1+0, FSR1L
	MOVFF       FARG_memCpyC___p1+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,488 :: 		inc(P1);
	INFSNZ      FARG_memCpyC___p1+0, 1 
	INCF        FARG_memCpyC___p1+1, 1 
;USB_Library_Core_NA.mpas,489 :: 		inc(P2);
	MOVLW       1
	ADDWF       FARG_memCpyC___p2+0, 1 
	MOVLW       0
	ADDWFC      FARG_memCpyC___p2+1, 1 
	ADDWFC      FARG_memCpyC___p2+2, 1 
;USB_Library_Core_NA.mpas,490 :: 		dec(N);
	MOVLW       1
	SUBWF       FARG_memCpyC___N+0, 1 
	MOVLW       0
	SUBWFB      FARG_memCpyC___N+1, 1 
;USB_Library_Core_NA.mpas,491 :: 		end;
	GOTO        L__memCpyC__33
L__memCpyC__34:
;USB_Library_Core_NA.mpas,492 :: 		end;
L_end_memCpyC__:
	RETURN      0
; end of _memCpyC__

USB_Library_Core_NA_SendZeroLenPacket:

;USB_Library_Core_NA.mpas,495 :: 		begin
;USB_Library_Core_NA.mpas,499 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,500 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_Library_Core_NA.mpas,501 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,502 :: 		end;
L_end_SendZeroLenPacket:
	RETURN      0
; end of USB_Library_Core_NA_SendZeroLenPacket

_SendAckToHost:

;USB_Library_Core_NA.mpas,505 :: 		begin
;USB_Library_Core_NA.mpas,509 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,510 :: 		BDEP0INCnt       := 0;
	CLRF        1029 
;USB_Library_Core_NA.mpas,511 :: 		BDEP0INStat      := (USB_USIE or USB_DAT1 or USB_DTSEN); // UOWN, DTS (data1) and DTSEN are set
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,512 :: 		end;
L_end_SendAckToHost:
	RETURN      0
; end of _SendAckToHost

_minimum__:

;USB_Library_Core_NA.mpas,515 :: 		begin
;USB_Library_Core_NA.mpas,516 :: 		if v1 < V2
	MOVF        FARG_minimum___v2+1, 0 
	SUBWF       FARG_minimum___v1+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__minimum__367
	MOVF        FARG_minimum___v2+0, 0 
	SUBWF       FARG_minimum___v1+0, 0 
L__minimum__367:
	BTFSC       STATUS+0, 0 
	GOTO        L__minimum__41
;USB_Library_Core_NA.mpas,517 :: 		then result := v1
	MOVF        FARG_minimum___v1+0, 0 
	MOVWF       R2 
	MOVF        FARG_minimum___v1+1, 0 
	MOVWF       R3 
	GOTO        L__minimum__42
;USB_Library_Core_NA.mpas,518 :: 		else result := v2;
L__minimum__41:
	MOVF        FARG_minimum___v2+0, 0 
	MOVWF       R2 
	MOVF        FARG_minimum___v2+1, 0 
	MOVWF       R3 
L__minimum__42:
;USB_Library_Core_NA.mpas,519 :: 		end;
	MOVF        R2, 0 
	MOVWF       R0 
	MOVF        R3, 0 
	MOVWF       R1 
L_end_minimum__:
	RETURN      0
; end of _minimum__

USB_Library_Core_NA_AdaptDescriptorBytes:

;USB_Library_Core_NA.mpas,522 :: 		begin
;USB_Library_Core_NA.mpas,523 :: 		DescriptorBytesToSend    := DescriptorBytesToSend    - Len;
	MOVF        FARG_AdaptDescriptorBytes_Len+0, 0 
	SUBWF       _DescriptorBytesToSend+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesToSend+1, 1 
;USB_Library_Core_NA.mpas,524 :: 		DescriptorBytesRequested := DescriptorBytesRequested - Len;
	MOVF        FARG_AdaptDescriptorBytes_Len+0, 0 
	SUBWF       _DescriptorBytesRequested+0, 1 
	MOVLW       0
	SUBWFB      _DescriptorBytesRequested+1, 1 
;USB_Library_Core_NA.mpas,525 :: 		end;
L_end_AdaptDescriptorBytes:
	RETURN      0
; end of USB_Library_Core_NA_AdaptDescriptorBytes

_SendDescriptorToEP0:

;USB_Library_Core_NA.mpas,531 :: 		begin
;USB_Library_Core_NA.mpas,532 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       SendDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       SendDescriptorToEP0_Dst+1 
;USB_Library_Core_NA.mpas,533 :: 		Len := DescriptorBytesToSend;
	MOVF        _DescriptorBytesToSend+0, 0 
	MOVWF       SendDescriptorToEP0_Len+0 
	MOVF        _DescriptorBytesToSend+1, 0 
	MOVWF       SendDescriptorToEP0_Len+1 
;USB_Library_Core_NA.mpas,535 :: 		if (Len = 0)
	MOVLW       0
	XORWF       _DescriptorBytesToSend+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__SendDescriptorToEP0370
	MOVLW       0
	XORWF       _DescriptorBytesToSend+0, 0 
L__SendDescriptorToEP0370:
	BTFSS       STATUS+0, 2 
	GOTO        L__SendDescriptorToEP046
;USB_Library_Core_NA.mpas,536 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
	GOTO        L__SendDescriptorToEP047
;USB_Library_Core_NA.mpas,539 :: 		else  // some left over of the descriptor is to be sent
L__SendDescriptorToEP046:
;USB_Library_Core_NA.mpas,541 :: 		Len := minimum__(Len, EP0_PACKET_SIZE);
	MOVF        SendDescriptorToEP0_Len+0, 0 
	MOVWF       FARG_minimum___v1+0 
	MOVF        SendDescriptorToEP0_Len+1, 0 
	MOVWF       FARG_minimum___v1+1 
	MOVLW       64
	MOVWF       FARG_minimum___v2+0 
	MOVLW       0
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       SendDescriptorToEP0_Len+0 
	MOVF        R1, 0 
	MOVWF       SendDescriptorToEP0_Len+1 
;USB_Library_Core_NA.mpas,543 :: 		I := 0;
	CLRF        SendDescriptorToEP0_I+0 
;USB_Library_Core_NA.mpas,544 :: 		while I < Len do
L__SendDescriptorToEP049:
	MOVLW       0
	MOVWF       R0 
	MOVF        SendDescriptorToEP0_Len+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__SendDescriptorToEP0371
	MOVF        SendDescriptorToEP0_Len+0, 0 
	SUBWF       SendDescriptorToEP0_I+0, 0 
L__SendDescriptorToEP0371:
	BTFSC       STATUS+0, 0 
	GOTO        L__SendDescriptorToEP050
;USB_Library_Core_NA.mpas,546 :: 		Dst^:= DescriptorPointer^;
	MOVF        _DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        _DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        _DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       SendDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,547 :: 		Inc(Dst);
	INFSNZ      SendDescriptorToEP0_Dst+0, 1 
	INCF        SendDescriptorToEP0_Dst+1, 1 
;USB_Library_Core_NA.mpas,548 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       _DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      _DescriptorPointer+1, 1 
	ADDWFC      _DescriptorPointer+2, 1 
;USB_Library_Core_NA.mpas,549 :: 		inc(I);
	INCF        SendDescriptorToEP0_I+0, 1 
;USB_Library_Core_NA.mpas,550 :: 		end;
	GOTO        L__SendDescriptorToEP049
L__SendDescriptorToEP050:
;USB_Library_Core_NA.mpas,552 :: 		AdaptDescriptorBytes(Len);
	MOVF        SendDescriptorToEP0_Len+0, 0 
	MOVWF       FARG_AdaptDescriptorBytes_Len+0 
	CALL        USB_Library_Core_NA_AdaptDescriptorBytes+0, 0
;USB_Library_Core_NA.mpas,553 :: 		end;
L__SendDescriptorToEP047:
;USB_Library_Core_NA.mpas,555 :: 		if (DescriptorBytesRequested = 0) then UsbDeviceRequest := $FF;
	MOVLW       0
	XORWF       _DescriptorBytesRequested+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__SendDescriptorToEP0372
	MOVLW       0
	XORWF       _DescriptorBytesRequested+0, 0 
L__SendDescriptorToEP0372:
	BTFSS       STATUS+0, 2 
	GOTO        L__SendDescriptorToEP054
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
L__SendDescriptorToEP054:
;USB_Library_Core_NA.mpas,556 :: 		if (Len < EP0_PACKET_SIZE) then UsbDeviceRequest := $FF;
	MOVLW       0
	SUBWF       SendDescriptorToEP0_Len+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__SendDescriptorToEP0373
	MOVLW       64
	SUBWF       SendDescriptorToEP0_Len+0, 0 
L__SendDescriptorToEP0373:
	BTFSC       STATUS+0, 0 
	GOTO        L__SendDescriptorToEP057
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
L__SendDescriptorToEP057:
;USB_Library_Core_NA.mpas,558 :: 		BDEP0INCnt  := Len;
	MOVF        SendDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_Library_Core_NA.mpas,559 :: 		GiveEP0INtoSIE__; // send
	CALL        _GiveEP0INtoSIE__+0, 0
;USB_Library_Core_NA.mpas,560 :: 		end;
L_end_SendDescriptorToEP0:
	RETURN      0
; end of _SendDescriptorToEP0

USB_Library_Core_NA_SendStringDescriptorToEP0:

;USB_Library_Core_NA.mpas,566 :: 		begin
;USB_Library_Core_NA.mpas,568 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        1030, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+0 
	MOVF        1031, 0 
	MOVWF       SendStringDescriptorToEP0_Dst+1 
;USB_Library_Core_NA.mpas,569 :: 		Len := DescriptorBytesToSend;
	MOVF        _DescriptorBytesToSend+0, 0 
	MOVWF       SendStringDescriptorToEP0_Len+0 
	MOVF        _DescriptorBytesToSend+1, 0 
	MOVWF       SendStringDescriptorToEP0_Len+1 
;USB_Library_Core_NA.mpas,571 :: 		if (Len = 0)
	MOVLW       0
	XORWF       _DescriptorBytesToSend+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP0375
	MOVLW       0
	XORWF       _DescriptorBytesToSend+0, 0 
L_USB_Library_Core_NA_SendStringDescriptorToEP0375:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP061
;USB_Library_Core_NA.mpas,572 :: 		then UsbDeviceRequest := $FF // all bytes have been sent previous time
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP062
;USB_Library_Core_NA.mpas,575 :: 		else  // some left over of the descriptor is to be sent
L_USB_Library_Core_NA_SendStringDescriptorToEP061:
;USB_Library_Core_NA.mpas,577 :: 		Len := minimum__(Len, EP0_PACKET_SIZE);
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       FARG_minimum___v1+0 
	MOVF        SendStringDescriptorToEP0_Len+1, 0 
	MOVWF       FARG_minimum___v1+1 
	MOVLW       64
	MOVWF       FARG_minimum___v2+0 
	MOVLW       0
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       SendStringDescriptorToEP0_Len+0 
	MOVF        R1, 0 
	MOVWF       SendStringDescriptorToEP0_Len+1 
;USB_Library_Core_NA.mpas,579 :: 		I := 0;
	CLRF        SendStringDescriptorToEP0_I+0 
;USB_Library_Core_NA.mpas,580 :: 		if StartStringDescriptor then     // first send length byte and string descriptor identifier
	MOVF        _StartStringDescriptor+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP064
;USB_Library_Core_NA.mpas,582 :: 		Dst^ := Len;                    // length byte
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,583 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_Library_Core_NA.mpas,585 :: 		Dst^ := USB_STRING_DESCRIPTOR;  // descriptor identifcation
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVLW       3
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,586 :: 		inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_Library_Core_NA.mpas,588 :: 		I := 2;
	MOVLW       2
	MOVWF       SendStringDescriptorToEP0_I+0 
;USB_Library_Core_NA.mpas,589 :: 		StartStringDescriptor := false;
	CLRF        _StartStringDescriptor+0 
;USB_Library_Core_NA.mpas,590 :: 		end;
L_USB_Library_Core_NA_SendStringDescriptorToEP064:
;USB_Library_Core_NA.mpas,592 :: 		while I < Len do
L_USB_Library_Core_NA_SendStringDescriptorToEP067:
	MOVLW       0
	MOVWF       R0 
	MOVF        SendStringDescriptorToEP0_Len+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP0376
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	SUBWF       SendStringDescriptorToEP0_I+0, 0 
L_USB_Library_Core_NA_SendStringDescriptorToEP0376:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP068
;USB_Library_Core_NA.mpas,594 :: 		Dst^:= DescriptorPointer^;     // copy byte
	MOVF        _DescriptorPointer+0, 0 
	MOVWF       TBLPTRL 
	MOVF        _DescriptorPointer+1, 0 
	MOVWF       TBLPTRH 
	MOVF        _DescriptorPointer+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R0
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,595 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_Library_Core_NA.mpas,596 :: 		Inc(DescriptorPointer);
	MOVLW       1
	ADDWF       _DescriptorPointer+0, 1 
	MOVLW       0
	ADDWFC      _DescriptorPointer+1, 1 
	ADDWFC      _DescriptorPointer+2, 1 
;USB_Library_Core_NA.mpas,597 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_Library_Core_NA.mpas,599 :: 		Dst^:= 0;                     // and add zero
	MOVFF       SendStringDescriptorToEP0_Dst+0, FSR1L
	MOVFF       SendStringDescriptorToEP0_Dst+1, FSR1H
	CLRF        POSTINC1+0 
;USB_Library_Core_NA.mpas,600 :: 		Inc(Dst);
	INFSNZ      SendStringDescriptorToEP0_Dst+0, 1 
	INCF        SendStringDescriptorToEP0_Dst+1, 1 
;USB_Library_Core_NA.mpas,601 :: 		inc(I);
	INCF        SendStringDescriptorToEP0_I+0, 1 
;USB_Library_Core_NA.mpas,602 :: 		end;
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP067
L_USB_Library_Core_NA_SendStringDescriptorToEP068:
;USB_Library_Core_NA.mpas,604 :: 		AdaptDescriptorBytes(Len);
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       FARG_AdaptDescriptorBytes_Len+0 
	CALL        USB_Library_Core_NA_AdaptDescriptorBytes+0, 0
;USB_Library_Core_NA.mpas,605 :: 		end;
L_USB_Library_Core_NA_SendStringDescriptorToEP062:
;USB_Library_Core_NA.mpas,607 :: 		if (DescriptorBytesRequested = 0) then UsbDeviceRequest := $FF;
	MOVLW       0
	XORWF       _DescriptorBytesRequested+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP0377
	MOVLW       0
	XORWF       _DescriptorBytesRequested+0, 0 
L_USB_Library_Core_NA_SendStringDescriptorToEP0377:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP072
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
L_USB_Library_Core_NA_SendStringDescriptorToEP072:
;USB_Library_Core_NA.mpas,608 :: 		if (Len < EP0_PACKET_SIZE) then UsbDeviceRequest := $FF;
	MOVLW       0
	SUBWF       SendStringDescriptorToEP0_Len+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP0378
	MOVLW       64
	SUBWF       SendStringDescriptorToEP0_Len+0, 0 
L_USB_Library_Core_NA_SendStringDescriptorToEP0378:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_SendStringDescriptorToEP075
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
L_USB_Library_Core_NA_SendStringDescriptorToEP075:
;USB_Library_Core_NA.mpas,610 :: 		BDEP0INCnt  := Len;
	MOVF        SendStringDescriptorToEP0_Len+0, 0 
	MOVWF       1029 
;USB_Library_Core_NA.mpas,611 :: 		GiveEP0INtoSIE__; // send
	CALL        _GiveEP0INtoSIE__+0, 0
;USB_Library_Core_NA.mpas,612 :: 		end;
L_end_SendStringDescriptorToEP0:
	RETURN      0
; end of USB_Library_Core_NA_SendStringDescriptorToEP0

USB_Library_Core_NA_PrepareStringDescriptor:

;USB_Library_Core_NA.mpas,617 :: 		begin
;USB_Library_Core_NA.mpas,619 :: 		Len := 0;
	CLRF        PrepareStringDescriptor_Len+0 
	CLRF        PrepareStringDescriptor_Len+1 
;USB_Library_Core_NA.mpas,620 :: 		Tmp := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       PrepareStringDescriptor_Tmp+0 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       PrepareStringDescriptor_Tmp+1 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       PrepareStringDescriptor_Tmp+2 
;USB_Library_Core_NA.mpas,621 :: 		while Tmp^ > 0 do
L_USB_Library_Core_NA_PrepareStringDescriptor79:
	MOVF        PrepareStringDescriptor_Tmp+0, 0 
	MOVWF       TBLPTRL 
	MOVF        PrepareStringDescriptor_Tmp+1, 0 
	MOVWF       TBLPTRH 
	MOVF        PrepareStringDescriptor_Tmp+2, 0 
	MOVWF       TBLPTRU 
	TBLRD*+
	MOVFF       TABLAT+0, R1
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_PrepareStringDescriptor80
;USB_Library_Core_NA.mpas,623 :: 		inc(Len);
	INFSNZ      PrepareStringDescriptor_Len+0, 1 
	INCF        PrepareStringDescriptor_Len+1, 1 
;USB_Library_Core_NA.mpas,624 :: 		inc(Tmp);
	MOVLW       1
	ADDWF       PrepareStringDescriptor_Tmp+0, 1 
	MOVLW       0
	ADDWFC      PrepareStringDescriptor_Tmp+1, 1 
	ADDWFC      PrepareStringDescriptor_Tmp+2, 1 
;USB_Library_Core_NA.mpas,625 :: 		end;
	GOTO        L_USB_Library_Core_NA_PrepareStringDescriptor79
L_USB_Library_Core_NA_PrepareStringDescriptor80:
;USB_Library_Core_NA.mpas,626 :: 		Len := (2 * Len) + 2;
	MOVF        PrepareStringDescriptor_Len+0, 0 
	MOVWF       R0 
	MOVF        PrepareStringDescriptor_Len+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       2
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       PrepareStringDescriptor_Len+0 
	MOVF        R1, 0 
	MOVWF       PrepareStringDescriptor_Len+1 
;USB_Library_Core_NA.mpas,628 :: 		DescriptorPointer        := Src;
	MOVF        FARG_PrepareStringDescriptor_Src+0, 0 
	MOVWF       _DescriptorPointer+0 
	MOVF        FARG_PrepareStringDescriptor_Src+1, 0 
	MOVWF       _DescriptorPointer+1 
	MOVF        FARG_PrepareStringDescriptor_Src+2, 0 
	MOVWF       _DescriptorPointer+2 
;USB_Library_Core_NA.mpas,629 :: 		DescriptorBytesToSend    := Len;
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,630 :: 		DescriptorBytesRequested := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_Library_Core_NA.mpas,631 :: 		DescriptorBytesToSend    := minimum__(DescriptorBytesToSend, DescriptorBytesRequested);
	MOVF        R0, 0 
	MOVWF       FARG_minimum___v1+0 
	MOVF        R1, 0 
	MOVWF       FARG_minimum___v1+1 
	MOVF        _SetUpPacket+6, 0 
	MOVWF       FARG_minimum___v2+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,632 :: 		StartStringDescriptor    := true;
	MOVLW       255
	MOVWF       _StartStringDescriptor+0 
;USB_Library_Core_NA.mpas,633 :: 		UsbDeviceRequest         := USB_GET_STRING_DESCRIPTOR_ONGOING;
	MOVLW       2
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,634 :: 		end;
L_end_PrepareStringDescriptor:
	RETURN      0
; end of USB_Library_Core_NA_PrepareStringDescriptor

USB_Library_Core_NA_PrepareDeviceDescriptor:

;USB_Library_Core_NA.mpas,637 :: 		begin
;USB_Library_Core_NA.mpas,638 :: 		DescriptorPointer        := @DeviceDescriptor;
	MOVLW       _DeviceDescriptor+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_DeviceDescriptor+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_DeviceDescriptor+0)
	MOVWF       _DescriptorPointer+2 
;USB_Library_Core_NA.mpas,639 :: 		DescriptorBytesToSend    := SizeOf(DeviceDescriptor);
	MOVLW       18
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,640 :: 		DescriptorBytesRequested := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_Library_Core_NA.mpas,641 :: 		DescriptorBytesToSend    := minimum__(DescriptorBytesToSend, DescriptorBytesRequested);
	MOVLW       18
	MOVWF       FARG_minimum___v1+0 
	MOVLW       0
	MOVWF       FARG_minimum___v1+1 
	MOVF        _SetUpPacket+6, 0 
	MOVWF       FARG_minimum___v2+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,642 :: 		UsbDeviceRequest         := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,643 :: 		end;
L_end_PrepareDeviceDescriptor:
	RETURN      0
; end of USB_Library_Core_NA_PrepareDeviceDescriptor

USB_Library_Core_NA_PrepareConfigDescriptor:

;USB_Library_Core_NA.mpas,646 :: 		begin
;USB_Library_Core_NA.mpas,647 :: 		DescriptorPointer        := @ConfigurationDescriptor;
	MOVLW       _ConfigurationDescriptor+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_ConfigurationDescriptor+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_ConfigurationDescriptor+0)
	MOVWF       _DescriptorPointer+2 
;USB_Library_Core_NA.mpas,648 :: 		DescriptorBytesToSend    := SizeOf(ConfigurationDescriptor);
	MOVLW       113
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,649 :: 		DescriptorBytesRequested := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_Library_Core_NA.mpas,650 :: 		DescriptorBytesToSend    := minimum__(DescriptorBytesToSend, DescriptorBytesRequested);
	MOVLW       113
	MOVWF       FARG_minimum___v1+0 
	MOVLW       0
	MOVWF       FARG_minimum___v1+1 
	MOVF        _SetUpPacket+6, 0 
	MOVWF       FARG_minimum___v2+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,651 :: 		UsbDeviceRequest         := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,652 :: 		end;
L_end_PrepareConfigDescriptor:
	RETURN      0
; end of USB_Library_Core_NA_PrepareConfigDescriptor

USB_Library_Core_NA_GetDescriptor:

;USB_Library_Core_NA.mpas,657 :: 		begin
;USB_Library_Core_NA.mpas,658 :: 		Index := Lo(SetUpPacket.wValue);
	MOVF        _SetUpPacket+2, 0 
	MOVWF       GetDescriptor_Index+0 
;USB_Library_Core_NA.mpas,682 :: 		USB_DEVICE_DESCRIPTOR        : // GetDeviceDescriptor
	MOVF        _SetUpPacket+3, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor89
;USB_Library_Core_NA.mpas,687 :: 		PrepareDeviceDescriptor;
	CALL        USB_Library_Core_NA_PrepareDeviceDescriptor+0, 0
;USB_Library_Core_NA.mpas,688 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,689 :: 		SendDescriptorToEP0;
	CALL        _SendDescriptorToEP0+0, 0
;USB_Library_Core_NA.mpas,690 :: 		end;
	GOTO        L_USB_Library_Core_NA_GetDescriptor86
L_USB_Library_Core_NA_GetDescriptor89:
;USB_Library_Core_NA.mpas,692 :: 		USB_CONFIGURATION_DESCRIPTOR : // GetConfigDescriptor;
	MOVF        _SetUpPacket+3, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor92
;USB_Library_Core_NA.mpas,694 :: 		PrepareConfigDescriptor;
	CALL        USB_Library_Core_NA_PrepareConfigDescriptor+0, 0
;USB_Library_Core_NA.mpas,695 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,696 :: 		SendDescriptorToEP0;
	CALL        _SendDescriptorToEP0+0, 0
;USB_Library_Core_NA.mpas,697 :: 		end;
	GOTO        L_USB_Library_Core_NA_GetDescriptor86
L_USB_Library_Core_NA_GetDescriptor92:
;USB_Library_Core_NA.mpas,699 :: 		USB_STRING_DESCRIPTOR        : // GetStringDescriptor(Index);
	MOVF        _SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor95
;USB_Library_Core_NA.mpas,705 :: 		if Index <= 3 then  // 4 strings in total
	MOVF        GetDescriptor_Index+0, 0 
	SUBLW       3
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_GetDescriptor97
;USB_Library_Core_NA.mpas,708 :: 		0: //
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor102
;USB_Library_Core_NA.mpas,710 :: 		DescriptorPointer        := @LanguageString;
	MOVLW       _LanguageString+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_LanguageString+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_LanguageString+0)
	MOVWF       _DescriptorPointer+2 
;USB_Library_Core_NA.mpas,711 :: 		DescriptorBytesToSend    := SizeOf(LanguageString);
	MOVLW       4
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,712 :: 		DescriptorBytesRequested := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_Library_Core_NA.mpas,713 :: 		DescriptorBytesToSend    := minimum__(DescriptorBytesToSend, DescriptorBytesRequested);
	MOVLW       4
	MOVWF       FARG_minimum___v1+0 
	MOVLW       0
	MOVWF       FARG_minimum___v1+1 
	MOVF        _SetUpPacket+6, 0 
	MOVWF       FARG_minimum___v2+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_Library_Core_NA.mpas,714 :: 		UsbDeviceRequest         := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,715 :: 		end;
	GOTO        L_USB_Library_Core_NA_GetDescriptor99
L_USB_Library_Core_NA_GetDescriptor102:
;USB_Library_Core_NA.mpas,717 :: 		1: PrepareStringDescriptor(@UsbManufacturer);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor105
	MOVLW       _UsbManufacturer+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbManufacturer+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_Library_Core_NA_PrepareStringDescriptor+0, 0
	GOTO        L_USB_Library_Core_NA_GetDescriptor99
L_USB_Library_Core_NA_GetDescriptor105:
;USB_Library_Core_NA.mpas,718 :: 		2: PrepareStringDescriptor(@UsbProduct);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor108
	MOVLW       _UsbProduct+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbProduct+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_Library_Core_NA_PrepareStringDescriptor+0, 0
	GOTO        L_USB_Library_Core_NA_GetDescriptor99
L_USB_Library_Core_NA_GetDescriptor108:
;USB_Library_Core_NA.mpas,719 :: 		3: PrepareStringDescriptor(@UsbSerialNo);
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor111
	MOVLW       _UsbSerialNo+0
	MOVWF       FARG_PrepareStringDescriptor_Src+0 
	MOVLW       hi_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+1 
	MOVLW       higher_addr(_UsbSerialNo+0)
	MOVWF       FARG_PrepareStringDescriptor_Src+2 
	CALL        USB_Library_Core_NA_PrepareStringDescriptor+0, 0
	GOTO        L_USB_Library_Core_NA_GetDescriptor99
L_USB_Library_Core_NA_GetDescriptor111:
L_USB_Library_Core_NA_GetDescriptor99:
;USB_Library_Core_NA.mpas,722 :: 		EP0OutReset(USB_DAT1);          // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,723 :: 		if Index = 0
	MOVF        GetDescriptor_Index+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor113
;USB_Library_Core_NA.mpas,724 :: 		then SendDescriptorToEP0        // special case
	CALL        _SendDescriptorToEP0+0, 0
	GOTO        L_USB_Library_Core_NA_GetDescriptor114
;USB_Library_Core_NA.mpas,725 :: 		else SendStringDescriptorToEP0;
L_USB_Library_Core_NA_GetDescriptor113:
	CALL        USB_Library_Core_NA_SendStringDescriptorToEP0+0, 0
L_USB_Library_Core_NA_GetDescriptor114:
;USB_Library_Core_NA.mpas,726 :: 		end
	GOTO        L_USB_Library_Core_NA_GetDescriptor98
;USB_Library_Core_NA.mpas,728 :: 		else StallEP0;
L_USB_Library_Core_NA_GetDescriptor97:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_GetDescriptor98:
;USB_Library_Core_NA.mpas,729 :: 		end;
	GOTO        L_USB_Library_Core_NA_GetDescriptor86
L_USB_Library_Core_NA_GetDescriptor95:
;USB_Library_Core_NA.mpas,731 :: 		USB_INTERFACE_DESCRIPTOR: //
	MOVF        _SetUpPacket+3, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor117
;USB_Library_Core_NA.mpas,736 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,737 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,738 :: 		end;
	GOTO        L_USB_Library_Core_NA_GetDescriptor86
L_USB_Library_Core_NA_GetDescriptor117:
;USB_Library_Core_NA.mpas,740 :: 		USB_ENDPOINT_DESCRIPTOR: //
	MOVF        _SetUpPacket+3, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor120
;USB_Library_Core_NA.mpas,745 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,746 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,749 :: 		else
	GOTO        L_USB_Library_Core_NA_GetDescriptor86
L_USB_Library_Core_NA_GetDescriptor120:
;USB_Library_Core_NA.mpas,751 :: 		if not GetClassSpecificDescriptor then
	CALL        _GetClassSpecificDescriptor+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_GetDescriptor122
;USB_Library_Core_NA.mpas,753 :: 		StallEP0;  // no valid descriptor request;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,757 :: 		end;
L_USB_Library_Core_NA_GetDescriptor122:
;USB_Library_Core_NA.mpas,758 :: 		end;
L_USB_Library_Core_NA_GetDescriptor86:
;USB_Library_Core_NA.mpas,760 :: 		end;
L_end_GetDescriptor:
	RETURN      0
; end of USB_Library_Core_NA_GetDescriptor

USB_Library_Core_NA_TokenOutPID:

;USB_Library_Core_NA.mpas,764 :: 		begin
;USB_Library_Core_NA.mpas,766 :: 		Ep := (USTATCopy shr 3) and $0F; // get endpoint
	MOVF        _USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       TokenOutPID_Ep+0 
;USB_Library_Core_NA.mpas,773 :: 		if (EP > 0)
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_TokenOutPID126
;USB_Library_Core_NA.mpas,774 :: 		then ClassTokenOut(Ep) // surely a class specific token out
	MOVF        TokenOutPID_Ep+0, 0 
	MOVWF       FARG_ClassTokenOut_Ep+0 
	CALL        _ClassTokenOut+0, 0
	GOTO        L_USB_Library_Core_NA_TokenOutPID127
;USB_Library_Core_NA.mpas,776 :: 		else
L_USB_Library_Core_NA_TokenOutPID126:
;USB_Library_Core_NA.mpas,779 :: 		if (Ep = 0) and (BDEP0OUTCnt = 0) then  // ZLP received , reset EP0 out, ready for reception
	MOVF        TokenOutPID_Ep+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        1025, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenOutPID129
;USB_Library_Core_NA.mpas,781 :: 		EP0OutReset(USB_DAT0);  // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,785 :: 		exit;
	GOTO        L_end_USB_Library_Core_NA_TokenOutPID
;USB_Library_Core_NA.mpas,786 :: 		end;
L_USB_Library_Core_NA_TokenOutPID129:
;USB_Library_Core_NA.mpas,788 :: 		ClassTokenOut(Ep); // some classes also use EP0
	MOVF        TokenOutPID_Ep+0, 0 
	MOVWF       FARG_ClassTokenOut_Ep+0 
	CALL        _ClassTokenOut+0, 0
;USB_Library_Core_NA.mpas,790 :: 		if (BDEP0OutCnt < EP0_PACKET_SIZE) then                // this was the last packet
	MOVLW       0
	MOVWF       R0 
	MOVLW       0
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenOutPID384
	MOVLW       64
	SUBWF       1025, 0 
L_USB_Library_Core_NA_TokenOutPID384:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_TokenOutPID132
;USB_Library_Core_NA.mpas,792 :: 		EP0OutReset(USB_DAT0); // reset EP0 to its initial state
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,793 :: 		SendZeroLenPacket;
	CALL        USB_Library_Core_NA_SendZeroLenPacket+0, 0
;USB_Library_Core_NA.mpas,794 :: 		end
	GOTO        L_USB_Library_Core_NA_TokenOutPID133
;USB_Library_Core_NA.mpas,795 :: 		else
L_USB_Library_Core_NA_TokenOutPID132:
;USB_Library_Core_NA.mpas,797 :: 		GiveEP0OUTtoSIE__; // toggle the DTS bit and set DTSEN and USB_USIE (give to SIE = prepare to receive data)
	CALL        _GiveEP0OUTtoSIE__+0, 0
;USB_Library_Core_NA.mpas,798 :: 		end;
L_USB_Library_Core_NA_TokenOutPID133:
;USB_Library_Core_NA.mpas,800 :: 		end;
L_USB_Library_Core_NA_TokenOutPID127:
;USB_Library_Core_NA.mpas,801 :: 		end;
L_end_USB_Library_Core_NA_TokenOutPID:
L_end_TokenOutPID:
	RETURN      0
; end of USB_Library_Core_NA_TokenOutPID

USB_Library_Core_NA_TokenInPID:

;USB_Library_Core_NA.mpas,805 :: 		begin
;USB_Library_Core_NA.mpas,807 :: 		Ep := (USTATCopy shr 3) and $0F; // get endpoint
	MOVF        _USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       TokenInPID_Ep+0 
;USB_Library_Core_NA.mpas,814 :: 		if EP > 0
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_TokenInPID136
;USB_Library_Core_NA.mpas,815 :: 		then ClassTokenIn(Ep) // surely a class token IN
	MOVF        TokenInPID_Ep+0, 0 
	MOVWF       FARG_ClassTokenIn_Ep+0 
	CALL        _ClassTokenIn+0, 0
	GOTO        L_USB_Library_Core_NA_TokenInPID137
;USB_Library_Core_NA.mpas,816 :: 		else
L_USB_Library_Core_NA_TokenInPID136:
;USB_Library_Core_NA.mpas,822 :: 		USB_GET_DESCRIPTOR_ONGOING: SendDescriptorToEP0;
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenInPID141
	CALL        _SendDescriptorToEP0+0, 0
	GOTO        L_USB_Library_Core_NA_TokenInPID138
L_USB_Library_Core_NA_TokenInPID141:
;USB_Library_Core_NA.mpas,824 :: 		USB_GET_STRING_DESCRIPTOR_ONGOING: SendStringDescriptorToEP0;
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenInPID144
	CALL        USB_Library_Core_NA_SendStringDescriptorToEP0+0, 0
	GOTO        L_USB_Library_Core_NA_TokenInPID138
L_USB_Library_Core_NA_TokenInPID144:
;USB_Library_Core_NA.mpas,826 :: 		USB_SET_ADDRESS_ONGOING:      //  FinishSetAddress;
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenInPID147
;USB_Library_Core_NA.mpas,828 :: 		UsbDeviceRequest := $FF;    // clear current device request
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,829 :: 		UsbCurrentConfig := 0;      // clear configuration
	CLRF        _UsbCurrentConfig+0 
;USB_Library_Core_NA.mpas,830 :: 		UADDR := UsbAddressPending; // set USB Address
	MOVF        _UsbAddressPending+0, 0 
	MOVWF       UADDR+0 
;USB_Library_Core_NA.mpas,831 :: 		if UsbAddressPending > 0
	MOVF        _UsbAddressPending+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_TokenInPID149
;USB_Library_Core_NA.mpas,832 :: 		then UsbDeviceEnumState := USB_ADDRESS_STATE; // change status
	MOVLW       2
	MOVWF       _UsbDeviceEnumState+0 
L_USB_Library_Core_NA_TokenInPID149:
;USB_Library_Core_NA.mpas,839 :: 		else ClassTokenIn(Ep); // some classes may use EP0 Token IN
	GOTO        L_USB_Library_Core_NA_TokenInPID138
L_USB_Library_Core_NA_TokenInPID147:
	MOVF        TokenInPID_Ep+0, 0 
	MOVWF       FARG_ClassTokenIn_Ep+0 
	CALL        _ClassTokenIn+0, 0
L_USB_Library_Core_NA_TokenInPID138:
;USB_Library_Core_NA.mpas,842 :: 		end;
L_USB_Library_Core_NA_TokenInPID137:
;USB_Library_Core_NA.mpas,844 :: 		end;
L_end_TokenInPID:
	RETURN      0
; end of USB_Library_Core_NA_TokenInPID

USB_Library_Core_NA_Bit__:

;USB_Library_Core_NA.mpas,847 :: 		begin
;USB_Library_Core_NA.mpas,848 :: 		Result := 0;
	CLRF        R1 
;USB_Library_Core_NA.mpas,849 :: 		if B > 0 then result := 1;
	MOVF        FARG_Bit___B+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_Bit__153
	MOVLW       1
	MOVWF       R1 
L_USB_Library_Core_NA_Bit__153:
;USB_Library_Core_NA.mpas,850 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_Bit__:
	RETURN      0
; end of USB_Library_Core_NA_Bit__

USB_Library_Core_NA_CalcEp:

;USB_Library_Core_NA.mpas,853 :: 		begin
;USB_Library_Core_NA.mpas,854 :: 		TmpEp_  := Ep_ and $0f;                    // endpoint 0..15
	MOVFF       FARG_CalcEp_TmpEp_+0, FSR1L
	MOVFF       FARG_CalcEp_TmpEp_+1, FSR1H
	MOVLW       15
	ANDWF       FARG_CalcEp_Ep_+0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,855 :: 		TmpDir_ := Ep_ and $80;                    // endpoint direction: 0 = OUT; $80 = IN
	MOVFF       FARG_CalcEp_TmpDir_+0, FSR1L
	MOVFF       FARG_CalcEp_TmpDir_+1, FSR1H
	MOVLW       128
	ANDWF       FARG_CalcEp_Ep_+0, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,856 :: 		TmpUEP_ := @UEP0 + TmpEp_;                 // UEPx address of TmpEP_
	MOVFF       FARG_CalcEp_TmpEp_+0, FSR0L
	MOVFF       FARG_CalcEp_TmpEp_+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVLW       UEP0+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(UEP0+0)
	ADDWFC      R1, 1 
	MOVFF       FARG_CalcEp_TmpUep_+0, FSR1L
	MOVFF       FARG_CalcEp_TmpUep_+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,857 :: 		TmpStat_ := @BDEP0OUTStat + (TmpEP_ * 8);  // address of bufferdescriptor status of TmpEP_; TmpDir_
	MOVFF       FARG_CalcEp_TmpEp_+0, FSR0L
	MOVFF       FARG_CalcEp_TmpEp_+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVLW       3
	MOVWF       R2 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L_USB_Library_Core_NA_CalcEp388:
	BZ          L_USB_Library_Core_NA_CalcEp389
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L_USB_Library_Core_NA_CalcEp388
L_USB_Library_Core_NA_CalcEp389:
	MOVFF       FARG_CalcEp_TmpStat_+0, FSR1L
	MOVFF       FARG_CalcEp_TmpStat_+1, FSR1H
	MOVLW       0
	ADDWF       R0, 0 
	MOVWF       POSTINC1+0 
	MOVLW       4
	ADDWFC      R1, 0 
	MOVWF       POSTINC1+0 
;USB_Library_Core_NA.mpas,858 :: 		if TmpDir_ = $80 then TmpStat_ := TmpStat_ + 4;
	MOVFF       FARG_CalcEp_TmpDir_+0, FSR0L
	MOVFF       FARG_CalcEp_TmpDir_+1, FSR0H
	MOVF        POSTINC0+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_CalcEp157
	MOVFF       FARG_CalcEp_TmpStat_+0, FSR0L
	MOVFF       FARG_CalcEp_TmpStat_+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       4
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVFF       FARG_CalcEp_TmpStat_+0, FSR1L
	MOVFF       FARG_CalcEp_TmpStat_+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
L_USB_Library_Core_NA_CalcEp157:
;USB_Library_Core_NA.mpas,859 :: 		end;
L_end_CalcEp:
	RETURN      0
; end of USB_Library_Core_NA_CalcEp

USB_Library_Core_NA_StandardRequest:

;USB_Library_Core_NA.mpas,865 :: 		begin
;USB_Library_Core_NA.mpas,868 :: 		USB_STD_HOST_TO_DEVICE: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest163
;USB_Library_Core_NA.mpas,872 :: 		USB_CLEAR_FEATURE:      // ClearDeviceFeature;
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest167
;USB_Library_Core_NA.mpas,874 :: 		if SetUpPacket.wValue = USB_DEVICE_REMOTE_WAKEUP then // device remote wakeup
	MOVLW       0
	XORWF       _SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest391
	MOVLW       1
	XORWF       _SetUpPacket+2, 0 
L_USB_Library_Core_NA_StandardRequest391:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest169
;USB_Library_Core_NA.mpas,876 :: 		Usb_Status_Device.1 := 0;
	BCF         _Usb_Status_Device+0, 1 
;USB_Library_Core_NA.mpas,877 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,878 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,879 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest170
;USB_Library_Core_NA.mpas,880 :: 		else
L_USB_Library_Core_NA_StandardRequest169:
;USB_Library_Core_NA.mpas,882 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,886 :: 		end;
L_USB_Library_Core_NA_StandardRequest170:
;USB_Library_Core_NA.mpas,887 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest164
L_USB_Library_Core_NA_StandardRequest167:
;USB_Library_Core_NA.mpas,889 :: 		USB_SET_ADDRESS:        //SetAddress;
	MOVF        _SetUpPacket+1, 0 
	XORLW       5
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest173
;USB_Library_Core_NA.mpas,891 :: 		UsbDeviceRequest := USB_SET_ADDRESS_ONGOING;
	MOVLW       3
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,892 :: 		UsbAddressPending := SetUpPacket.wValue; // USB address
	MOVF        _SetUpPacket+2, 0 
	MOVWF       _UsbAddressPending+0 
;USB_Library_Core_NA.mpas,893 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,894 :: 		BDEP0INCnt  := 0;
	CLRF        1029 
;USB_Library_Core_NA.mpas,895 :: 		BDEP0INStat := (USB_USIE or USB_DAT1 or USB_DTSEN); // echo the buffer
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,896 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest164
L_USB_Library_Core_NA_StandardRequest173:
;USB_Library_Core_NA.mpas,898 :: 		USB_SET_CONFIGURATION:  // SetConfiguration;
	MOVF        _SetUpPacket+1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest176
;USB_Library_Core_NA.mpas,900 :: 		Config := Lo(SetUpPacket.wValue);
	MOVF        _SetUpPacket+2, 0 
	MOVWF       StandardRequest_Config+0 
;USB_Library_Core_NA.mpas,901 :: 		if Config <= USB_NUM_CONFIGURATIONS then
	MOVF        _SetUpPacket+2, 0 
	SUBLW       1
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest178
;USB_Library_Core_NA.mpas,903 :: 		UsbCurrentConfig := Config;   // set configuration
	MOVF        StandardRequest_Config+0, 0 
	MOVWF       _UsbCurrentConfig+0 
;USB_Library_Core_NA.mpas,904 :: 		if Config > 0 then
	MOVF        StandardRequest_Config+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest181
;USB_Library_Core_NA.mpas,906 :: 		UsbDeviceEnumState := USB_CONFIG_STATE;
	MOVLW       3
	MOVWF       _UsbDeviceEnumState+0 
;USB_Library_Core_NA.mpas,907 :: 		ClassSetupEndPoints;
	CALL        _ClassSetupEndPoints+0, 0
;USB_Library_Core_NA.mpas,908 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest182
;USB_Library_Core_NA.mpas,909 :: 		else UsbDeviceEnumState := USB_ADDRESS_STATE;
L_USB_Library_Core_NA_StandardRequest181:
	MOVLW       2
	MOVWF       _UsbDeviceEnumState+0 
L_USB_Library_Core_NA_StandardRequest182:
;USB_Library_Core_NA.mpas,910 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,911 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,912 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest179
;USB_Library_Core_NA.mpas,913 :: 		else
L_USB_Library_Core_NA_StandardRequest178:
;USB_Library_Core_NA.mpas,915 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,919 :: 		end;
L_USB_Library_Core_NA_StandardRequest179:
;USB_Library_Core_NA.mpas,920 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest164
L_USB_Library_Core_NA_StandardRequest176:
;USB_Library_Core_NA.mpas,922 :: 		USB_SET_FEATURE:        // SetDeviceFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest185
;USB_Library_Core_NA.mpas,924 :: 		if SetUpPacket.wValue = 1 then // device remote wakeup
	MOVLW       0
	XORWF       _SetUpPacket+3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest392
	MOVLW       1
	XORWF       _SetUpPacket+2, 0 
L_USB_Library_Core_NA_StandardRequest392:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest187
;USB_Library_Core_NA.mpas,929 :: 		Usb_Status_Device.1 := 1;  // remote wakeup
	BSF         _Usb_Status_Device+0, 1 
;USB_Library_Core_NA.mpas,930 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,931 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,932 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest188
;USB_Library_Core_NA.mpas,933 :: 		else
L_USB_Library_Core_NA_StandardRequest187:
;USB_Library_Core_NA.mpas,935 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,939 :: 		end;
L_USB_Library_Core_NA_StandardRequest188:
;USB_Library_Core_NA.mpas,942 :: 		else
	GOTO        L_USB_Library_Core_NA_StandardRequest164
L_USB_Library_Core_NA_StandardRequest185:
;USB_Library_Core_NA.mpas,944 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,948 :: 		end;
L_USB_Library_Core_NA_StandardRequest164:
;USB_Library_Core_NA.mpas,950 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest160
L_USB_Library_Core_NA_StandardRequest163:
;USB_Library_Core_NA.mpas,952 :: 		USB_STD_HOST_TO_INTERFACE: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest191
;USB_Library_Core_NA.mpas,956 :: 		USB_CLEAR_FEATURE:      // ClearInterfaceFeature;
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest195
;USB_Library_Core_NA.mpas,961 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,962 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,963 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest192
L_USB_Library_Core_NA_StandardRequest195:
;USB_Library_Core_NA.mpas,965 :: 		USB_SET_INTERFACE:      // SetInterface;
	MOVF        _SetUpPacket+1, 0 
	XORLW       11
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest198
;USB_Library_Core_NA.mpas,970 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE then
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest200
;USB_Library_Core_NA.mpas,972 :: 		UsbInterface := SetupPacket.wIndex;
	MOVF        _SetUpPacket+4, 0 
	MOVWF       _UsbInterface+0 
;USB_Library_Core_NA.mpas,973 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,974 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,975 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest201
;USB_Library_Core_NA.mpas,976 :: 		else
L_USB_Library_Core_NA_StandardRequest200:
;USB_Library_Core_NA.mpas,978 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,982 :: 		end
L_USB_Library_Core_NA_StandardRequest201:
;USB_Library_Core_NA.mpas,983 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest192
L_USB_Library_Core_NA_StandardRequest198:
;USB_Library_Core_NA.mpas,985 :: 		USB_SET_FEATURE:        // SetInterfaceFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest204
;USB_Library_Core_NA.mpas,990 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,991 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,994 :: 		else
	GOTO        L_USB_Library_Core_NA_StandardRequest192
L_USB_Library_Core_NA_StandardRequest204:
;USB_Library_Core_NA.mpas,996 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1000 :: 		end;
L_USB_Library_Core_NA_StandardRequest192:
;USB_Library_Core_NA.mpas,1002 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest160
L_USB_Library_Core_NA_StandardRequest191:
;USB_Library_Core_NA.mpas,1004 :: 		USB_STD_HOST_TO_ENDPOINT: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest207
;USB_Library_Core_NA.mpas,1007 :: 		Ep := SetUpPacket.wIndex and $8F; // endpoint + direction
	MOVLW       143
	ANDWF       _SetUpPacket+4, 0 
	MOVWF       FARG_CalcEp_Ep_+0 
;USB_Library_Core_NA.mpas,1008 :: 		CalcEp(Ep, TmpEp, TmpDir, TmpUEP, TmpStat);
	MOVLW       StandardRequest_TmpEP+0
	MOVWF       FARG_CalcEp_TmpEp_+0 
	MOVLW       hi_addr(StandardRequest_TmpEP+0)
	MOVWF       FARG_CalcEp_TmpEp_+1 
	MOVLW       StandardRequest_TmpDir+0
	MOVWF       FARG_CalcEp_TmpDir_+0 
	MOVLW       hi_addr(StandardRequest_TmpDir+0)
	MOVWF       FARG_CalcEp_TmpDir_+1 
	MOVLW       StandardRequest_TmpUEP+0
	MOVWF       FARG_CalcEp_TmpUep_+0 
	MOVLW       hi_addr(StandardRequest_TmpUEP+0)
	MOVWF       FARG_CalcEp_TmpUep_+1 
	MOVLW       StandardRequest_TmpStat+0
	MOVWF       FARG_CalcEp_TmpStat_+0 
	MOVLW       hi_addr(StandardRequest_TmpStat+0)
	MOVWF       FARG_CalcEp_TmpStat_+1 
	CALL        USB_Library_Core_NA_CalcEp+0, 0
;USB_Library_Core_NA.mpas,1012 :: 		USB_CLEAR_FEATURE:      // ClearEndpointFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest211
;USB_Library_Core_NA.mpas,1018 :: 		if TmpEP <= 4 then
	MOVF        StandardRequest_TmpEP+0, 0 
	SUBLW       4
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest213
;USB_Library_Core_NA.mpas,1021 :: 		0:   if TmpUEP^ > 0 then TmpStat^ := (USB_USIE or USB_DAT0 or USB_DTSEN) else StallEP0; // EP OUT; clear endpoint stall condition
	MOVF        StandardRequest_TmpDir+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest218
	MOVFF       StandardRequest_TmpUEP+0, FSR0L
	MOVFF       StandardRequest_TmpUEP+1, FSR0H
	MOVF        POSTINC0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest220
	MOVFF       StandardRequest_TmpStat+0, FSR1L
	MOVFF       StandardRequest_TmpStat+1, FSR1H
	MOVLW       136
	MOVWF       POSTINC1+0 
	GOTO        L_USB_Library_Core_NA_StandardRequest221
L_USB_Library_Core_NA_StandardRequest220:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest221:
	GOTO        L_USB_Library_Core_NA_StandardRequest215
L_USB_Library_Core_NA_StandardRequest218:
;USB_Library_Core_NA.mpas,1022 :: 		$80: if TmpUEP^ > 0 then TmpStat^ := (USB_UCPU or USB_DAT0 or USB_DTSEN) else StallEP0; // EP IN; clear endpoint stall condition
	MOVF        StandardRequest_TmpDir+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest224
	MOVFF       StandardRequest_TmpUEP+0, FSR0L
	MOVFF       StandardRequest_TmpUEP+1, FSR0H
	MOVF        POSTINC0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest226
	MOVFF       StandardRequest_TmpStat+0, FSR1L
	MOVFF       StandardRequest_TmpStat+1, FSR1H
	MOVLW       8
	MOVWF       POSTINC1+0 
	GOTO        L_USB_Library_Core_NA_StandardRequest227
L_USB_Library_Core_NA_StandardRequest226:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest227:
	GOTO        L_USB_Library_Core_NA_StandardRequest215
L_USB_Library_Core_NA_StandardRequest224:
L_USB_Library_Core_NA_StandardRequest215:
;USB_Library_Core_NA.mpas,1024 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest214
;USB_Library_Core_NA.mpas,1025 :: 		else StallEP0;
L_USB_Library_Core_NA_StandardRequest213:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest214:
;USB_Library_Core_NA.mpas,1027 :: 		if not EP0Stalled then
	CALL        USB_Library_Core_NA_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest229
;USB_Library_Core_NA.mpas,1029 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1030 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,1031 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest230
;USB_Library_Core_NA.mpas,1032 :: 		else
L_USB_Library_Core_NA_StandardRequest229:
;USB_Library_Core_NA.mpas,1037 :: 		end;
L_USB_Library_Core_NA_StandardRequest230:
;USB_Library_Core_NA.mpas,1038 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest208
L_USB_Library_Core_NA_StandardRequest211:
;USB_Library_Core_NA.mpas,1040 :: 		USB_SET_FEATURE:        // SetEndpointFeature
	MOVF        _SetUpPacket+1, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest233
;USB_Library_Core_NA.mpas,1046 :: 		if TmpEP <= 4 then
	MOVF        StandardRequest_TmpEP+0, 0 
	SUBLW       4
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest235
;USB_Library_Core_NA.mpas,1048 :: 		if TmpUEP^ > 0 then TmpStat^ := (USB_USIE or USB_BSTALL) else StallEP0; // stall endpoint
	MOVFF       StandardRequest_TmpUEP+0, FSR0L
	MOVFF       StandardRequest_TmpUEP+1, FSR0H
	MOVF        POSTINC0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest238
	MOVFF       StandardRequest_TmpStat+0, FSR1L
	MOVFF       StandardRequest_TmpStat+1, FSR1H
	MOVLW       132
	MOVWF       POSTINC1+0 
	GOTO        L_USB_Library_Core_NA_StandardRequest239
L_USB_Library_Core_NA_StandardRequest238:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest239:
;USB_Library_Core_NA.mpas,1049 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest236
;USB_Library_Core_NA.mpas,1050 :: 		else StallEP0;
L_USB_Library_Core_NA_StandardRequest235:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest236:
;USB_Library_Core_NA.mpas,1052 :: 		if not EP0Stalled then
	CALL        USB_Library_Core_NA_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest241
;USB_Library_Core_NA.mpas,1054 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1055 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,1056 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest242
;USB_Library_Core_NA.mpas,1057 :: 		else
L_USB_Library_Core_NA_StandardRequest241:
;USB_Library_Core_NA.mpas,1062 :: 		end;
L_USB_Library_Core_NA_StandardRequest242:
;USB_Library_Core_NA.mpas,1065 :: 		else
	GOTO        L_USB_Library_Core_NA_StandardRequest208
L_USB_Library_Core_NA_StandardRequest233:
;USB_Library_Core_NA.mpas,1067 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1071 :: 		end;
L_USB_Library_Core_NA_StandardRequest208:
;USB_Library_Core_NA.mpas,1073 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest160
L_USB_Library_Core_NA_StandardRequest207:
;USB_Library_Core_NA.mpas,1075 :: 		USB_STD_DEVICE_TO_HOST: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest245
;USB_Library_Core_NA.mpas,1079 :: 		USB_GET_CONFIGURATION:  // GetConfiguration;
	MOVF        _SetUpPacket+1, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest249
;USB_Library_Core_NA.mpas,1084 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_Library_Core_NA.mpas,1085 :: 		if UsbDeviceEnumState = USB_CONFIG_STATE
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest251
;USB_Library_Core_NA.mpas,1086 :: 		then BuffEP0IN[0] := UsbCurrentConfig;
	MOVF        _UsbCurrentConfig+0, 0 
	MOVWF       1344 
L_USB_Library_Core_NA_StandardRequest251:
;USB_Library_Core_NA.mpas,1087 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1088 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_Library_Core_NA.mpas,1089 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,1090 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest246
L_USB_Library_Core_NA_StandardRequest249:
;USB_Library_Core_NA.mpas,1092 :: 		USB_GET_DESCRIPTOR: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest255
;USB_Library_Core_NA.mpas,1097 :: 		GetDescriptor;
	CALL        USB_Library_Core_NA_GetDescriptor+0, 0
;USB_Library_Core_NA.mpas,1098 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest246
L_USB_Library_Core_NA_StandardRequest255:
;USB_Library_Core_NA.mpas,1100 :: 		USB_GET_STATUS:         // GetDeviceStatus
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest258
;USB_Library_Core_NA.mpas,1106 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1107 :: 		BuffEP0IN[0] := Usb_Status_Device;
	MOVF        _Usb_Status_Device+0, 0 
	MOVWF       1344 
;USB_Library_Core_NA.mpas,1108 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_Library_Core_NA.mpas,1109 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_Library_Core_NA.mpas,1110 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,1113 :: 		else
	GOTO        L_USB_Library_Core_NA_StandardRequest246
L_USB_Library_Core_NA_StandardRequest258:
;USB_Library_Core_NA.mpas,1115 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1119 :: 		end;
L_USB_Library_Core_NA_StandardRequest246:
;USB_Library_Core_NA.mpas,1121 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest160
L_USB_Library_Core_NA_StandardRequest245:
;USB_Library_Core_NA.mpas,1123 :: 		USB_STD_INTERFACE_TO_HOST: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       129
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest261
;USB_Library_Core_NA.mpas,1127 :: 		USB_GET_INTERFACE:      // GetInterface;
	MOVF        _SetUpPacket+1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest265
;USB_Library_Core_NA.mpas,1133 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest267
;USB_Library_Core_NA.mpas,1135 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1136 :: 		BuffEP0IN[0] := UsbInterface;
	MOVF        _UsbInterface+0, 0 
	MOVWF       1344 
;USB_Library_Core_NA.mpas,1137 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       1029 
;USB_Library_Core_NA.mpas,1138 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,1139 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest268
;USB_Library_Core_NA.mpas,1140 :: 		else
L_USB_Library_Core_NA_StandardRequest267:
;USB_Library_Core_NA.mpas,1142 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1146 :: 		end;
L_USB_Library_Core_NA_StandardRequest268:
;USB_Library_Core_NA.mpas,1147 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest262
L_USB_Library_Core_NA_StandardRequest265:
;USB_Library_Core_NA.mpas,1149 :: 		USB_GET_STATUS:         // GetInterfaceStatus;
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest271
;USB_Library_Core_NA.mpas,1154 :: 		if UsbDeviceEnumState <> USB_ADDRESS_STATE then
	MOVF        _UsbDeviceEnumState+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest273
;USB_Library_Core_NA.mpas,1156 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1157 :: 		BuffEP0IN[0] := 0;
	CLRF        1344 
;USB_Library_Core_NA.mpas,1158 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_Library_Core_NA.mpas,1159 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_Library_Core_NA.mpas,1160 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: send
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,1161 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest274
;USB_Library_Core_NA.mpas,1162 :: 		else
L_USB_Library_Core_NA_StandardRequest273:
;USB_Library_Core_NA.mpas,1164 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1168 :: 		end;
L_USB_Library_Core_NA_StandardRequest274:
;USB_Library_Core_NA.mpas,1169 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest262
L_USB_Library_Core_NA_StandardRequest271:
;USB_Library_Core_NA.mpas,1171 :: 		USB_GET_DESCRIPTOR: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest277
;USB_Library_Core_NA.mpas,1176 :: 		GetDescriptor;
	CALL        USB_Library_Core_NA_GetDescriptor+0, 0
;USB_Library_Core_NA.mpas,1179 :: 		else
	GOTO        L_USB_Library_Core_NA_StandardRequest262
L_USB_Library_Core_NA_StandardRequest277:
;USB_Library_Core_NA.mpas,1181 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1185 :: 		end;
L_USB_Library_Core_NA_StandardRequest262:
;USB_Library_Core_NA.mpas,1187 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest160
L_USB_Library_Core_NA_StandardRequest261:
;USB_Library_Core_NA.mpas,1189 :: 		USB_STD_ENDPOINT_TO_HOST: //
	MOVF        _SetUpPacket+0, 0 
	XORLW       130
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest280
;USB_Library_Core_NA.mpas,1192 :: 		Ep := SetUpPacket.wIndex and $8F;  // endpoint number
	MOVLW       143
	ANDWF       _SetUpPacket+4, 0 
	MOVWF       FARG_CalcEp_Ep_+0 
;USB_Library_Core_NA.mpas,1193 :: 		CalcEp(Ep, TmpEp, TmpDir, TmpUEP, TmpStat);
	MOVLW       StandardRequest_TmpEP+0
	MOVWF       FARG_CalcEp_TmpEp_+0 
	MOVLW       hi_addr(StandardRequest_TmpEP+0)
	MOVWF       FARG_CalcEp_TmpEp_+1 
	MOVLW       StandardRequest_TmpDir+0
	MOVWF       FARG_CalcEp_TmpDir_+0 
	MOVLW       hi_addr(StandardRequest_TmpDir+0)
	MOVWF       FARG_CalcEp_TmpDir_+1 
	MOVLW       StandardRequest_TmpUEP+0
	MOVWF       FARG_CalcEp_TmpUep_+0 
	MOVLW       hi_addr(StandardRequest_TmpUEP+0)
	MOVWF       FARG_CalcEp_TmpUep_+1 
	MOVLW       StandardRequest_TmpStat+0
	MOVWF       FARG_CalcEp_TmpStat_+0 
	MOVLW       hi_addr(StandardRequest_TmpStat+0)
	MOVWF       FARG_CalcEp_TmpStat_+1 
	CALL        USB_Library_Core_NA_CalcEp+0, 0
;USB_Library_Core_NA.mpas,1197 :: 		USB_GET_STATUS:         //GetEndpointStatus;
	MOVF        _SetUpPacket+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest284
;USB_Library_Core_NA.mpas,1203 :: 		BuffEP0IN[0] := 0; // default
	CLRF        1344 
;USB_Library_Core_NA.mpas,1205 :: 		if TmpEP <= 4 then
	MOVF        StandardRequest_TmpEP+0, 0 
	SUBLW       4
	BTFSS       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest286
;USB_Library_Core_NA.mpas,1207 :: 		if TmpUEP^ > 0 then BuffEP0IN[0] := bit__(TmpStat^ and USB_BSTALL) else StallEP0; // return 1 if endpoint stalled, else 0
	MOVFF       StandardRequest_TmpUEP+0, FSR0L
	MOVFF       StandardRequest_TmpUEP+1, FSR0H
	MOVF        POSTINC0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_Library_Core_NA_StandardRequest289
	MOVFF       StandardRequest_TmpStat+0, FSR0L
	MOVFF       StandardRequest_TmpStat+1, FSR0H
	MOVLW       4
	ANDWF       POSTINC0+0, 0 
	MOVWF       FARG_Bit___B+0 
	CALL        USB_Library_Core_NA_Bit__+0, 0
	MOVF        R0, 0 
	MOVWF       1344 
	GOTO        L_USB_Library_Core_NA_StandardRequest290
L_USB_Library_Core_NA_StandardRequest289:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest290:
;USB_Library_Core_NA.mpas,1208 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest287
;USB_Library_Core_NA.mpas,1209 :: 		else StallEP0;
L_USB_Library_Core_NA_StandardRequest286:
	CALL        _StallEP0+0, 0
L_USB_Library_Core_NA_StandardRequest287:
;USB_Library_Core_NA.mpas,1211 :: 		if not Ep0Stalled then
	CALL        USB_Library_Core_NA_EP0Stalled+0, 0
	COMF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest292
;USB_Library_Core_NA.mpas,1213 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1214 :: 		BuffEP0IN[1] := 0;
	CLRF        1345 
;USB_Library_Core_NA.mpas,1215 :: 		BDEP0INCnt   := 2;
	MOVLW       2
	MOVWF       1029 
;USB_Library_Core_NA.mpas,1216 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // data 1 packet, sets UOWN bit: go
	MOVLW       200
	MOVWF       1028 
;USB_Library_Core_NA.mpas,1217 :: 		end
	GOTO        L_USB_Library_Core_NA_StandardRequest293
;USB_Library_Core_NA.mpas,1218 :: 		else
L_USB_Library_Core_NA_StandardRequest292:
;USB_Library_Core_NA.mpas,1223 :: 		end;
L_USB_Library_Core_NA_StandardRequest293:
;USB_Library_Core_NA.mpas,1224 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest281
L_USB_Library_Core_NA_StandardRequest284:
;USB_Library_Core_NA.mpas,1226 :: 		USB_SYNCH_FRAME: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       12
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_StandardRequest296
;USB_Library_Core_NA.mpas,1231 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_Library_Core_NA.mpas,1232 :: 		SendAckToHost; // send acknowledge
	CALL        _SendAckToHost+0, 0
;USB_Library_Core_NA.mpas,1235 :: 		else
	GOTO        L_USB_Library_Core_NA_StandardRequest281
L_USB_Library_Core_NA_StandardRequest296:
;USB_Library_Core_NA.mpas,1237 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1241 :: 		end;
L_USB_Library_Core_NA_StandardRequest281:
;USB_Library_Core_NA.mpas,1245 :: 		end;
	GOTO        L_USB_Library_Core_NA_StandardRequest160
L_USB_Library_Core_NA_StandardRequest280:
L_USB_Library_Core_NA_StandardRequest160:
;USB_Library_Core_NA.mpas,1247 :: 		end;
L_end_StandardRequest:
	RETURN      0
; end of USB_Library_Core_NA_StandardRequest

USB_Library_Core_NA_TokenSetupPID:

;USB_Library_Core_NA.mpas,1251 :: 		begin
;USB_Library_Core_NA.mpas,1252 :: 		UsbDeviceRequest := $FF; // clear the device request
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_Library_Core_NA.mpas,1255 :: 		Dst := ^byte(@SetupPacket);
	MOVLW       _SetUpPacket+0
	MOVWF       TokenSetupPID_Dst+0 
	MOVLW       hi_addr(_SetUpPacket+0)
	MOVWF       TokenSetupPID_Dst+1 
;USB_Library_Core_NA.mpas,1256 :: 		Src := ^byte(BufferDescriptor^.Address);
	MOVLW       2
	ADDWF       _BufferDescriptor+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      _BufferDescriptor+1, 0 
	MOVWF       R1 
	MOVFF       R0, FSR0L
	MOVFF       R1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_MemCpy___From+1 
;USB_Library_Core_NA.mpas,1257 :: 		MemCpy__(Dst, Src, SizeOf(SetupPacket));
	MOVF        TokenSetupPID_Dst+0, 0 
	MOVWF       FARG_MemCpy___Towards+0 
	MOVF        TokenSetupPID_Dst+1, 0 
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       8
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_Library_Core_NA.mpas,1259 :: 		BDEP0OUTStat := 0; // disable EP0 out
	CLRF        1024 
;USB_Library_Core_NA.mpas,1260 :: 		EP0InReset;        // return the IN buffer to us (dequeue any pending requests)
	CALL        USB_Library_Core_NA_EP0InReset+0, 0
;USB_Library_Core_NA.mpas,1261 :: 		UCON.PKTDIS := 0;  // enable setup packets again
	BCF         UCON+0, 4 
;USB_Library_Core_NA.mpas,1296 :: 		case (SetUpPacket.bmRequestType and $60) shr 5 of
	MOVLW       96
	ANDWF       _SetUpPacket+0, 0 
	MOVWF       R1 
	MOVLW       5
	MOVWF       R0 
	MOVF        R1, 0 
	MOVWF       FLOC_USB_Library_Core_NA_TokenSetupPID+0 
	MOVF        R0, 0 
L_USB_Library_Core_NA_TokenSetupPID394:
	BZ          L_USB_Library_Core_NA_TokenSetupPID395
	RRCF        FLOC_USB_Library_Core_NA_TokenSetupPID+0, 1 
	BCF         FLOC_USB_Library_Core_NA_TokenSetupPID+0, 7 
	ADDLW       255
	GOTO        L_USB_Library_Core_NA_TokenSetupPID394
L_USB_Library_Core_NA_TokenSetupPID395:
;USB_Library_Core_NA.mpas,1297 :: 		USB_STANDARD:                      // Standard request
	MOVF        FLOC_USB_Library_Core_NA_TokenSetupPID+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenSetupPID301
;USB_Library_Core_NA.mpas,1299 :: 		StandardRequest;
	CALL        USB_Library_Core_NA_StandardRequest+0, 0
;USB_Library_Core_NA.mpas,1300 :: 		end;
	GOTO        L_USB_Library_Core_NA_TokenSetupPID298
L_USB_Library_Core_NA_TokenSetupPID301:
;USB_Library_Core_NA.mpas,1302 :: 		USB_CLASS: //
	MOVF        FLOC_USB_Library_Core_NA_TokenSetupPID+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenSetupPID304
;USB_Library_Core_NA.mpas,1307 :: 		ClassSpecificRequest;      // Class specific request
	CALL        _ClassSpecificRequest+0, 0
;USB_Library_Core_NA.mpas,1308 :: 		end;
	GOTO        L_USB_Library_Core_NA_TokenSetupPID298
L_USB_Library_Core_NA_TokenSetupPID304:
;USB_Library_Core_NA.mpas,1310 :: 		USB_VENDOR:                  // CheckforVendorRequest;
	MOVF        FLOC_USB_Library_Core_NA_TokenSetupPID+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_Library_Core_NA_TokenSetupPID307
;USB_Library_Core_NA.mpas,1317 :: 		else
	GOTO        L_USB_Library_Core_NA_TokenSetupPID298
L_USB_Library_Core_NA_TokenSetupPID307:
;USB_Library_Core_NA.mpas,1319 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_Library_Core_NA.mpas,1323 :: 		end;
L_USB_Library_Core_NA_TokenSetupPID298:
;USB_Library_Core_NA.mpas,1325 :: 		end;
L_end_TokenSetupPID:
	RETURN      0
; end of USB_Library_Core_NA_TokenSetupPID

_USB_Interrupt:

;USB_Library_Core_NA.mpas,1330 :: 		begin
;USB_Library_Core_NA.mpas,1332 :: 		if PIR2.USBIF = 1 then // usb interrupt occurred
	BTFSS       PIR2+0, 5 
	GOTO        L__USB_Interrupt310
;USB_Library_Core_NA.mpas,1334 :: 		PIR2.USBIF := 0;
	BCF         PIR2+0, 5 
;USB_Library_Core_NA.mpas,1336 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_Library_Core_NA.mpas,1338 :: 		while Tmp > 0 do    // some interrupts have occured
L__USB_Interrupt313:
	MOVF        USB_Interrupt_Tmp+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_Interrupt314
;USB_Library_Core_NA.mpas,1340 :: 		while Tmp.TRNIF = 1 do
L__USB_Interrupt318:
	BTFSS       USB_Interrupt_Tmp+0, 3 
	GOTO        L__USB_Interrupt319
;USB_Library_Core_NA.mpas,1344 :: 		USTATCopy := USTAT; // get copy of the status register
	MOVF        USTAT+0, 0 
	MOVWF       _USTATCopy+0 
;USB_Library_Core_NA.mpas,1345 :: 		BufferDescriptor := ^TBufferDescriptor(@BDEP0OUTStat) + ((USTATCopy shr 2) and $1F); // create pointer to BufferDescriptor of EPx
	MOVF        _USTATCopy+0, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       31
	ANDWF       R0, 0 
	MOVWF       R3 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _BDEP0OUTStat+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_BDEP0OUTStat+0)
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _BufferDescriptor+0 
	MOVF        R1, 0 
	MOVWF       _BufferDescriptor+1 
;USB_Library_Core_NA.mpas,1346 :: 		UIR.TRNIF := 0;    // clear the interrupt flag (enable further activity)
	BCF         UIR+0, 3 
;USB_Library_Core_NA.mpas,1348 :: 		if BufferDescriptor^.Status.UOWN = 0 then
	MOVF        R0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L
	MOVFF       R3, FSR0H
	BTFSC       POSTINC0+0, 7 
	GOTO        L__USB_Interrupt323
;USB_Library_Core_NA.mpas,1350 :: 		Pid := (BufferDescriptor^.Status shr 2) and $0F; // get the PID out of the endpoint buffer status
	MOVFF       _BufferDescriptor+0, FSR0L
	MOVFF       _BufferDescriptor+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVLW       15
	ANDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       USB_Interrupt_Pid+0 
;USB_Library_Core_NA.mpas,1352 :: 		USB_TOKEN_IN:     TokenInPid;
	MOVF        R1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt328
	CALL        USB_Library_Core_NA_TokenInPID+0, 0
	GOTO        L__USB_Interrupt325
L__USB_Interrupt328:
;USB_Library_Core_NA.mpas,1353 :: 		USB_TOKEN_OUT:    TokenOutPid;
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt331
	CALL        USB_Library_Core_NA_TokenOutPID+0, 0
	GOTO        L__USB_Interrupt325
L__USB_Interrupt331:
;USB_Library_Core_NA.mpas,1354 :: 		USB_TOKEN_SETUP:  TokenSetupPID;
	MOVF        USB_Interrupt_Pid+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L__USB_Interrupt334
	CALL        USB_Library_Core_NA_TokenSetupPID+0, 0
	GOTO        L__USB_Interrupt325
L__USB_Interrupt334:
L__USB_Interrupt325:
;USB_Library_Core_NA.mpas,1356 :: 		end;
L__USB_Interrupt323:
;USB_Library_Core_NA.mpas,1358 :: 		Tmp := UIR and UIE;
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_Library_Core_NA.mpas,1359 :: 		end;
	GOTO        L__USB_Interrupt318
L__USB_Interrupt319:
;USB_Library_Core_NA.mpas,1361 :: 		if Tmp.URSTIF  = 1 then UsbReset;
	BTFSS       USB_Interrupt_Tmp+0, 0 
	GOTO        L__USB_Interrupt336
	CALL        USB_Library_Core_NA_UsbReset+0, 0
L__USB_Interrupt336:
;USB_Library_Core_NA.mpas,1363 :: 		if Tmp.STALLIF = 1 then UIR.STALLIF := 0; // clear interrupt flag
	BTFSS       USB_Interrupt_Tmp+0, 5 
	GOTO        L__USB_Interrupt339
	BCF         UIR+0, 5 
L__USB_Interrupt339:
;USB_Library_Core_NA.mpas,1373 :: 		if Tmp.IDLEIF  = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 4 
	GOTO        L__USB_Interrupt342
;USB_Library_Core_NA.mpas,1375 :: 		IsIdle := true;
	MOVLW       255
	MOVWF       _IsIdle+0 
;USB_Library_Core_NA.mpas,1376 :: 		UIE.IDLEIE := 0; // disable the idle interrupt
	BCF         UIE+0, 4 
;USB_Library_Core_NA.mpas,1377 :: 		UIR.SOFIF  := 0;
	BCF         UIR+0, 6 
;USB_Library_Core_NA.mpas,1378 :: 		UIE.SOFIE :=  1; // enable the SOF interrupt
	BSF         UIE+0, 6 
;USB_Library_Core_NA.mpas,1379 :: 		UIR.IDLEIF := 0; // clear interrupt flag
	BCF         UIR+0, 4 
;USB_Library_Core_NA.mpas,1380 :: 		end;
L__USB_Interrupt342:
;USB_Library_Core_NA.mpas,1382 :: 		if Tmp.SOFIF = 1 then
	BTFSS       USB_Interrupt_Tmp+0, 6 
	GOTO        L__USB_Interrupt345
;USB_Library_Core_NA.mpas,1384 :: 		IsIdle     := false; // clear the "is Idle" bit 0
	CLRF        _IsIdle+0 
;USB_Library_Core_NA.mpas,1385 :: 		UIE.SOFIE  := 0;     // disable the SOF interrupt
	BCF         UIE+0, 6 
;USB_Library_Core_NA.mpas,1386 :: 		UIR.IDLEIF := 0;
	BCF         UIR+0, 4 
;USB_Library_Core_NA.mpas,1387 :: 		UIE.IDLEIE := 1;     // enable the idle interrupt
	BSF         UIE+0, 4 
;USB_Library_Core_NA.mpas,1388 :: 		UIR.SOFIF  := 0;     // clear interrupt flag
	BCF         UIR+0, 6 
;USB_Library_Core_NA.mpas,1389 :: 		end;
L__USB_Interrupt345:
;USB_Library_Core_NA.mpas,1391 :: 		Tmp := UIR and UIE; // get the enabled interrupts
	MOVF        UIE+0, 0 
	ANDWF       UIR+0, 0 
	MOVWF       USB_Interrupt_Tmp+0 
;USB_Library_Core_NA.mpas,1392 :: 		end;
	GOTO        L__USB_Interrupt313
L__USB_Interrupt314:
;USB_Library_Core_NA.mpas,1394 :: 		end;
L__USB_Interrupt310:
;USB_Library_Core_NA.mpas,1395 :: 		end;
L_end_USB_Interrupt:
	RETURN      0
; end of _USB_Interrupt
