
USB_HID_Library_NA_GiveEP1INtoSIE:

;USB_HID_Library_NA.mpas,78 :: 		begin
;USB_HID_Library_NA.mpas,79 :: 		BDEP1INStat := BDEP1INStat and USB_DTSMask;             // save only the data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP1INStat+0, 1 
;USB_HID_Library_NA.mpas,80 :: 		BDEP1INStat := BDEP1INStat xor USB_DTSMask;             // toggle the data 0/1 bit
	BTG         _BDEP1INStat+0, 6 
;USB_HID_Library_NA.mpas,81 :: 		BDEP1INStat := BDEP1INStat or (USB_DTSEN or USB_USIE);  // set the DTS bit and set the UOWN bit
	MOVLW       136
	IORWF       _BDEP1INStat+0, 1 
;USB_HID_Library_NA.mpas,82 :: 		end;
L_end_GiveEP1INtoSIE:
	RETURN      0
; end of USB_HID_Library_NA_GiveEP1INtoSIE

USB_HID_Library_NA_GiveEP1OUTtoSIE:

;USB_HID_Library_NA.mpas,85 :: 		begin
;USB_HID_Library_NA.mpas,86 :: 		BDEP1OUTStat := BDEP1OUTStat and USB_DTSMask;            // save only the data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP1OUTStat+0, 1 
;USB_HID_Library_NA.mpas,87 :: 		BDEP1OUTStat := BDEP1OUTStat xor USB_DTSMask;            // toggle data 0/1
	BTG         _BDEP1OUTStat+0, 6 
;USB_HID_Library_NA.mpas,88 :: 		BDEP1OUTStat := BDEP1OUTStat or (USB_DTSEN or USB_USIE); // set the DTS bit and the UOWN bit
	MOVLW       136
	IORWF       _BDEP1OUTStat+0, 1 
;USB_HID_Library_NA.mpas,89 :: 		end;
L_end_GiveEP1OUTtoSIE:
	RETURN      0
; end of USB_HID_Library_NA_GiveEP1OUTtoSIE

_USB_HID_Read:

;USB_HID_Library_NA.mpas,95 :: 		begin
;USB_HID_Library_NA.mpas,96 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_HID_Library_NA.mpas,98 :: 		if BDEP1OUTStat.UOWN = 0
	BTFSC       _BDEP1OUTStat+0, 7 
	GOTO        L__USB_HID_Read4
;USB_HID_Library_NA.mpas,99 :: 		then Result := true
	MOVLW       255
	MOVWF       USB_HID_Read_local_result+0 
	GOTO        L__USB_HID_Read5
;USB_HID_Library_NA.mpas,100 :: 		else Result := false;
L__USB_HID_Read4:
	CLRF        USB_HID_Read_local_result+0 
L__USB_HID_Read5:
;USB_HID_Library_NA.mpas,102 :: 		if Result then  // PIC owns the buffer
	MOVF        USB_HID_Read_local_result+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__USB_HID_Read7
;USB_HID_Library_NA.mpas,105 :: 		ByteCount := BDEP1OUTCnt;   // get bytecount of EP1 out buffer
	MOVF        _BDEP1OUTCnt+0, 0 
	MOVWF       USB_HID_Read_ByteCount+0 
;USB_HID_Library_NA.mpas,106 :: 		if ByteCount > MaxLen then ByteCount := MaxLen;
	MOVF        USB_HID_Read_ByteCount+0, 0 
	SUBWF       FARG_USB_HID_Read_MaxLen+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Read10
	MOVF        FARG_USB_HID_Read_MaxLen+0, 0 
	MOVWF       USB_HID_Read_ByteCount+0 
L__USB_HID_Read10:
;USB_HID_Library_NA.mpas,108 :: 		if ByteCount > 0 then       // non empty
	MOVF        USB_HID_Read_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Read13
;USB_HID_Library_NA.mpas,110 :: 		SrcPtr := ^byte(BDEP1OUTAdr);    // Source data pointer
	MOVF        _BDEP1OUTAdr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        _BDEP1OUTAdr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
;USB_HID_Library_NA.mpas,111 :: 		memcpy(DstPtr, SrcPtr, ByteCount);
	MOVF        FARG_USB_HID_Read_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        FARG_USB_HID_Read_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        USB_HID_Read_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
;USB_HID_Library_NA.mpas,112 :: 		end;
L__USB_HID_Read13:
;USB_HID_Library_NA.mpas,115 :: 		BDEP1OUTCnt  := USB_BUFF_SIZE;                           // bytecount (= maximum = USB_BUFF_SIZE)
	MOVLW       64
	MOVWF       _BDEP1OUTCnt+0 
;USB_HID_Library_NA.mpas,116 :: 		GiveEP1OUTtoSIE;
	CALL        USB_HID_Library_NA_GiveEP1OUTtoSIE+0, 0
;USB_HID_Library_NA.mpas,117 :: 		end;
L__USB_HID_Read7:
;USB_HID_Library_NA.mpas,118 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_HID_Library_NA.mpas,119 :: 		end;
	MOVF        USB_HID_Read_local_result+0, 0 
	MOVWF       R0 
L_end_USB_HID_Read:
	RETURN      0
; end of _USB_HID_Read

_USB_HID_Write:

;USB_HID_Library_NA.mpas,125 :: 		begin
;USB_HID_Library_NA.mpas,126 :: 		PIE2.USBIE := 0;
	BCF         PIE2+0, 5 
;USB_HID_Library_NA.mpas,128 :: 		if (BDEP1INStat.UOWN = 0)
	BTFSC       _BDEP1INStat+0, 7 
	GOTO        L__USB_HID_Write17
;USB_HID_Library_NA.mpas,129 :: 		then Result := true
	MOVLW       255
	MOVWF       USB_HID_Write_local_result+0 
	GOTO        L__USB_HID_Write18
;USB_HID_Library_NA.mpas,130 :: 		else Result := false;
L__USB_HID_Write17:
	CLRF        USB_HID_Write_local_result+0 
L__USB_HID_Write18:
;USB_HID_Library_NA.mpas,132 :: 		if Result{ = true} then
	MOVF        USB_HID_Write_local_result+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__USB_HID_Write20
;USB_HID_Library_NA.mpas,135 :: 		DstPtr := @BuffEP1IN;    // get destination address
	MOVLW       _BuffEP1IN+0
	MOVWF       USB_HID_Write_DstPtr+0 
	MOVLW       hi_addr(_BuffEP1IN+0)
	MOVWF       USB_HID_Write_DstPtr+1 
;USB_HID_Library_NA.mpas,137 :: 		if ByteCount > 0 then memcpy(DstPtr, SrcPtr, ByteCount);   // fill the transmit buffer
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Write23
	MOVF        USB_HID_Write_DstPtr+0, 0 
	MOVWF       FARG_memcpy_p1+0 
	MOVF        USB_HID_Write_DstPtr+1, 0 
	MOVWF       FARG_memcpy_p1+1 
	MOVF        FARG_USB_HID_Write_SrcPtr+0, 0 
	MOVWF       FARG_memcpy_p2+0 
	MOVF        FARG_USB_HID_Write_SrcPtr+1, 0 
	MOVWF       FARG_memcpy_p2+1 
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	MOVWF       FARG_memcpy_nn+0 
	MOVLW       0
	MOVWF       FARG_memcpy_nn+1 
	CALL        _memcpy+0, 0
L__USB_HID_Write23:
;USB_HID_Library_NA.mpas,140 :: 		if (ByteCount < HID_INPUT_REPORT_BYTES) then
	MOVLW       10
	SUBWF       FARG_USB_HID_Write_ByteCount+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__USB_HID_Write26
;USB_HID_Library_NA.mpas,142 :: 		DstPtr := @BuffEP1IN + ByteCount;
	MOVLW       _BuffEP1IN+0
	MOVWF       R0 
	MOVLW       hi_addr(_BuffEP1IN+0)
	MOVWF       R1 
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	ADDWF       R0, 1 
	BTFSC       STATUS+0, 0 
	INCF        R1, 1 
	MOVF        R0, 0 
	MOVWF       USB_HID_Write_DstPtr+0 
	MOVF        R1, 0 
	MOVWF       USB_HID_Write_DstPtr+1 
;USB_HID_Library_NA.mpas,143 :: 		memset(DstPtr, 0, HID_INPUT_REPORT_BYTES - ByteCount);
	MOVF        R0, 0 
	MOVWF       FARG_memset_p+0 
	MOVF        R1, 0 
	MOVWF       FARG_memset_p+1 
	CLRF        FARG_memset_character+0 
	MOVF        FARG_USB_HID_Write_ByteCount+0, 0 
	SUBLW       10
	MOVWF       FARG_memset_n+0 
	MOVLW       0
	MOVWF       FARG_memset_n+1 
	MOVLW       0
	SUBFWB      FARG_memset_n+1, 1 
	CALL        _memset+0, 0
;USB_HID_Library_NA.mpas,144 :: 		end;
L__USB_HID_Write26:
;USB_HID_Library_NA.mpas,147 :: 		BDEP1INCnt  := HID_INPUT_REPORT_BYTES;                  // set bytecount
	MOVLW       10
	MOVWF       _BDEP1INCnt+0 
;USB_HID_Library_NA.mpas,148 :: 		GiveEP1INtoSIE;
	CALL        USB_HID_Library_NA_GiveEP1INtoSIE+0, 0
;USB_HID_Library_NA.mpas,149 :: 		end;
L__USB_HID_Write20:
;USB_HID_Library_NA.mpas,151 :: 		PIE2.USBIE := 1;
	BSF         PIE2+0, 5 
;USB_HID_Library_NA.mpas,152 :: 		end;
	MOVF        USB_HID_Write_local_result+0, 0 
	MOVWF       R0 
L_end_USB_HID_Write:
	RETURN      0
; end of _USB_HID_Write

_ClassSpecificRequestHID:

;USB_HID_Library_NA.mpas,156 :: 		begin
;USB_HID_Library_NA.mpas,164 :: 		Result := false;
	CLRF        ClassSpecificRequestHID_local_result+0 
;USB_HID_Library_NA.mpas,168 :: 		USB_CLASS_HOST_TO_INTERFACE:  //
	MOVF        _SetUpPacket+0, 0 
	XORLW       33
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID32
;USB_HID_Library_NA.mpas,171 :: 		USB_SET_HID_REPORT: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       9
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID36
;USB_HID_Library_NA.mpas,176 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassSpecificRequestHID_local_result+0 
;USB_HID_Library_NA.mpas,177 :: 		UsbDeviceRequest := USB_HID_SET_REPORT_ONGOING;
	MOVLW       4
	MOVWF       _UsbDeviceRequest+0 
;USB_HID_Library_NA.mpas,178 :: 		EP0OutReset(USB_DAT1);
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_HID_Library_NA.mpas,181 :: 		end;
	GOTO        L__ClassSpecificRequestHID33
L__ClassSpecificRequestHID36:
;USB_HID_Library_NA.mpas,183 :: 		USB_SET_HID_IDLE: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       10
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID39
;USB_HID_Library_NA.mpas,188 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassSpecificRequestHID_local_result+0 
;USB_HID_Library_NA.mpas,189 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_HID_Library_NA.mpas,190 :: 		SendAckToHost;
	CALL        _SendAckToHost+0, 0
;USB_HID_Library_NA.mpas,191 :: 		end;
	GOTO        L__ClassSpecificRequestHID33
L__ClassSpecificRequestHID39:
L__ClassSpecificRequestHID33:
;USB_HID_Library_NA.mpas,194 :: 		end;
	GOTO        L__ClassSpecificRequestHID29
L__ClassSpecificRequestHID32:
;USB_HID_Library_NA.mpas,196 :: 		USB_CLASS_INTERFACE_TO_HOST:  //
	MOVF        _SetUpPacket+0, 0 
	XORLW       161
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID42
;USB_HID_Library_NA.mpas,199 :: 		USB_GET_HID_REPORT: // GetHIDReport
	MOVF        _SetUpPacket+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID46
;USB_HID_Library_NA.mpas,201 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassSpecificRequestHID_local_result+0 
;USB_HID_Library_NA.mpas,206 :: 		EP0OutReset(USB_DAT1);
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_HID_Library_NA.mpas,210 :: 		USB_HID_INPUT_REPORT: //
	MOVF        _SetUpPacket+3, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID50
;USB_HID_Library_NA.mpas,217 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_HID_Library_NA.mpas,219 :: 		BDEP1INStat.UOWN := 0;          // take back buffer EP1
	BCF         _BDEP1INStat+0, 7 
;USB_HID_Library_NA.mpas,222 :: 		Dst := ^byte(BDEP0INAdr);
	MOVF        _BDEP0INAdr+0, 0 
	MOVWF       FARG_MemCpy___Towards+0 
	MOVF        _BDEP0INAdr+1, 0 
	MOVWF       FARG_MemCpy___Towards+1 
;USB_HID_Library_NA.mpas,223 :: 		Src := ^byte(BDEP1INAdr);
	MOVF        _BDEP1INAdr+0, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVF        _BDEP1INAdr+1, 0 
	MOVWF       FARG_MemCpy___From+1 
;USB_HID_Library_NA.mpas,224 :: 		MemCpy__(Dst, Src, BDEP1INCnt);
	MOVF        _BDEP1INCnt+0, 0 
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_HID_Library_NA.mpas,226 :: 		BDEP0INCnt  := BDEP1INCnt;                  // copy the bytecount
	MOVF        _BDEP1INCnt+0, 0 
	MOVWF       _BDEP0INCnt+0 
;USB_HID_Library_NA.mpas,227 :: 		BDEP0INStat := (USB_DTSEN or USB_DAT1 or USB_USIE);
	MOVLW       200
	MOVWF       _BDEP0INStat+0 
;USB_HID_Library_NA.mpas,232 :: 		end;
	GOTO        L__ClassSpecificRequestHID47
L__ClassSpecificRequestHID50:
;USB_HID_Library_NA.mpas,234 :: 		USB_HID_FEATURE_REPORT: //
	MOVF        _SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestHID53
;USB_HID_Library_NA.mpas,236 :: 		StallEP0;
	CALL        _StallEP0+0, 0
;USB_HID_Library_NA.mpas,260 :: 		end;
	GOTO        L__ClassSpecificRequestHID47
L__ClassSpecificRequestHID53:
L__ClassSpecificRequestHID47:
;USB_HID_Library_NA.mpas,263 :: 		end;
	GOTO        L__ClassSpecificRequestHID43
L__ClassSpecificRequestHID46:
L__ClassSpecificRequestHID43:
;USB_HID_Library_NA.mpas,265 :: 		end;
	GOTO        L__ClassSpecificRequestHID29
L__ClassSpecificRequestHID42:
L__ClassSpecificRequestHID29:
;USB_HID_Library_NA.mpas,268 :: 		end;
	MOVF        ClassSpecificRequestHID_local_result+0, 0 
	MOVWF       R0 
L_end_ClassSpecificRequestHID:
	RETURN      0
; end of _ClassSpecificRequestHID

_ClassSetupEndPointsHID:

;USB_HID_Library_NA.mpas,271 :: 		begin
;USB_HID_Library_NA.mpas,277 :: 		BDEP1OUTCnt  := USB_BUFF_SIZE;
	MOVLW       64
	MOVWF       _BDEP1OUTCnt+0 
;USB_HID_Library_NA.mpas,278 :: 		BDEP1OUTAdr  := word(@BuffEP1OUT);
	MOVLW       _BuffEP1OUT+0
	MOVWF       _BDEP1OUTAdr+0 
	MOVLW       hi_addr(_BuffEP1OUT+0)
	MOVWF       _BDEP1OUTAdr+1 
;USB_HID_Library_NA.mpas,279 :: 		BDEP1OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN); // set the UOWN bit (give to SIE)
	MOVLW       136
	MOVWF       _BDEP1OUTStat+0 
;USB_HID_Library_NA.mpas,282 :: 		BDEP1INCnt   := 0;
	CLRF        _BDEP1INCnt+0 
;USB_HID_Library_NA.mpas,283 :: 		BDEP1INAdr   := word(@BuffEP1IN);
	MOVLW       _BuffEP1IN+0
	MOVWF       _BDEP1INAdr+0 
	MOVLW       hi_addr(_BuffEP1IN+0)
	MOVWF       _BDEP1INAdr+1 
;USB_HID_Library_NA.mpas,284 :: 		BDEP1INStat  := (USB_UCPU + USB_DAT1 or USB_DTSEN); // clear the UOWN bit (give to PIC)
	MOVLW       72
	MOVWF       _BDEP1INStat+0 
;USB_HID_Library_NA.mpas,286 :: 		UEP1 := (USB_EP_OUT_IN or USB_HSHK_EN);             // in/out endpoint, handshake enabled
	MOVLW       30
	MOVWF       UEP1+0 
;USB_HID_Library_NA.mpas,287 :: 		end;
L_end_ClassSetupEndPointsHID:
	RETURN      0
; end of _ClassSetupEndPointsHID

USB_HID_Library_NA_SetHIDReport:

;USB_HID_Library_NA.mpas,291 :: 		begin
;USB_HID_Library_NA.mpas,295 :: 		USB_HID_OUTPUT_REPORT: //
	MOVF        _SetUpPacket+3, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_NA_SetHIDReport59
;USB_HID_Library_NA.mpas,299 :: 		UsbDeviceRequest := $FF;
	MOVLW       255
	MOVWF       _UsbDeviceRequest+0 
;USB_HID_Library_NA.mpas,302 :: 		Src := ^byte(BDEP0OUTAdr);
	MOVF        _BDEP0OUTAdr+0, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVF        _BDEP0OUTAdr+1, 0 
	MOVWF       FARG_MemCpy___From+1 
;USB_HID_Library_NA.mpas,303 :: 		Dst := ^byte(BDEP1OUTAdr);
	MOVF        _BDEP1OUTAdr+0, 0 
	MOVWF       FARG_MemCpy___Towards+0 
	MOVF        _BDEP1OUTAdr+1, 0 
	MOVWF       FARG_MemCpy___Towards+1 
;USB_HID_Library_NA.mpas,304 :: 		MemCpy__(Dst, Src, BDEP0OUTCnt);
	MOVF        _BDEP0OUTCnt+0, 0 
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_HID_Library_NA.mpas,306 :: 		BDEP1OUTCnt  := BDEP0OUTCnt;   // copy the bytecount
	MOVF        _BDEP0OUTCnt+0, 0 
	MOVWF       _BDEP1OUTCnt+0 
;USB_HID_Library_NA.mpas,307 :: 		BDEP1OUTStat := BDEP0OUTStat;  // copy the status
	MOVF        _BDEP0OUTStat+0, 0 
	MOVWF       _BDEP1OUTStat+0 
;USB_HID_Library_NA.mpas,312 :: 		end;
	GOTO        L_USB_HID_Library_NA_SetHIDReport56
L_USB_HID_Library_NA_SetHIDReport59:
;USB_HID_Library_NA.mpas,314 :: 		USB_HID_FEATURE_REPORT: //
	MOVF        _SetUpPacket+3, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_HID_Library_NA_SetHIDReport62
;USB_HID_Library_NA.mpas,316 :: 		StallEp0;
	CALL        _StallEP0+0, 0
;USB_HID_Library_NA.mpas,331 :: 		end;
	GOTO        L_USB_HID_Library_NA_SetHIDReport56
L_USB_HID_Library_NA_SetHIDReport62:
L_USB_HID_Library_NA_SetHIDReport56:
;USB_HID_Library_NA.mpas,335 :: 		end;
L_end_SetHIDReport:
	RETURN      0
; end of USB_HID_Library_NA_SetHIDReport

_ClassTokenOutHID:

;USB_HID_Library_NA.mpas,338 :: 		begin
;USB_HID_Library_NA.mpas,339 :: 		Result := false;
	CLRF        ClassTokenOutHID_local_result+0 
;USB_HID_Library_NA.mpas,341 :: 		0: //
	MOVF        FARG_ClassTokenOutHID_Ep+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutHID67
;USB_HID_Library_NA.mpas,343 :: 		if UsbDeviceRequest = USB_HID_SET_REPORT_ONGOING then
	MOVF        _UsbDeviceRequest+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutHID69
;USB_HID_Library_NA.mpas,345 :: 		SetHIDReport;
	CALL        USB_HID_Library_NA_SetHIDReport+0, 0
;USB_HID_Library_NA.mpas,346 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenOutHID_local_result+0 
;USB_HID_Library_NA.mpas,347 :: 		end;
L__ClassTokenOutHID69:
;USB_HID_Library_NA.mpas,348 :: 		end;
	GOTO        L__ClassTokenOutHID64
L__ClassTokenOutHID67:
;USB_HID_Library_NA.mpas,350 :: 		1: // endpoint 1 out
	MOVF        FARG_ClassTokenOutHID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutHID73
;USB_HID_Library_NA.mpas,352 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenOutHID_local_result+0 
;USB_HID_Library_NA.mpas,357 :: 		end;
	GOTO        L__ClassTokenOutHID64
L__ClassTokenOutHID73:
L__ClassTokenOutHID64:
;USB_HID_Library_NA.mpas,359 :: 		end;
	MOVF        ClassTokenOutHID_local_result+0, 0 
	MOVWF       R0 
L_end_ClassTokenOutHID:
	RETURN      0
; end of _ClassTokenOutHID

_ClassTokenInHID:

;USB_HID_Library_NA.mpas,362 :: 		begin
;USB_HID_Library_NA.mpas,363 :: 		Result := false;
	CLRF        R1 
;USB_HID_Library_NA.mpas,366 :: 		1: // endpoint 1 IN
	MOVF        FARG_ClassTokenInHID_Ep+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInHID78
;USB_HID_Library_NA.mpas,368 :: 		Result := true;
	MOVLW       255
	MOVWF       R1 
;USB_HID_Library_NA.mpas,373 :: 		end;
	GOTO        L__ClassTokenInHID75
L__ClassTokenInHID78:
L__ClassTokenInHID75:
;USB_HID_Library_NA.mpas,375 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_ClassTokenInHID:
	RETURN      0
; end of _ClassTokenInHID

_GetClassSpecificDescriptorHID:

;USB_HID_Library_NA.mpas,378 :: 		begin
;USB_HID_Library_NA.mpas,379 :: 		Result := false;
	CLRF        GetClassSpecificDescriptorHID_local_result+0 
;USB_HID_Library_NA.mpas,381 :: 		if (SetUpPacket.wIndex = USB_HID_INTERFACE_NUMBER) then
	MOVLW       0
	XORWF       _SetUpPacket+5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__GetClassSpecificDescriptorHID100
	MOVLW       1
	XORWF       _SetUpPacket+4, 0 
L__GetClassSpecificDescriptorHID100:
	BTFSS       STATUS+0, 2 
	GOTO        L__GetClassSpecificDescriptorHID81
;USB_HID_Library_NA.mpas,385 :: 		USB_HID_DESCRIPTOR         : //
	MOVF        _SetUpPacket+3, 0 
	XORLW       33
	BTFSS       STATUS+0, 2 
	GOTO        L__GetClassSpecificDescriptorHID86
;USB_HID_Library_NA.mpas,387 :: 		Result := true;
	MOVLW       255
	MOVWF       GetClassSpecificDescriptorHID_local_result+0 
;USB_HID_Library_NA.mpas,388 :: 		UsbDeviceRequest         := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_HID_Library_NA.mpas,389 :: 		DescriptorPointer        := @HIDDescriptor;
	MOVLW       _HIDDescriptor+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_HIDDescriptor+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_HIDDescriptor+0)
	MOVWF       _DescriptorPointer+2 
;USB_HID_Library_NA.mpas,390 :: 		DescriptorBytesToSend    := SizeOf(HIDDescriptor);
	MOVLW       9
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_HID_Library_NA.mpas,391 :: 		DescriptorBytesRequested := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_HID_Library_NA.mpas,392 :: 		DescriptorBytesToSend    := minimum__(DescriptorBytesToSend, DescriptorBytesRequested);
	MOVLW       9
	MOVWF       FARG_minimum___v1+0 
	MOVLW       0
	MOVWF       FARG_minimum___v1+1 
	MOVF        _SetUpPacket+6, 0 
	MOVWF       FARG_minimum___v2+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_HID_Library_NA.mpas,398 :: 		SendDescriptorToEP0;
	CALL        _SendDescriptorToEP0+0, 0
;USB_HID_Library_NA.mpas,399 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_HID_Library_NA.mpas,400 :: 		end;
	GOTO        L__GetClassSpecificDescriptorHID83
L__GetClassSpecificDescriptorHID86:
;USB_HID_Library_NA.mpas,402 :: 		HID_REPORT_DESCRIPTOR      : //
	MOVF        _SetUpPacket+3, 0 
	XORLW       34
	BTFSS       STATUS+0, 2 
	GOTO        L__GetClassSpecificDescriptorHID89
;USB_HID_Library_NA.mpas,404 :: 		Result := true;
	MOVLW       255
	MOVWF       GetClassSpecificDescriptorHID_local_result+0 
;USB_HID_Library_NA.mpas,405 :: 		UsbDeviceRequest         := USB_GET_DESCRIPTOR_ONGOING;
	MOVLW       1
	MOVWF       _UsbDeviceRequest+0 
;USB_HID_Library_NA.mpas,406 :: 		DescriptorPointer        := @HIDReportDescriptor;
	MOVLW       _HIDReportDescriptor+0
	MOVWF       _DescriptorPointer+0 
	MOVLW       hi_addr(_HIDReportDescriptor+0)
	MOVWF       _DescriptorPointer+1 
	MOVLW       higher_addr(_HIDReportDescriptor+0)
	MOVWF       _DescriptorPointer+2 
;USB_HID_Library_NA.mpas,407 :: 		DescriptorBytesToSend    := SizeOf(HIDReportDescriptor);
	MOVLW       34
	MOVWF       _DescriptorBytesToSend+0 
	MOVLW       0
	MOVWF       _DescriptorBytesToSend+1 
;USB_HID_Library_NA.mpas,408 :: 		DescriptorBytesRequested := SetUpPacket.wLength;
	MOVF        _SetUpPacket+6, 0 
	MOVWF       _DescriptorBytesRequested+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       _DescriptorBytesRequested+1 
;USB_HID_Library_NA.mpas,409 :: 		DescriptorBytesToSend    := minimum__(DescriptorBytesToSend, DescriptorBytesRequested);
	MOVLW       34
	MOVWF       FARG_minimum___v1+0 
	MOVLW       0
	MOVWF       FARG_minimum___v1+1 
	MOVF        _SetUpPacket+6, 0 
	MOVWF       FARG_minimum___v2+0 
	MOVF        _SetUpPacket+7, 0 
	MOVWF       FARG_minimum___v2+1 
	CALL        _minimum__+0, 0
	MOVF        R0, 0 
	MOVWF       _DescriptorBytesToSend+0 
	MOVF        R1, 0 
	MOVWF       _DescriptorBytesToSend+1 
;USB_HID_Library_NA.mpas,415 :: 		SendDescriptorToEP0;
	CALL        _SendDescriptorToEP0+0, 0
;USB_HID_Library_NA.mpas,416 :: 		EP0OutReset(USB_DAT1); // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_HID_Library_NA.mpas,417 :: 		end;
	GOTO        L__GetClassSpecificDescriptorHID83
L__GetClassSpecificDescriptorHID89:
L__GetClassSpecificDescriptorHID83:
;USB_HID_Library_NA.mpas,420 :: 		end;
L__GetClassSpecificDescriptorHID81:
;USB_HID_Library_NA.mpas,421 :: 		end;
	MOVF        GetClassSpecificDescriptorHID_local_result+0, 0 
	MOVWF       R0 
L_end_GetClassSpecificDescriptorHID:
	RETURN      0
; end of _GetClassSpecificDescriptorHID
