
USB_MSD_Library_NA_Msd_SendPacket:

;USB_MSD_Library_NA.mpas,364 :: 		begin
;USB_MSD_Library_NA.mpas,374 :: 		repeat
L_USB_MSD_Library_NA_Msd_SendPacket1:
;USB_MSD_Library_NA.mpas,375 :: 		until (BDEP4INStat.UOWN = 0);                                  // wait until the PIC owns the buffer
	BTFSC       _BDEP4INStat+0, 7 
	GOTO        L_USB_MSD_Library_NA_Msd_SendPacket1
;USB_MSD_Library_NA.mpas,376 :: 		BDEP4INCnt  := Len;
	MOVF        FARG_Msd_SendPacket_Len+0, 0 
	MOVWF       _BDEP4INCnt+0 
;USB_MSD_Library_NA.mpas,377 :: 		BDEP4INStat := BDEP4INStat and USB_DTSMASK;                    // save only the data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP4INStat+0, 1 
;USB_MSD_Library_NA.mpas,378 :: 		BDEP4INStat := BDEP4INStat xor USB_DTSMASK;  // toggle the data 0/1 bit
	BTG         _BDEP4INStat+0, 6 
;USB_MSD_Library_NA.mpas,379 :: 		BDEP4INStat := BDEP4INStat or (USB_DTSEN or USB_USIE);         // set the DTSEN bit and UOWN bit (enable sending)
	MOVLW       136
	IORWF       _BDEP4INStat+0, 1 
;USB_MSD_Library_NA.mpas,380 :: 		end;
L_end_Msd_SendPacket:
	RETURN      0
; end of USB_MSD_Library_NA_Msd_SendPacket

USB_MSD_Library_NA_Msd_ReceivePacket:

;USB_MSD_Library_NA.mpas,384 :: 		begin
;USB_MSD_Library_NA.mpas,385 :: 		BDEP4OUTCnt  := USB_MSD_BULK_OUT_EP_SIZE;
	MOVLW       64
	MOVWF       _BDEP4OUTCnt+0 
;USB_MSD_Library_NA.mpas,386 :: 		BDEP4OUTStat := BDEP4OUTStat and USB_DTSMASK;                   // save data 0/1 bit
	MOVLW       64
	ANDWF       _BDEP4OUTStat+0, 1 
;USB_MSD_Library_NA.mpas,387 :: 		BDEP4OUTStat := BDEP4OUTStat xor USB_DTSMASK; // toggle the data 0/1 bit
	BTG         _BDEP4OUTStat+0, 6 
;USB_MSD_Library_NA.mpas,388 :: 		BDEP4OUTStat := BDEP4OUTStat or (USB_USIE or USB_DTSEN);        // set UOWN and DTS: give buffer back to SIE
	MOVLW       136
	IORWF       _BDEP4OUTStat+0, 1 
;USB_MSD_Library_NA.mpas,389 :: 		end;
L_end_Msd_ReceivePacket:
	RETURN      0
; end of USB_MSD_Library_NA_Msd_ReceivePacket

USB_MSD_Library_NA_Msd_SendBulkZeroLenPacket:

;USB_MSD_Library_NA.mpas,392 :: 		begin
;USB_MSD_Library_NA.mpas,393 :: 		Msd_SendPacket(0); // zero length packet
	CLRF        FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,394 :: 		end;
L_end_Msd_SendBulkZeroLenPacket:
	RETURN      0
; end of USB_MSD_Library_NA_Msd_SendBulkZeroLenPacket

_ClassSpecificRequestMSD:

;USB_MSD_Library_NA.mpas,400 :: 		begin
;USB_MSD_Library_NA.mpas,402 :: 		Result := false;
	CLRF        ClassSpecificRequestMSD_local_result+0 
;USB_MSD_Library_NA.mpas,404 :: 		if (SetUpPacket.wIndex = USB_MSD_INTERFACE_NUMBER) then
	MOVLW       0
	XORWF       _SetUpPacket+5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestMSD168
	MOVLW       2
	XORWF       _SetUpPacket+4, 0 
L__ClassSpecificRequestMSD168:
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestMSD10
;USB_MSD_Library_NA.mpas,406 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassSpecificRequestMSD_local_result+0 
;USB_MSD_Library_NA.mpas,415 :: 		USB_MSD_RESET: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestMSD15
;USB_MSD_Library_NA.mpas,420 :: 		MSD_State   := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,421 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,423 :: 		EP0OutReset(USB_DAT0);
	CLRF        FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_MSD_Library_NA.mpas,424 :: 		SendAckToHost;
	CALL        _SendAckToHost+0, 0
;USB_MSD_Library_NA.mpas,425 :: 		end;
	GOTO        L__ClassSpecificRequestMSD12
L__ClassSpecificRequestMSD15:
;USB_MSD_Library_NA.mpas,427 :: 		USB_MSD_GET_MAX_LUN: //
	MOVF        _SetUpPacket+1, 0 
	XORLW       254
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSpecificRequestMSD18
;USB_MSD_Library_NA.mpas,432 :: 		EP0OutReset(USB_DAT1);          // prepare for first data out packet or ZLP acknowledge from host
	MOVLW       64
	MOVWF       FARG_EP0OutReset_USBDat+0 
	CALL        _EP0OutReset+0, 0
;USB_MSD_Library_NA.mpas,433 :: 		BuffEP0IN[0] := 0;
	CLRF        _BuffEP0IN+0 
;USB_MSD_Library_NA.mpas,434 :: 		BDEP0INCnt   := 1;
	MOVLW       1
	MOVWF       _BDEP0INCnt+0 
;USB_MSD_Library_NA.mpas,435 :: 		BDEP0INStat  := (USB_USIE or USB_DAT1 or USB_DTSEN); // send
	MOVLW       200
	MOVWF       _BDEP0INStat+0 
;USB_MSD_Library_NA.mpas,436 :: 		end;
	GOTO        L__ClassSpecificRequestMSD12
L__ClassSpecificRequestMSD18:
L__ClassSpecificRequestMSD12:
;USB_MSD_Library_NA.mpas,439 :: 		end;
L__ClassSpecificRequestMSD10:
;USB_MSD_Library_NA.mpas,440 :: 		end;
	MOVF        ClassSpecificRequestMSD_local_result+0, 0 
	MOVWF       R0 
L_end_ClassSpecificRequestMSD:
	RETURN      0
; end of _ClassSpecificRequestMSD

USB_MSD_Library_NA_Msd_ResetSenseData:

;USB_MSD_Library_NA.mpas,443 :: 		begin
;USB_MSD_Library_NA.mpas,444 :: 		Msd_SenseData.ResponseCode_Valid       := USB_MSD_S_CURRENT;
	MOVLW       112
	MOVWF       USB_MSD_Library_NA_Msd_SenseData+0 
;USB_MSD_Library_NA.mpas,445 :: 		Msd_SenseData.ResponseCode_Valid.valid := 0;
	BCF         USB_MSD_Library_NA_Msd_SenseData+0, 7 
;USB_MSD_Library_NA.mpas,446 :: 		Msd_SenseData.Obsolete                 := 0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+1 
;USB_MSD_Library_NA.mpas,447 :: 		Msd_SenseData.SenseKey_etc             := USB_MSD_S_NO_SENSE;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+2 
;USB_MSD_Library_NA.mpas,448 :: 		Msd_SenseData.SenseKey_etc.ILI         :=0;
	BCF         USB_MSD_Library_NA_Msd_SenseData+2, 5 
;USB_MSD_Library_NA.mpas,449 :: 		Msd_SenseData.SenseKey_etc.EOM         :=0;
	BCF         USB_MSD_Library_NA_Msd_SenseData+2, 6 
;USB_MSD_Library_NA.mpas,450 :: 		Msd_SenseData.SenseKey_etc.FILEMARK    :=0;
	BCF         USB_MSD_Library_NA_Msd_SenseData+2, 7 
;USB_MSD_Library_NA.mpas,451 :: 		Msd_SenseData.InformationB0            := 0x00;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+3 
;USB_MSD_Library_NA.mpas,452 :: 		Msd_SenseData.InformationB1            := 0x00;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+4 
;USB_MSD_Library_NA.mpas,453 :: 		Msd_SenseData.InformationB2            := 0x00;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+5 
;USB_MSD_Library_NA.mpas,454 :: 		Msd_SenseData.InformationB3            := 0x00;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+6 
;USB_MSD_Library_NA.mpas,455 :: 		Msd_SenseData.AddSenseLen              := 0x0a;        // n-7 (n=17 (0..17))
	MOVLW       10
	MOVWF       USB_MSD_Library_NA_Msd_SenseData+7 
;USB_MSD_Library_NA.mpas,456 :: 		Msd_SenseData.CmdSpecificInfo          := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+8 
	CLRF        USB_MSD_Library_NA_Msd_SenseData+9 
	CLRF        USB_MSD_Library_NA_Msd_SenseData+10 
	CLRF        USB_MSD_Library_NA_Msd_SenseData+11 
;USB_MSD_Library_NA.mpas,457 :: 		Msd_SenseData.ASC                      := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+12 
;USB_MSD_Library_NA.mpas,458 :: 		Msd_SenseData.ASCQ                     := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+13 
;USB_MSD_Library_NA.mpas,459 :: 		Msd_SenseData.FRUC                     := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+14 
;USB_MSD_Library_NA.mpas,460 :: 		Msd_SenseData.SenseKeySpecific[0]      := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+15 
;USB_MSD_Library_NA.mpas,461 :: 		Msd_SenseData.SenseKeySpecific[1]      := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+16 
;USB_MSD_Library_NA.mpas,462 :: 		Msd_SenseData.SenseKeySpecific[2]      := 0x0;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+17 
;USB_MSD_Library_NA.mpas,463 :: 		end;
L_end_Msd_ResetSenseData:
	RETURN      0
; end of USB_MSD_Library_NA_Msd_ResetSenseData

_ClassSetupEndPointsMSD:

;USB_MSD_Library_NA.mpas,467 :: 		begin
;USB_MSD_Library_NA.mpas,473 :: 		MSD_State   := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,474 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,476 :: 		SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVLW       2
	MOVWF       FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
;USB_MSD_Library_NA.mpas,477 :: 		delay_ms(500);
	MOVLW       31
	MOVWF       R11, 0
	MOVLW       113
	MOVWF       R12, 0
	MOVLW       30
	MOVWF       R13, 0
L__ClassSetupEndPointsMSD21:
	DECFSZ      R13, 1, 1
	BRA         L__ClassSetupEndPointsMSD21
	DECFSZ      R12, 1, 1
	BRA         L__ClassSetupEndPointsMSD21
	DECFSZ      R11, 1, 1
	BRA         L__ClassSetupEndPointsMSD21
	NOP
;USB_MSD_Library_NA.mpas,479 :: 		Res := MMC_Init;
	CALL        _Mmc_Init+0, 0
;USB_MSD_Library_NA.mpas,480 :: 		if Res = 0 then SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassSetupEndPointsMSD23
	CLRF        FARG_SPI1_Init_Advanced_master+0 
	CLRF        FARG_SPI1_Init_Advanced_data_sample+0 
	CLRF        FARG_SPI1_Init_Advanced_clock_idle+0 
	MOVLW       1
	MOVWF       FARG_SPI1_Init_Advanced_transmit_edge+0 
	CALL        _SPI1_Init_Advanced+0, 0
L__ClassSetupEndPointsMSD23:
;USB_MSD_Library_NA.mpas,482 :: 		Msd_ResetSenseData;
	CALL        USB_MSD_Library_NA_Msd_ResetSenseData+0, 0
;USB_MSD_Library_NA.mpas,484 :: 		BDEP4OUTAdr  := word(@BuffEP4OUT);
	MOVLW       _BuffEP4OUT+0
	MOVWF       _BDEP4OUTAdr+0 
	MOVLW       hi_addr(_BuffEP4OUT+0)
	MOVWF       _BDEP4OUTAdr+1 
;USB_MSD_Library_NA.mpas,485 :: 		BDEP4OUTCnt  := (USB_MSD_BULK_OUT_EP_SIZE);
	MOVLW       64
	MOVWF       _BDEP4OUTCnt+0 
;USB_MSD_Library_NA.mpas,486 :: 		BDEP4OUTStat := (USB_USIE or USB_DAT0 or USB_DTSEN);
	MOVLW       136
	MOVWF       _BDEP4OUTStat+0 
;USB_MSD_Library_NA.mpas,488 :: 		BDEP4INAdr   := word(@BuffEP4IN);
	MOVLW       _BuffEP4IN+0
	MOVWF       _BDEP4INAdr+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       _BDEP4INAdr+1 
;USB_MSD_Library_NA.mpas,489 :: 		BDEP4INStat  := (USB_UCPU or USB_DAT1 or USB_DTSEN); // DAT will be toggled before actual usage
	MOVLW       72
	MOVWF       _BDEP4INStat+0 
;USB_MSD_Library_NA.mpas,491 :: 		UEP4         := (USB_EP_OUT_IN or USB_HSHK_EN);  // enable data pipes
	MOVLW       30
	MOVWF       UEP4+0 
;USB_MSD_Library_NA.mpas,497 :: 		end;
L_end_ClassSetupEndPointsMSD:
	RETURN      0
; end of _ClassSetupEndPointsMSD

USB_MSD_Library_NA_UsbMsdSendCsw:

;USB_MSD_Library_NA.mpas,504 :: 		begin
;USB_MSD_Library_NA.mpas,505 :: 		repeat
L_USB_MSD_Library_NA_UsbMsdSendCsw26:
;USB_MSD_Library_NA.mpas,506 :: 		until (BDEP4INStat.UOWN = 0);
	BTFSC       _BDEP4INStat+0, 7 
	GOTO        L_USB_MSD_Library_NA_UsbMsdSendCsw26
;USB_MSD_Library_NA.mpas,518 :: 		MemCpy__(^byte(@BuffEP4IN), ^byte(@Msd_Csw), USB_Msd_Csw_SIZE);
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       USB_MSD_Library_NA_Msd_Csw+0
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_Msd_Csw+0)
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       13
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_MSD_Library_NA.mpas,519 :: 		Msd_SendPacket(USB_Msd_Csw_SIZE);
	MOVLW       13
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,520 :: 		MSD_State  := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,521 :: 		Msd_Command:= USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,523 :: 		Msd_ReceivePacket;                           // prepare for next packetreception
	CALL        USB_MSD_Library_NA_Msd_ReceivePacket+0, 0
;USB_MSD_Library_NA.mpas,524 :: 		end;
L_end_UsbMsdSendCsw:
	RETURN      0
; end of USB_MSD_Library_NA_UsbMsdSendCsw

USB_MSD_Library_NA_Msd_WriteHandler:

;USB_MSD_Library_NA.mpas,528 :: 		begin
;USB_MSD_Library_NA.mpas,543 :: 		if Msd_NrSectors > 0 then
	MOVLW       0
	MOVWF       R0 
	MOVF        USB_MSD_Library_NA_Msd_NrSectors+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler173
	MOVF        USB_MSD_Library_NA_Msd_NrSectors+0, 0 
	SUBLW       0
L_USB_MSD_Library_NA_Msd_WriteHandler173:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler33
;USB_MSD_Library_NA.mpas,545 :: 		MemCpy__(@MSD_Buffer[Msd_SectorChunk * 64], @BuffEP4OUT,  64); // copy the received packet to the 512 bytes (USB_MSD_BLOCKLEN) sectorbuffer
	MOVLW       6
	MOVWF       R2 
	MOVF        USB_MSD_Library_NA_Msd_SectorChunk+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L_USB_MSD_Library_NA_Msd_WriteHandler174:
	BZ          L_USB_MSD_Library_NA_Msd_WriteHandler175
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler174
L_USB_MSD_Library_NA_Msd_WriteHandler175:
	MOVLW       USB_MSD_Library_NA_MSD_buffer+0
	ADDWF       R0, 0 
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_MSD_buffer+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       _BuffEP4OUT+0
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(_BuffEP4OUT+0)
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       64
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_MSD_Library_NA.mpas,547 :: 		inc(Msd_SectorChunk);                                        // next chunk of 64 bytes
	INCF        USB_MSD_Library_NA_Msd_SectorChunk+0, 1 
;USB_MSD_Library_NA.mpas,549 :: 		if Msd_SectorChunk = 8 then                                  // last Chunk of a sector has been received
	MOVF        USB_MSD_Library_NA_Msd_SectorChunk+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler36
;USB_MSD_Library_NA.mpas,553 :: 		if MSD_SDMMC_RetryAttempt = 0 then                           // no persistent error condition yet
	MOVF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler39
;USB_MSD_Library_NA.mpas,555 :: 		repeat
L_USB_MSD_Library_NA_Msd_WriteHandler41:
;USB_MSD_Library_NA.mpas,556 :: 		mmc_Result := Mmc_Write_Sector(Msd_Sector, MSD_buffer);  // write to card
	MOVF        USB_MSD_Library_NA_Msd_Sector+0, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+0 
	MOVF        USB_MSD_Library_NA_Msd_Sector+1, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+1 
	MOVF        USB_MSD_Library_NA_Msd_Sector+2, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+2 
	MOVF        USB_MSD_Library_NA_Msd_Sector+3, 0 
	MOVWF       FARG_Mmc_Write_Sector_sector+3 
	MOVLW       USB_MSD_Library_NA_MSD_buffer+0
	MOVWF       FARG_Mmc_Write_Sector_dbuff+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_MSD_buffer+0)
	MOVWF       FARG_Mmc_Write_Sector_dbuff+1 
	CALL        _Mmc_Write_Sector+0, 0
	MOVF        R0, 0 
	MOVWF       Msd_WriteHandler_mmc_Result+0 
;USB_MSD_Library_NA.mpas,557 :: 		if mmc_Result > 0 then                                     // write error
	MOVF        R0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler47
;USB_MSD_Library_NA.mpas,559 :: 		inc(MSD_SDMMC_RetryAttempt);
	INCF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 1 
;USB_MSD_Library_NA.mpas,560 :: 		if MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES then
	MOVF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler50
;USB_MSD_Library_NA.mpas,562 :: 		Msd_Csw.Status             := USB_MSD_STATUS_FAILED;
	MOVLW       1
	MOVWF       USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,563 :: 		Msd_SenseData.Sensekey_etc := USB_MSD_S_MEDIUM_ERROR;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_Msd_SenseData+2 
;USB_MSD_Library_NA.mpas,564 :: 		Msd_SenseData.ASC          := USB_MSD_ASC_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+12 
;USB_MSD_Library_NA.mpas,565 :: 		Msd_SenseData.ASCQ         := USB_MSD_ASCQ_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+13 
;USB_MSD_Library_NA.mpas,566 :: 		end;
L_USB_MSD_Library_NA_Msd_WriteHandler50:
;USB_MSD_Library_NA.mpas,567 :: 		end;
L_USB_MSD_Library_NA_Msd_WriteHandler47:
;USB_MSD_Library_NA.mpas,568 :: 		until (mmc_Result = 0) or (MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES);
	MOVF        Msd_WriteHandler_mmc_Result+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler44
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler41
L_USB_MSD_Library_NA_Msd_WriteHandler44:
;USB_MSD_Library_NA.mpas,569 :: 		if mmc_Result = 0 then MSD_SDMMC_RetryAttempt := 0;
	MOVF        Msd_WriteHandler_mmc_Result+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler53
	CLRF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0 
L_USB_MSD_Library_NA_Msd_WriteHandler53:
;USB_MSD_Library_NA.mpas,570 :: 		end;
L_USB_MSD_Library_NA_Msd_WriteHandler39:
;USB_MSD_Library_NA.mpas,572 :: 		Msd_SectorChunk := 0;                                      // next Chunk is zero
	CLRF        USB_MSD_Library_NA_Msd_SectorChunk+0 
;USB_MSD_Library_NA.mpas,573 :: 		dec(Msd_NrSectors);                                        // one sector less to write
	MOVLW       1
	SUBWF       USB_MSD_Library_NA_Msd_NrSectors+0, 1 
	MOVLW       0
	SUBWFB      USB_MSD_Library_NA_Msd_NrSectors+1, 1 
;USB_MSD_Library_NA.mpas,574 :: 		inc(Msd_Sector);                                           // get next sector to write
	MOVLW       1
	ADDWF       USB_MSD_Library_NA_Msd_Sector+0, 1 
	MOVLW       0
	ADDWFC      USB_MSD_Library_NA_Msd_Sector+1, 1 
	ADDWFC      USB_MSD_Library_NA_Msd_Sector+2, 1 
	ADDWFC      USB_MSD_Library_NA_Msd_Sector+3, 1 
;USB_MSD_Library_NA.mpas,575 :: 		end;
L_USB_MSD_Library_NA_Msd_WriteHandler36:
;USB_MSD_Library_NA.mpas,578 :: 		if Msd_NrSectors = 0
	MOVLW       0
	XORWF       USB_MSD_Library_NA_Msd_NrSectors+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler176
	MOVLW       0
	XORWF       USB_MSD_Library_NA_Msd_NrSectors+0, 0 
L_USB_MSD_Library_NA_Msd_WriteHandler176:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler56
;USB_MSD_Library_NA.mpas,579 :: 		then UsbMsdSendCsw                                             // done, send CSW right away
	CALL        USB_MSD_Library_NA_UsbMsdSendCsw+0, 0
	GOTO        L_USB_MSD_Library_NA_Msd_WriteHandler57
;USB_MSD_Library_NA.mpas,580 :: 		else Msd_ReceivePacket;                            // arm EP4 out for reception
L_USB_MSD_Library_NA_Msd_WriteHandler56:
	CALL        USB_MSD_Library_NA_Msd_ReceivePacket+0, 0
L_USB_MSD_Library_NA_Msd_WriteHandler57:
;USB_MSD_Library_NA.mpas,581 :: 		end;
L_USB_MSD_Library_NA_Msd_WriteHandler33:
;USB_MSD_Library_NA.mpas,582 :: 		end;
L_end_Msd_WriteHandler:
	RETURN      0
; end of USB_MSD_Library_NA_Msd_WriteHandler

USB_MSD_Library_NA_Msd_ReadHandler:

;USB_MSD_Library_NA.mpas,590 :: 		begin
;USB_MSD_Library_NA.mpas,592 :: 		if Msd_NrSectors > 0 then
	MOVLW       0
	MOVWF       R0 
	MOVF        USB_MSD_Library_NA_Msd_NrSectors+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler178
	MOVF        USB_MSD_Library_NA_Msd_NrSectors+0, 0 
	SUBLW       0
L_USB_MSD_Library_NA_Msd_ReadHandler178:
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler60
;USB_MSD_Library_NA.mpas,596 :: 		if Msd_SectorChunk = 0 then
	MOVF        USB_MSD_Library_NA_Msd_SectorChunk+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler63
;USB_MSD_Library_NA.mpas,598 :: 		if MSD_SDMMC_RetryAttempt = 0 then                           // no persistent error condition yet
	MOVF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler66
;USB_MSD_Library_NA.mpas,600 :: 		repeat
L_USB_MSD_Library_NA_Msd_ReadHandler68:
;USB_MSD_Library_NA.mpas,601 :: 		mmc_Result := Mmc_Read_Sector(Msd_Sector, MSD_buffer);  // read from card
	MOVF        USB_MSD_Library_NA_Msd_Sector+0, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+0 
	MOVF        USB_MSD_Library_NA_Msd_Sector+1, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+1 
	MOVF        USB_MSD_Library_NA_Msd_Sector+2, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+2 
	MOVF        USB_MSD_Library_NA_Msd_Sector+3, 0 
	MOVWF       FARG_Mmc_Read_Sector_sector+3 
	MOVLW       USB_MSD_Library_NA_MSD_buffer+0
	MOVWF       FARG_Mmc_Read_Sector_dbuff+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_MSD_buffer+0)
	MOVWF       FARG_Mmc_Read_Sector_dbuff+1 
	CALL        _Mmc_Read_Sector+0, 0
	MOVF        R0, 0 
	MOVWF       Msd_ReadHandler_Mmc_Result+0 
;USB_MSD_Library_NA.mpas,602 :: 		if mmc_Result > 0 then                                     // read error
	MOVF        R0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler74
;USB_MSD_Library_NA.mpas,604 :: 		inc(MSD_SDMMC_RetryAttempt);
	INCF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 1 
;USB_MSD_Library_NA.mpas,605 :: 		if MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES then
	MOVF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler77
;USB_MSD_Library_NA.mpas,607 :: 		Msd_Csw.Status             := USB_MSD_STATUS_FAILED;
	MOVLW       1
	MOVWF       USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,608 :: 		Msd_SenseData.Sensekey_etc := USB_MSD_S_MEDIUM_ERROR;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_Msd_SenseData+2 
;USB_MSD_Library_NA.mpas,609 :: 		Msd_SenseData.ASC          := USB_MSD_ASC_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+12 
;USB_MSD_Library_NA.mpas,610 :: 		Msd_SenseData.ASCQ         := USB_MSD_ASCQ_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+13 
;USB_MSD_Library_NA.mpas,611 :: 		end;
L_USB_MSD_Library_NA_Msd_ReadHandler77:
;USB_MSD_Library_NA.mpas,612 :: 		end;
L_USB_MSD_Library_NA_Msd_ReadHandler74:
;USB_MSD_Library_NA.mpas,613 :: 		until (mmc_Result = 0) or (MSD_SDMMC_RetryAttempt = MSD_MAX_RETRIES);
	MOVF        Msd_ReadHandler_Mmc_Result+0, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0, 0 
	XORLW       100
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler71
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler68
L_USB_MSD_Library_NA_Msd_ReadHandler71:
;USB_MSD_Library_NA.mpas,614 :: 		if mmc_Result = 0 then MSD_SDMMC_RetryAttempt := 0;
	MOVF        Msd_ReadHandler_Mmc_Result+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler80
	CLRF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0 
L_USB_MSD_Library_NA_Msd_ReadHandler80:
;USB_MSD_Library_NA.mpas,615 :: 		end;
L_USB_MSD_Library_NA_Msd_ReadHandler66:
;USB_MSD_Library_NA.mpas,616 :: 		end;
L_USB_MSD_Library_NA_Msd_ReadHandler63:
;USB_MSD_Library_NA.mpas,618 :: 		MemCpy__(@BuffEP4IN, @MSD_Buffer[Msd_SectorChunk * 64], 64);              // send a chunk of 64 bytes to the host
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       6
	MOVWF       R2 
	MOVF        USB_MSD_Library_NA_Msd_SectorChunk+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L_USB_MSD_Library_NA_Msd_ReadHandler179:
	BZ          L_USB_MSD_Library_NA_Msd_ReadHandler180
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler179
L_USB_MSD_Library_NA_Msd_ReadHandler180:
	MOVLW       USB_MSD_Library_NA_MSD_buffer+0
	ADDWF       R0, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_MSD_buffer+0)
	ADDWFC      R1, 0 
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       64
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_MSD_Library_NA.mpas,626 :: 		Msd_SendPacket(64);
	MOVLW       64
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,633 :: 		inc(Msd_SectorChunk);                                                   // next chunk of 64 bytes
	INCF        USB_MSD_Library_NA_Msd_SectorChunk+0, 1 
;USB_MSD_Library_NA.mpas,634 :: 		if Msd_SectorChunk = 8 then                                             // last Chunk of a sector sent to the host
	MOVF        USB_MSD_Library_NA_Msd_SectorChunk+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler83
;USB_MSD_Library_NA.mpas,636 :: 		Msd_SectorChunk := 0;                                                 // next Chunk is zero
	CLRF        USB_MSD_Library_NA_Msd_SectorChunk+0 
;USB_MSD_Library_NA.mpas,637 :: 		dec(Msd_NrSectors);                                                   // one sector less to read
	MOVLW       1
	SUBWF       USB_MSD_Library_NA_Msd_NrSectors+0, 1 
	MOVLW       0
	SUBWFB      USB_MSD_Library_NA_Msd_NrSectors+1, 1 
;USB_MSD_Library_NA.mpas,638 :: 		inc(Msd_Sector);                                                      // next sector to read
	MOVLW       1
	ADDWF       USB_MSD_Library_NA_Msd_Sector+0, 1 
	MOVLW       0
	ADDWFC      USB_MSD_Library_NA_Msd_Sector+1, 1 
	ADDWFC      USB_MSD_Library_NA_Msd_Sector+2, 1 
	ADDWFC      USB_MSD_Library_NA_Msd_Sector+3, 1 
;USB_MSD_Library_NA.mpas,639 :: 		end;
L_USB_MSD_Library_NA_Msd_ReadHandler83:
;USB_MSD_Library_NA.mpas,641 :: 		if Msd_NrSectors = 0 then Msd_State := USB_MSD_SEND_CSW;                // done, wait for the next "TokenIn" to send the CSW
	MOVLW       0
	XORWF       USB_MSD_Library_NA_Msd_NrSectors+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler181
	MOVLW       0
	XORWF       USB_MSD_Library_NA_Msd_NrSectors+0, 0 
L_USB_MSD_Library_NA_Msd_ReadHandler181:
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_Msd_ReadHandler86
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
L_USB_MSD_Library_NA_Msd_ReadHandler86:
;USB_MSD_Library_NA.mpas,642 :: 		end;
L_USB_MSD_Library_NA_Msd_ReadHandler60:
;USB_MSD_Library_NA.mpas,643 :: 		end;
L_end_Msd_ReadHandler:
	RETURN      0
; end of USB_MSD_Library_NA_Msd_ReadHandler

USB_MSD_Library_NA_MsdProcessCommand:

;USB_MSD_Library_NA.mpas,650 :: 		begin
;USB_MSD_Library_NA.mpas,651 :: 		if Msd_Command = USB_MSD_COMMAND_IDLE
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand90
;USB_MSD_Library_NA.mpas,652 :: 		then Msd_Command := Command; // get new command
	MOVF        FARG_MsdProcessCommand_Command+0, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
L_USB_MSD_Library_NA_MsdProcessCommand90:
;USB_MSD_Library_NA.mpas,660 :: 		USB_MSD_COMMAND_IDLE: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand95
;USB_MSD_Library_NA.mpas,665 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand95:
;USB_MSD_Library_NA.mpas,667 :: 		USB_MSD_INQUIRY: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       18
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand98
;USB_MSD_Library_NA.mpas,674 :: 		MemCpyC__(^byte(@BuffEP4IN), Dword(@inq_resp), sizeOf(T_Usb_Msd_Inquiry_Response));
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_memCpyC___p1+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_memCpyC___p1+1 
	MOVLW       USB_MSD_Library_NA_inq_resp+0
	MOVWF       R0 
	MOVLW       hi_addr(USB_MSD_Library_NA_inq_resp+0)
	MOVWF       R1 
	MOVLW       higher_addr(USB_MSD_Library_NA_inq_resp+0)
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	MOVF        R0, 0 
	MOVWF       FARG_memCpyC___p2+0 
	MOVF        R1, 0 
	MOVWF       FARG_memCpyC___p2+1 
	MOVF        R2, 0 
	MOVWF       FARG_memCpyC___p2+2 
	MOVLW       36
	MOVWF       FARG_memCpyC___N+0 
	MOVLW       0
	MOVWF       FARG_memCpyC___N+1 
	CALL        _memCpyC__+0, 0
;USB_MSD_Library_NA.mpas,676 :: 		Msd_Csw.Status := USB_MSD_STATUS_OK;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,677 :: 		Msd_SendPacket(sizeOf(T_Usb_Msd_Inquiry_Response));
	MOVLW       36
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,678 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,679 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,680 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand98:
;USB_MSD_Library_NA.mpas,682 :: 		USB_MSD_READ_CAPACITY: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       37
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand101
;USB_MSD_Library_NA.mpas,684 :: 		SectorSize := USB_MSD_BLOCKLEN;  // 512 bytes per sector
	MOVLW       0
	MOVWF       MsdProcessCommand_SectorSize+0 
	MOVLW       2
	MOVWF       MsdProcessCommand_SectorSize+1 
	MOVLW       0
	MOVWF       MsdProcessCommand_SectorSize+2 
	MOVWF       MsdProcessCommand_SectorSize+3 
;USB_MSD_Library_NA.mpas,686 :: 		Capacity   := (SDMMC_CardSize shl 9); // # of sectors
	CALL        _SDMMC_CardSize+0, 0
	MOVLW       9
	MOVWF       R4 
	MOVF        R0, 0 
	MOVWF       MsdProcessCommand_Capacity+0 
	MOVF        R1, 0 
	MOVWF       MsdProcessCommand_Capacity+1 
	MOVF        R2, 0 
	MOVWF       MsdProcessCommand_Capacity+2 
	MOVF        R3, 0 
	MOVWF       MsdProcessCommand_Capacity+3 
	MOVF        R4, 0 
L_USB_MSD_Library_NA_MsdProcessCommand183:
	BZ          L_USB_MSD_Library_NA_MsdProcessCommand184
	RLCF        MsdProcessCommand_Capacity+0, 1 
	BCF         MsdProcessCommand_Capacity+0, 0 
	RLCF        MsdProcessCommand_Capacity+1, 1 
	RLCF        MsdProcessCommand_Capacity+2, 1 
	RLCF        MsdProcessCommand_Capacity+3, 1 
	ADDLW       255
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand183
L_USB_MSD_Library_NA_MsdProcessCommand184:
;USB_MSD_Library_NA.mpas,687 :: 		Capacity   := dec(Capacity);            // max sectornumber
	MOVLW       1
	SUBWF       MsdProcessCommand_Capacity+0, 1 
	MOVLW       0
	SUBWFB      MsdProcessCommand_Capacity+1, 1 
	SUBWFB      MsdProcessCommand_Capacity+2, 1 
	SUBWFB      MsdProcessCommand_Capacity+3, 1 
;USB_MSD_Library_NA.mpas,690 :: 		BuffEP4IN[0] := Highest(Capacity);
	MOVF        MsdProcessCommand_Capacity+3, 0 
	MOVWF       1856 
;USB_MSD_Library_NA.mpas,691 :: 		BuffEP4IN[1] := Higher(Capacity);
	MOVF        MsdProcessCommand_Capacity+2, 0 
	MOVWF       1857 
;USB_MSD_Library_NA.mpas,692 :: 		BuffEP4IN[2] := Hi(Capacity);
	MOVF        MsdProcessCommand_Capacity+1, 0 
	MOVWF       1858 
;USB_MSD_Library_NA.mpas,693 :: 		BuffEP4IN[3] := Lo(Capacity);
	MOVF        MsdProcessCommand_Capacity+0, 0 
	MOVWF       1859 
;USB_MSD_Library_NA.mpas,695 :: 		BuffEP4IN[4] := Highest(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+3, 0 
	MOVWF       1860 
;USB_MSD_Library_NA.mpas,696 :: 		BuffEP4IN[5] := Higher(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+2, 0 
	MOVWF       1861 
;USB_MSD_Library_NA.mpas,697 :: 		BuffEP4IN[6] := Hi(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+1, 0 
	MOVWF       1862 
;USB_MSD_Library_NA.mpas,698 :: 		BuffEP4IN[7] := Lo(SectorSize);
	MOVF        MsdProcessCommand_SectorSize+0, 0 
	MOVWF       1863 
;USB_MSD_Library_NA.mpas,705 :: 		Msd_Csw.Status := USB_MSD_STATUS_OK;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,706 :: 		Msd_Sendpacket(8);
	MOVLW       8
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,707 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,708 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,709 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand101:
;USB_MSD_Library_NA.mpas,711 :: 		USB_MSD_READ_10: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       40
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand104
;USB_MSD_Library_NA.mpas,716 :: 		Highest(Msd_Sector) := Msd_Cbw.CommandBlock[2];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+17, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+3 
;USB_MSD_Library_NA.mpas,717 :: 		Higher(Msd_Sector)  := Msd_Cbw.CommandBlock[3];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+18, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+2 
;USB_MSD_Library_NA.mpas,718 :: 		Hi(Msd_Sector)      := Msd_Cbw.CommandBlock[4];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+19, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+1 
;USB_MSD_Library_NA.mpas,719 :: 		Lo(Msd_Sector)      := Msd_Cbw.CommandBlock[5];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+20, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+0 
;USB_MSD_Library_NA.mpas,721 :: 		Hi(Msd_NrSectors)   := Msd_Cbw.CommandBlock[7];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+22, 0 
	MOVWF       USB_MSD_Library_NA_Msd_NrSectors+1 
;USB_MSD_Library_NA.mpas,722 :: 		Lo(Msd_NrSectors)   := Msd_Cbw.CommandBlock[8];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+23, 0 
	MOVWF       USB_MSD_Library_NA_Msd_NrSectors+0 
;USB_MSD_Library_NA.mpas,736 :: 		Msd_SectorChunk := 0;
	CLRF        USB_MSD_Library_NA_Msd_SectorChunk+0 
;USB_MSD_Library_NA.mpas,739 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,740 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,742 :: 		MSD_SDMMC_RetryAttempt := 0;
	CLRF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0 
;USB_MSD_Library_NA.mpas,743 :: 		MSD_State := USB_MSD_DATA_IN;
	MOVLW       1
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,744 :: 		Msd_ReadHandler;              // read first chunk of data
	CALL        USB_MSD_Library_NA_Msd_ReadHandler+0, 0
;USB_MSD_Library_NA.mpas,746 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand104:
;USB_MSD_Library_NA.mpas,748 :: 		USB_MSD_WRITE_10: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       42
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand107
;USB_MSD_Library_NA.mpas,753 :: 		Highest(Msd_Sector) := Msd_Cbw.CommandBlock[2];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+17, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+3 
;USB_MSD_Library_NA.mpas,754 :: 		Higher(Msd_Sector)  := Msd_Cbw.CommandBlock[3];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+18, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+2 
;USB_MSD_Library_NA.mpas,755 :: 		Hi(Msd_Sector)      := Msd_Cbw.CommandBlock[4];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+19, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+1 
;USB_MSD_Library_NA.mpas,756 :: 		Lo(Msd_Sector)      := Msd_Cbw.CommandBlock[5];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+20, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Sector+0 
;USB_MSD_Library_NA.mpas,758 :: 		Hi(Msd_NrSectors)   := Msd_Cbw.CommandBlock[7];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+22, 0 
	MOVWF       USB_MSD_Library_NA_Msd_NrSectors+1 
;USB_MSD_Library_NA.mpas,759 :: 		Lo(Msd_NrSectors)   := Msd_Cbw.CommandBlock[8];
	MOVF        USB_MSD_Library_NA_Msd_Cbw+23, 0 
	MOVWF       USB_MSD_Library_NA_Msd_NrSectors+0 
;USB_MSD_Library_NA.mpas,761 :: 		Msd_SectorChunk     := 0;
	CLRF        USB_MSD_Library_NA_Msd_SectorChunk+0 
;USB_MSD_Library_NA.mpas,775 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,776 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,778 :: 		MSD_SDMMC_RetryAttempt := 0;
	CLRF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0 
;USB_MSD_Library_NA.mpas,779 :: 		MSD_State              := USB_MSD_DATA_OUT;
	MOVLW       2
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,781 :: 		Msd_ReceivePacket; // arm EP4 out for packet reception
	CALL        USB_MSD_Library_NA_Msd_ReceivePacket+0, 0
;USB_MSD_Library_NA.mpas,784 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand107:
;USB_MSD_Library_NA.mpas,786 :: 		USB_MSD_REQUEST_SENSE: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand110
;USB_MSD_Library_NA.mpas,791 :: 		MemCpy__(^byte(@BuffEP4IN), ^byte(@Msd_SenseData), SizeOf(Msd_SenseData));
	MOVLW       _BuffEP4IN+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(_BuffEP4IN+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVLW       USB_MSD_Library_NA_Msd_SenseData+0
	MOVWF       FARG_MemCpy___From+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_Msd_SenseData+0)
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       18
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_MSD_Library_NA.mpas,792 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,793 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,795 :: 		Msd_Sendpacket(SizeOf(Msd_SenseData));
	MOVLW       18
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,796 :: 		Msd_Command    := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,797 :: 		Msd_State      := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,798 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand110:
;USB_MSD_Library_NA.mpas,800 :: 		USB_MSD_MODE_SENSE: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       26
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand113
;USB_MSD_Library_NA.mpas,805 :: 		BuffEP4IN[0] := 2;
	MOVLW       2
	MOVWF       1856 
;USB_MSD_Library_NA.mpas,806 :: 		BuffEP4IN[1] := 0;
	CLRF        1857 
;USB_MSD_Library_NA.mpas,807 :: 		BuffEP4IN[2] := 0;
	CLRF        1858 
;USB_MSD_Library_NA.mpas,808 :: 		BuffEP4IN[3] := 0;
	CLRF        1859 
;USB_MSD_Library_NA.mpas,810 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,811 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,813 :: 		Msd_Sendpacket(4);
	MOVLW       4
	MOVWF       FARG_Msd_SendPacket_Len+0 
	CALL        USB_MSD_Library_NA_Msd_SendPacket+0, 0
;USB_MSD_Library_NA.mpas,814 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,815 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,816 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand113:
;USB_MSD_Library_NA.mpas,818 :: 		USB_MSD_PREVENT_ALLOW_MEDIUM_REMOVAL: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       30
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand116
;USB_MSD_Library_NA.mpas,824 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,825 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,826 :: 		Msd_Command         := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,827 :: 		Msd_State           := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,828 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_NA_UsbMsdSendCsw+0, 0
;USB_MSD_Library_NA.mpas,829 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand116:
;USB_MSD_Library_NA.mpas,831 :: 		USB_MSD_TEST_UNIT_READY: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand119
;USB_MSD_Library_NA.mpas,836 :: 		Msd_ResetSenseData;
	CALL        USB_MSD_Library_NA_Msd_ResetSenseData+0, 0
;USB_MSD_Library_NA.mpas,837 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,838 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,839 :: 		Msd_Command         := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,840 :: 		Msd_State           := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,841 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_NA_UsbMsdSendCsw+0, 0
;USB_MSD_Library_NA.mpas,842 :: 		end;
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand119:
;USB_MSD_Library_NA.mpas,845 :: 		USB_MSD_STOP_START: //
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       47
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand122
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand120
L_USB_MSD_Library_NA_MsdProcessCommand122:
	MOVF        USB_MSD_Library_NA_Msd_Command+0, 0 
	XORLW       27
	BTFSS       STATUS+0, 2 
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand123
L_USB_MSD_Library_NA_MsdProcessCommand120:
;USB_MSD_Library_NA.mpas,850 :: 		Msd_Csw.Status      := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,851 :: 		Msd_Csw.DataResidue := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,852 :: 		Msd_Command         := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,853 :: 		Msd_State           := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,854 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_NA_UsbMsdSendCsw+0, 0
;USB_MSD_Library_NA.mpas,857 :: 		else // Other and USB_MSD_COMMAND_ERROR: //
	GOTO        L_USB_MSD_Library_NA_MsdProcessCommand92
L_USB_MSD_Library_NA_MsdProcessCommand123:
;USB_MSD_Library_NA.mpas,863 :: 		Msd_ResetSenseData;
	CALL        USB_MSD_Library_NA_Msd_ResetSenseData+0, 0
;USB_MSD_Library_NA.mpas,864 :: 		Msd_SenseData.SenseKey_etc := USB_MSD_S_ILLEGAL_REQUEST;
	MOVLW       5
	MOVWF       USB_MSD_Library_NA_Msd_SenseData+2 
;USB_MSD_Library_NA.mpas,865 :: 		Msd_SenseData.asc          := USB_MSD_ASC_INVALID_COMMAND_OPCODE;
	MOVLW       32
	MOVWF       USB_MSD_Library_NA_Msd_SenseData+12 
;USB_MSD_Library_NA.mpas,866 :: 		Msd_SenseData.ascq         := USB_MSD_ASCQ_INVALID_COMMAND_OPCODE;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+13 
;USB_MSD_Library_NA.mpas,867 :: 		Msd_Csw.status             := USB_MSD_STATUS_FAILED;
	MOVLW       1
	MOVWF       USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,868 :: 		Msd_Csw.DataResidue        := 0;
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,870 :: 		Msd_SendBulkZeroLenPacket;
	CALL        USB_MSD_Library_NA_Msd_SendBulkZeroLenPacket+0, 0
;USB_MSD_Library_NA.mpas,871 :: 		Msd_Command := USB_MSD_COMMAND_IDLE;
	MOVLW       255
	MOVWF       USB_MSD_Library_NA_Msd_Command+0 
;USB_MSD_Library_NA.mpas,872 :: 		Msd_State   := USB_MSD_SEND_CSW;
	MOVLW       3
	MOVWF       USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,873 :: 		end;
L_USB_MSD_Library_NA_MsdProcessCommand92:
;USB_MSD_Library_NA.mpas,876 :: 		end;
L_end_MsdProcessCommand:
	RETURN      0
; end of USB_MSD_Library_NA_MsdProcessCommand

_ClassTokenOutMSD:

;USB_MSD_Library_NA.mpas,879 :: 		begin
;USB_MSD_Library_NA.mpas,880 :: 		Result := false;
	CLRF        ClassTokenOutMSD_local_result+0 
;USB_MSD_Library_NA.mpas,889 :: 		4: // endpoint 4 out
	MOVF        FARG_ClassTokenOutMSD_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD128
;USB_MSD_Library_NA.mpas,891 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenOutMSD_local_result+0 
;USB_MSD_Library_NA.mpas,895 :: 		USB_MSD_IDLE: //
	MOVF        USB_MSD_Library_NA_MSD_State+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD132
;USB_MSD_Library_NA.mpas,897 :: 		if BDEP4OUTCnt = USB_Msd_Cbw_SIZE then // possibly a CBW has arrived
	MOVF        _BDEP4OUTCnt+0, 0 
	XORLW       31
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD134
;USB_MSD_Library_NA.mpas,900 :: 		MemCpy__(^byte(@Msd_Cbw), BDEP4OUTAdr, USB_Msd_Cbw_SIZE);
	MOVLW       USB_MSD_Library_NA_Msd_Cbw+0
	MOVWF       FARG_MemCpy___Towards+0 
	MOVLW       hi_addr(USB_MSD_Library_NA_Msd_Cbw+0)
	MOVWF       FARG_MemCpy___Towards+1 
	MOVF        _BDEP4OUTAdr+0, 0 
	MOVWF       FARG_MemCpy___From+0 
	MOVF        _BDEP4OUTAdr+1, 0 
	MOVWF       FARG_MemCpy___From+1 
	MOVLW       31
	MOVWF       FARG_MemCpy___n+0 
	MOVLW       0
	MOVWF       FARG_MemCpy___n+1 
	CALL        _MemCpy__+0, 0
;USB_MSD_Library_NA.mpas,908 :: 		if (Msd_Cbw.Signature = $43425355) then
	MOVF        USB_MSD_Library_NA_Msd_Cbw+3, 0 
	XORLW       67
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD186
	MOVF        USB_MSD_Library_NA_Msd_Cbw+2, 0 
	XORLW       66
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD186
	MOVF        USB_MSD_Library_NA_Msd_Cbw+1, 0 
	XORLW       83
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD186
	MOVF        USB_MSD_Library_NA_Msd_Cbw+0, 0 
	XORLW       85
L__ClassTokenOutMSD186:
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD137
;USB_MSD_Library_NA.mpas,911 :: 		if (Msd_Cbw.Lun = 0) and
	MOVF        USB_MSD_Library_NA_Msd_Cbw+13, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
;USB_MSD_Library_NA.mpas,912 :: 		(Msd_Cbw.CbLen <= 16) and
	MOVF        USB_MSD_Library_NA_Msd_Cbw+14, 0 
	SUBLW       16
	MOVLW       0
	BTFSC       STATUS+0, 0 
	MOVLW       255
	MOVWF       R0 
	MOVF        R0, 0 
	ANDWF       R1, 1 
;USB_MSD_Library_NA.mpas,913 :: 		(Msd_Cbw.CbLen >= 1) and
	MOVLW       1
	SUBWF       USB_MSD_Library_NA_Msd_Cbw+14, 0 
	MOVLW       0
	BTFSC       STATUS+0, 0 
	MOVLW       255
	MOVWF       R0 
	MOVF        R0, 0 
	ANDWF       R1, 0 
	MOVWF       R2 
;USB_MSD_Library_NA.mpas,914 :: 		((Msd_Cbw.Flags = 0) or (Msd_Cbw.Flags = $80)) then
	MOVF        USB_MSD_Library_NA_Msd_Cbw+12, 0 
	XORLW       0
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R1 
	MOVF        USB_MSD_Library_NA_Msd_Cbw+12, 0 
	XORLW       128
	MOVLW       255
	BTFSS       STATUS+0, 2 
	MOVLW       0
	MOVWF       R0 
	MOVF        R1, 0 
	IORWF       R0, 1 
	MOVF        R2, 0 
	ANDWF       R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD140
;USB_MSD_Library_NA.mpas,923 :: 		Msd_Csw.Tag         := Msd_Cbw.Tag; // copy tag to CSW
	MOVF        USB_MSD_Library_NA_Msd_Cbw+4, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Csw+4 
	MOVF        USB_MSD_Library_NA_Msd_Cbw+5, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Csw+5 
	MOVF        USB_MSD_Library_NA_Msd_Cbw+6, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Csw+6 
	MOVF        USB_MSD_Library_NA_Msd_Cbw+7, 0 
	MOVWF       USB_MSD_Library_NA_Msd_Csw+7 
;USB_MSD_Library_NA.mpas,924 :: 		Msd_Csw.Signature   := $53425355;  // Give CSW its signature
	MOVLW       85
	MOVWF       USB_MSD_Library_NA_Msd_Csw+0 
	MOVLW       83
	MOVWF       USB_MSD_Library_NA_Msd_Csw+1 
	MOVLW       66
	MOVWF       USB_MSD_Library_NA_Msd_Csw+2 
	MOVLW       83
	MOVWF       USB_MSD_Library_NA_Msd_Csw+3 
;USB_MSD_Library_NA.mpas,925 :: 		Msd_Csw.DataResidue := 0;          // default
	CLRF        USB_MSD_Library_NA_Msd_Csw+8 
	CLRF        USB_MSD_Library_NA_Msd_Csw+9 
	CLRF        USB_MSD_Library_NA_Msd_Csw+10 
	CLRF        USB_MSD_Library_NA_Msd_Csw+11 
;USB_MSD_Library_NA.mpas,926 :: 		Msd_Csw.Status      := 0;          // default
	CLRF        USB_MSD_Library_NA_Msd_Csw+12 
;USB_MSD_Library_NA.mpas,928 :: 		MSD_SDMMC_RetryAttempt    := 0;
	CLRF        USB_MSD_Library_NA_MSD_SDMMC_RetryAttempt+0 
;USB_MSD_Library_NA.mpas,930 :: 		if Msd_Cbw.CommandBlock[0] <> USB_MSD_REQUEST_SENSE then
	MOVF        USB_MSD_Library_NA_Msd_Cbw+15, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD143
;USB_MSD_Library_NA.mpas,932 :: 		Msd_SenseData.SenseKey_etc := USB_MSD_S_NO_SENSE;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+2 
;USB_MSD_Library_NA.mpas,933 :: 		Msd_SenseData.ASC          := USB_MSD_ASC_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+12 
;USB_MSD_Library_NA.mpas,934 :: 		Msd_SenseData.ASCQ         := USB_MSD_ASCQ_NO_ADDITIONAL_SENSE_INFORMATION;
	CLRF        USB_MSD_Library_NA_Msd_SenseData+13 
;USB_MSD_Library_NA.mpas,935 :: 		end;
L__ClassTokenOutMSD143:
;USB_MSD_Library_NA.mpas,937 :: 		MsdProcessCommand(Msd_Cbw.CommandBlock[0]); // execute command
	MOVF        USB_MSD_Library_NA_Msd_Cbw+15, 0 
	MOVWF       FARG_MsdProcessCommand_Command+0 
	CALL        USB_MSD_Library_NA_MsdProcessCommand+0, 0
;USB_MSD_Library_NA.mpas,939 :: 		end;
L__ClassTokenOutMSD140:
;USB_MSD_Library_NA.mpas,940 :: 		end;
L__ClassTokenOutMSD137:
;USB_MSD_Library_NA.mpas,941 :: 		end;
L__ClassTokenOutMSD134:
;USB_MSD_Library_NA.mpas,942 :: 		end;
	GOTO        L__ClassTokenOutMSD129
L__ClassTokenOutMSD132:
;USB_MSD_Library_NA.mpas,944 :: 		USB_MSD_DATA_OUT: //
	MOVF        USB_MSD_Library_NA_MSD_State+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenOutMSD147
;USB_MSD_Library_NA.mpas,949 :: 		Msd_WriteHandler;
	CALL        USB_MSD_Library_NA_Msd_WriteHandler+0, 0
;USB_MSD_Library_NA.mpas,952 :: 		else
	GOTO        L__ClassTokenOutMSD129
L__ClassTokenOutMSD147:
;USB_MSD_Library_NA.mpas,958 :: 		Msd_State := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,959 :: 		end;
L__ClassTokenOutMSD129:
;USB_MSD_Library_NA.mpas,963 :: 		end;
	GOTO        L__ClassTokenOutMSD125
L__ClassTokenOutMSD128:
L__ClassTokenOutMSD125:
;USB_MSD_Library_NA.mpas,966 :: 		end;
	MOVF        ClassTokenOutMSD_local_result+0, 0 
	MOVWF       R0 
L_end_ClassTokenOutMSD:
	RETURN      0
; end of _ClassTokenOutMSD

_ClassTokenInMSD:

;USB_MSD_Library_NA.mpas,969 :: 		begin
;USB_MSD_Library_NA.mpas,970 :: 		Result := false;
	CLRF        ClassTokenInMSD_local_result+0 
;USB_MSD_Library_NA.mpas,982 :: 		4: // endpoint 4 in
	MOVF        FARG_ClassTokenInMSD_Ep+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInMSD152
;USB_MSD_Library_NA.mpas,984 :: 		Result := true;
	MOVLW       255
	MOVWF       ClassTokenInMSD_local_result+0 
;USB_MSD_Library_NA.mpas,987 :: 		USB_MSD_IDLE: //
	MOVF        USB_MSD_Library_NA_MSD_State+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInMSD156
;USB_MSD_Library_NA.mpas,992 :: 		end;
	GOTO        L__ClassTokenInMSD153
L__ClassTokenInMSD156:
;USB_MSD_Library_NA.mpas,994 :: 		USB_MSD_DATA_IN: //
	MOVF        USB_MSD_Library_NA_MSD_State+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInMSD159
;USB_MSD_Library_NA.mpas,999 :: 		Msd_ReadHandler;
	CALL        USB_MSD_Library_NA_Msd_ReadHandler+0, 0
;USB_MSD_Library_NA.mpas,1000 :: 		end;
	GOTO        L__ClassTokenInMSD153
L__ClassTokenInMSD159:
;USB_MSD_Library_NA.mpas,1002 :: 		USB_MSD_SEND_CSW: //
	MOVF        USB_MSD_Library_NA_MSD_State+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L__ClassTokenInMSD162
;USB_MSD_Library_NA.mpas,1007 :: 		UsbMsdSendCsw;
	CALL        USB_MSD_Library_NA_UsbMsdSendCsw+0, 0
;USB_MSD_Library_NA.mpas,1010 :: 		else
	GOTO        L__ClassTokenInMSD153
L__ClassTokenInMSD162:
;USB_MSD_Library_NA.mpas,1015 :: 		Msd_State := USB_MSD_IDLE;
	CLRF        USB_MSD_Library_NA_MSD_State+0 
;USB_MSD_Library_NA.mpas,1016 :: 		end;
L__ClassTokenInMSD153:
;USB_MSD_Library_NA.mpas,1019 :: 		end;
	GOTO        L__ClassTokenInMSD149
L__ClassTokenInMSD152:
L__ClassTokenInMSD149:
;USB_MSD_Library_NA.mpas,1021 :: 		end;
	MOVF        ClassTokenInMSD_local_result+0, 0 
	MOVWF       R0 
L_end_ClassTokenInMSD:
	RETURN      0
; end of _ClassTokenInMSD

_GetClassSpecificDescriptorMSD:

;USB_MSD_Library_NA.mpas,1024 :: 		begin
;USB_MSD_Library_NA.mpas,1025 :: 		Result := false;
	CLRF        R1 
;USB_MSD_Library_NA.mpas,1026 :: 		end;
	MOVF        R1, 0 
	MOVWF       R0 
L_end_GetClassSpecificDescriptorMSD:
	RETURN      0
; end of _GetClassSpecificDescriptorMSD
